// Compiled shader for all platforms, uncompressed size: 225.9KB

Shader "Sky/AtmosphereGhoss" {
SubShader { 
 Tags { "QUEUE"="Transparent-5" "IgnoreProjector"="True" "RenderType"="Transparent" }


 // Stats for Vertex shader:
 //       d3d11 : 15 math
 //        d3d9 : 20 math, 1 branch
 // Stats for Fragment shader:
 //       d3d11 : 685 math, 1 texture, 14 branch
 //        d3d9 : 1013 math, 61 texture, 9 branch
 Pass {
  Tags { "QUEUE"="Transparent-5"  "IgnoreProjector"="True"  "RenderType"="Transparent" }
  ZWrite Off
  Cull Front
  Fog { Mode Off }
  Blend SrcAlpha OneMinusSrcAlpha
Program "vp" {
SubProgram "opengl " {
"!!GLSL
#ifdef VERTEX
uniform vec4 _ProjectionParams;


varying vec4 xlv_TEXCOORD0;
varying vec2 xlv_TEXCOORD1;
varying vec2 xlv_TEXCOORD2;
void main ()
{
  vec4 tmpvar_1;
  vec4 tmpvar_2;
  tmpvar_2 = (gl_ModelViewProjectionMatrix * gl_Vertex);
  vec4 o_3;
  vec4 tmpvar_4;
  tmpvar_4 = (tmpvar_2 * 0.5);
  vec2 tmpvar_5;
  tmpvar_5.x = tmpvar_4.x;
  tmpvar_5.y = (tmpvar_4.y * _ProjectionParams.x);
  o_3.xy = (tmpvar_5 + tmpvar_4.w);
  o_3.zw = tmpvar_2.zw;
  tmpvar_1.xyw = o_3.xyw;
  vec2 tmpvar_6;
  tmpvar_6 = (o_3.xy / tmpvar_2.w);
  tmpvar_1.z = -((gl_ModelViewMatrix * gl_Vertex).z);
  gl_Position = tmpvar_2;
  xlv_TEXCOORD0 = tmpvar_1;
  xlv_TEXCOORD1 = tmpvar_6;
  xlv_TEXCOORD2 = tmpvar_6;
}


#endif
#ifdef FRAGMENT
#extension GL_ARB_shader_texture_lod : enable
uniform sampler2D _Transmittance;
uniform sampler2D _Inscatter;
uniform sampler2D _Irradiance;
uniform float M_PI;
uniform float Rg;
uniform float Rt;
uniform float RES_R;
uniform float RES_MU;
uniform float RES_MU_S;
uniform float RES_NU;
uniform vec3 SUN_DIR;
uniform float SUN_INTENSITY;
uniform vec3 betaR;
uniform float mieG;
uniform mat4 _ViewProjInv;
uniform float _viewdirOffset;
uniform float _experimentalAtmoScale;
uniform float _global_alpha;
uniform float _Exposure;
uniform float _global_depth;
uniform float _Ocean_Sigma;
uniform float fakeOcean;
uniform float _fade;
uniform vec3 _Ocean_Color;
uniform vec3 _camPos;
uniform sampler2D _customDepthTexture;
uniform float _openglThreshold;
varying vec2 xlv_TEXCOORD2;
void main ()
{
  vec4 tmpvar_1;
  float visib_2;
  vec3 oceanColor_3;
  vec3 worldPos_4;
  vec4 tmpvar_5;
  tmpvar_5.w = 1.0;
  tmpvar_5.x = ((xlv_TEXCOORD2.x * 2.0) - 1.0);
  tmpvar_5.y = ((xlv_TEXCOORD2.y * 2.0) - 1.0);
  tmpvar_5.z = ((texture2D (_customDepthTexture, xlv_TEXCOORD2).x * 2.0) - 1.0);
  vec4 tmpvar_6;
  tmpvar_6 = (_ViewProjInv * tmpvar_5);
  vec3 tmpvar_7;
  tmpvar_7 = (tmpvar_6 / tmpvar_6.w).xyz;
  worldPos_4 = tmpvar_7;
  float tmpvar_8;
  vec3 tmpvar_9;
  tmpvar_9 = (tmpvar_7 - _camPos);
  float tmpvar_10;
  tmpvar_10 = dot (tmpvar_9, tmpvar_9);
  float tmpvar_11;
  tmpvar_11 = (2.0 * dot (tmpvar_9, _camPos));
  float tmpvar_12;
  tmpvar_12 = ((tmpvar_11 * tmpvar_11) - ((4.0 * tmpvar_10) * (dot (_camPos, _camPos) - (Rg * Rg))));
  if ((tmpvar_12 < 0.0)) {
    tmpvar_8 = -1.0;
  } else {
    tmpvar_8 = ((-(tmpvar_11) - sqrt(tmpvar_12)) / (2.0 * tmpvar_10));
  };
  bool tmpvar_13;
  tmpvar_13 = (tmpvar_8 > 0.0);
  bool tmpvar_14;
  tmpvar_14 = (sqrt(dot (tmpvar_7, tmpvar_7)) >= Rt);
  if ((!(tmpvar_13) && tmpvar_14)) {
    tmpvar_1 = vec4(0.0, 0.0, 0.0, 0.0);
  } else {
    vec3 tmpvar_15;
    tmpvar_15 = (_camPos + (tmpvar_8 * (tmpvar_7 - _camPos)));
    vec3 arg0_16;
    arg0_16 = (tmpvar_15 - _camPos);
    vec3 arg0_17;
    arg0_17 = (tmpvar_7 - _camPos);
    bool tmpvar_18;
    tmpvar_18 = (sqrt(dot (arg0_16, arg0_16)) < sqrt(dot (arg0_17, arg0_17)));
    oceanColor_3 = vec3(1.0, 1.0, 1.0);
    if ((tmpvar_13 && tmpvar_18)) {
      worldPos_4 = tmpvar_15;
      if ((fakeOcean == 1.0)) {
        vec3 tmpvar_19;
        tmpvar_19 = normalize(tmpvar_15);
        vec3 tmpvar_20;
        tmpvar_20 = (tmpvar_19 * max (sqrt(dot (tmpvar_15, tmpvar_15)), Rg));
        vec3 tmpvar_21;
        tmpvar_21 = normalize((tmpvar_20 - _camPos));
        vec3 worldP_22;
        worldP_22 = tmpvar_20;
        float r_23;
        float tmpvar_24;
        tmpvar_24 = sqrt(dot (tmpvar_20, tmpvar_20));
        r_23 = tmpvar_24;
        if ((tmpvar_24 < (0.9 * Rg))) {
          worldP_22.z = (tmpvar_20.z + Rg);
          r_23 = sqrt(dot (worldP_22, worldP_22));
        };
        vec3 tmpvar_25;
        tmpvar_25 = (worldP_22 / r_23);
        float tmpvar_26;
        tmpvar_26 = dot (tmpvar_25, SUN_DIR);
        float tmpvar_27;
        tmpvar_27 = sqrt((1.0 - ((Rg / r_23) * (Rg / r_23))));
        vec3 tmpvar_28;
        if ((tmpvar_26 < -(tmpvar_27))) {
          tmpvar_28 = vec3(0.0, 0.0, 0.0);
        } else {
          float y_over_x_29;
          y_over_x_29 = (((tmpvar_26 + 0.15) / 1.15) * 14.1014);
          float x_30;
          x_30 = (y_over_x_29 * inversesqrt(((y_over_x_29 * y_over_x_29) + 1.0)));
          vec4 tmpvar_31;
          tmpvar_31.zw = vec2(0.0, 0.0);
          tmpvar_31.x = ((sign(x_30) * (1.5708 - (sqrt((1.0 - abs(x_30))) * (1.5708 + (abs(x_30) * (-0.214602 + (abs(x_30) * (0.0865667 + (abs(x_30) * -0.0310296))))))))) / 1.5);
          tmpvar_31.y = sqrt(((r_23 - Rg) / (Rt - Rg)));
          tmpvar_28 = texture2DLod (_Transmittance, tmpvar_31.xy, 0.0).xyz;
        };
        vec3 tmpvar_32;
        tmpvar_32 = (tmpvar_28 * SUN_INTENSITY);
        vec2 tmpvar_33;
        tmpvar_33.x = ((tmpvar_26 + 0.2) / 1.2);
        tmpvar_33.y = ((r_23 - Rg) / (Rt - Rg));
        vec3 tmpvar_34;
        tmpvar_34 = (((2.0 * texture2DLod (_Irradiance, tmpvar_33, 0.0).xyz) * SUN_INTENSITY) * ((1.0 + tmpvar_25.z) * 0.5));
        vec3 V_35;
        V_35 = -(tmpvar_21);
        vec3 seaColor_36;
        seaColor_36 = (_Ocean_Color * 10.0);
        float tmpvar_37;
        tmpvar_37 = sqrt(_Ocean_Sigma);
        float tmpvar_38;
        tmpvar_38 = (pow ((1.0 - dot (V_35, tmpvar_19)), (5.0 * exp((-2.69 * tmpvar_37)))) / (1.0 + (22.7 * pow (tmpvar_37, 1.5))));
        vec3 tmpvar_39;
        tmpvar_39 = normalize((SUN_DIR + V_35));
        float tmpvar_40;
        tmpvar_40 = dot (tmpvar_39, tmpvar_19);
        float tmpvar_41;
        tmpvar_41 = (exp(((-2.0 * ((1.0 - (tmpvar_40 * tmpvar_40)) / _Ocean_Sigma)) / (1.0 + tmpvar_40))) / ((4.0 * M_PI) * _Ocean_Sigma));
        float tmpvar_42;
        tmpvar_42 = (1.0 - dot (V_35, tmpvar_39));
        float tmpvar_43;
        tmpvar_43 = (tmpvar_42 * tmpvar_42);
        float tmpvar_44;
        tmpvar_44 = (0.02 + (((0.98 * tmpvar_43) * tmpvar_43) * tmpvar_42));
        float tmpvar_45;
        tmpvar_45 = max (dot (SUN_DIR, tmpvar_19), 0.01);
        float tmpvar_46;
        tmpvar_46 = max (dot (V_35, tmpvar_19), 0.01);
        float tmpvar_47;
        if ((tmpvar_45 <= 0.0)) {
          tmpvar_47 = 0.0;
        } else {
          tmpvar_47 = max (((tmpvar_44 * tmpvar_41) * sqrt(abs((tmpvar_45 / tmpvar_46)))), 0.0);
        };
        oceanColor_3 = (((tmpvar_47 * tmpvar_32) + ((tmpvar_34 * tmpvar_38) / M_PI)) + ((((1.0 - tmpvar_38) * seaColor_36) * tmpvar_34) / M_PI));
      };
    };
    float tmpvar_48;
    tmpvar_48 = sqrt(dot (worldPos_4, worldPos_4));
    if ((tmpvar_48 < (Rg + _openglThreshold))) {
      worldPos_4 = ((Rg + _openglThreshold) * normalize(worldPos_4));
    };
    vec3 tmpvar_49;
    vec3 camera_50;
    camera_50 = _camPos;
    vec3 _point_51;
    _point_51 = worldPos_4;
    vec3 extinction_52;
    float mu_53;
    float rMu_54;
    float r_55;
    float d_56;
    vec3 viewdir_57;
    vec3 result_58;
    result_58 = vec3(0.0, 0.0, 0.0);
    extinction_52 = vec3(1.0, 1.0, 1.0);
    vec3 tmpvar_59;
    tmpvar_59 = (worldPos_4 - _camPos);
    float tmpvar_60;
    tmpvar_60 = sqrt(dot (tmpvar_59, tmpvar_59));
    d_56 = tmpvar_60;
    vec3 tmpvar_61;
    tmpvar_61 = (tmpvar_59 / tmpvar_60);
    viewdir_57.yz = tmpvar_61.yz;
    float tmpvar_62;
    tmpvar_62 = (Rg + ((Rt - Rg) * _experimentalAtmoScale));
    viewdir_57.x = (tmpvar_61.x + _viewdirOffset);
    vec3 tmpvar_63;
    tmpvar_63 = normalize(viewdir_57);
    viewdir_57 = tmpvar_63;
    float tmpvar_64;
    tmpvar_64 = sqrt(dot (_camPos, _camPos));
    r_55 = tmpvar_64;
    if ((tmpvar_64 < (0.9 * Rg))) {
      camera_50.y = (_camPos.y + Rg);
      _point_51.y = (worldPos_4.y + Rg);
      r_55 = sqrt(dot (camera_50, camera_50));
    };
    float tmpvar_65;
    tmpvar_65 = dot (camera_50, tmpvar_63);
    rMu_54 = tmpvar_65;
    mu_53 = (tmpvar_65 / r_55);
    vec3 tmpvar_66;
    tmpvar_66 = (_point_51 - (tmpvar_63 * clamp (1.0, 0.0, tmpvar_60)));
    _point_51 = tmpvar_66;
    float tmpvar_67;
    tmpvar_67 = max ((-(tmpvar_65) - sqrt((((tmpvar_65 * tmpvar_65) - (r_55 * r_55)) + (tmpvar_62 * tmpvar_62)))), 0.0);
    if (((tmpvar_67 > 0.0) && (tmpvar_67 < tmpvar_60))) {
      camera_50 = (camera_50 + (tmpvar_67 * tmpvar_63));
      float tmpvar_68;
      tmpvar_68 = (tmpvar_65 + tmpvar_67);
      rMu_54 = tmpvar_68;
      mu_53 = (tmpvar_68 / tmpvar_62);
      r_55 = tmpvar_62;
      d_56 = (tmpvar_60 - tmpvar_67);
    };
    if ((r_55 <= tmpvar_62)) {
      float muS1_69;
      float mu1_70;
      float r1_71;
      vec4 inScatter_72;
      float tmpvar_73;
      tmpvar_73 = dot (tmpvar_63, SUN_DIR);
      float tmpvar_74;
      tmpvar_74 = (dot (camera_50, SUN_DIR) / r_55);
      if ((r_55 < (Rg + 600.0))) {
        float tmpvar_75;
        tmpvar_75 = ((Rg + 600.0) / r_55);
        r_55 = (r_55 * tmpvar_75);
        rMu_54 = (rMu_54 * tmpvar_75);
        _point_51 = (tmpvar_66 * tmpvar_75);
      };
      float tmpvar_76;
      tmpvar_76 = sqrt(dot (_point_51, _point_51));
      r1_71 = tmpvar_76;
      float tmpvar_77;
      tmpvar_77 = (dot (_point_51, tmpvar_63) / tmpvar_76);
      mu1_70 = tmpvar_77;
      muS1_69 = (dot (_point_51, SUN_DIR) / tmpvar_76);
      if ((mu_53 > 0.0)) {
        float y_over_x_78;
        y_over_x_78 = (((mu_53 + 0.15) / 1.15) * 14.1014);
        float x_79;
        x_79 = (y_over_x_78 * inversesqrt(((y_over_x_78 * y_over_x_78) + 1.0)));
        vec4 tmpvar_80;
        tmpvar_80.zw = vec2(0.0, 0.0);
        tmpvar_80.x = ((sign(x_79) * (1.5708 - (sqrt((1.0 - abs(x_79))) * (1.5708 + (abs(x_79) * (-0.214602 + (abs(x_79) * (0.0865667 + (abs(x_79) * -0.0310296))))))))) / 1.5);
        tmpvar_80.y = sqrt(((r_55 - Rg) / (tmpvar_62 - Rg)));
        float y_over_x_81;
        y_over_x_81 = (((tmpvar_77 + 0.15) / 1.15) * 14.1014);
        float x_82;
        x_82 = (y_over_x_81 * inversesqrt(((y_over_x_81 * y_over_x_81) + 1.0)));
        vec4 tmpvar_83;
        tmpvar_83.zw = vec2(0.0, 0.0);
        tmpvar_83.x = ((sign(x_82) * (1.5708 - (sqrt((1.0 - abs(x_82))) * (1.5708 + (abs(x_82) * (-0.214602 + (abs(x_82) * (0.0865667 + (abs(x_82) * -0.0310296))))))))) / 1.5);
        tmpvar_83.y = sqrt(((tmpvar_76 - Rg) / (tmpvar_62 - Rg)));
        extinction_52 = min ((texture2DLod (_Transmittance, tmpvar_80.xy, 0.0).xyz / texture2DLod (_Transmittance, tmpvar_83.xy, 0.0).xyz), vec3(1.0, 1.0, 1.0));
      } else {
        float y_over_x_84;
        y_over_x_84 = (((-(tmpvar_77) + 0.15) / 1.15) * 14.1014);
        float x_85;
        x_85 = (y_over_x_84 * inversesqrt(((y_over_x_84 * y_over_x_84) + 1.0)));
        vec4 tmpvar_86;
        tmpvar_86.zw = vec2(0.0, 0.0);
        tmpvar_86.x = ((sign(x_85) * (1.5708 - (sqrt((1.0 - abs(x_85))) * (1.5708 + (abs(x_85) * (-0.214602 + (abs(x_85) * (0.0865667 + (abs(x_85) * -0.0310296))))))))) / 1.5);
        tmpvar_86.y = sqrt(((tmpvar_76 - Rg) / (tmpvar_62 - Rg)));
        float y_over_x_87;
        y_over_x_87 = (((-(mu_53) + 0.15) / 1.15) * 14.1014);
        float x_88;
        x_88 = (y_over_x_87 * inversesqrt(((y_over_x_87 * y_over_x_87) + 1.0)));
        vec4 tmpvar_89;
        tmpvar_89.zw = vec2(0.0, 0.0);
        tmpvar_89.x = ((sign(x_88) * (1.5708 - (sqrt((1.0 - abs(x_88))) * (1.5708 + (abs(x_88) * (-0.214602 + (abs(x_88) * (0.0865667 + (abs(x_88) * -0.0310296))))))))) / 1.5);
        tmpvar_89.y = sqrt(((r_55 - Rg) / (tmpvar_62 - Rg)));
        extinction_52 = min ((texture2DLod (_Transmittance, tmpvar_86.xy, 0.0).xyz / texture2DLod (_Transmittance, tmpvar_89.xy, 0.0).xyz), vec3(1.0, 1.0, 1.0));
      };
      float tmpvar_90;
      tmpvar_90 = -(sqrt((1.0 - ((Rg / r_55) * (Rg / r_55)))));
      float tmpvar_91;
      tmpvar_91 = abs((mu_53 - tmpvar_90));
      if ((tmpvar_91 < 0.004)) {
        vec4 inScatterA_92;
        vec4 inScatter0_93;
        float a_94;
        a_94 = (((mu_53 - tmpvar_90) + 0.004) / 0.008);
        float tmpvar_95;
        tmpvar_95 = (tmpvar_90 - 0.004);
        mu_53 = tmpvar_95;
        float tmpvar_96;
        tmpvar_96 = sqrt((((r_55 * r_55) + (d_56 * d_56)) + (((2.0 * r_55) * d_56) * tmpvar_95)));
        r1_71 = tmpvar_96;
        mu1_70 = (((r_55 * tmpvar_95) + d_56) / tmpvar_96);
        float uMu_97;
        float uR_98;
        float tmpvar_99;
        tmpvar_99 = sqrt(((tmpvar_62 * tmpvar_62) - (Rg * Rg)));
        float tmpvar_100;
        tmpvar_100 = sqrt(((r_55 * r_55) - (Rg * Rg)));
        float tmpvar_101;
        tmpvar_101 = (r_55 * tmpvar_95);
        float tmpvar_102;
        tmpvar_102 = (((tmpvar_101 * tmpvar_101) - (r_55 * r_55)) + (Rg * Rg));
        vec4 tmpvar_103;
        if (((tmpvar_101 < 0.0) && (tmpvar_102 > 0.0))) {
          vec4 tmpvar_104;
          tmpvar_104.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_104.w = (0.5 - (0.5 / RES_MU));
          tmpvar_103 = tmpvar_104;
        } else {
          vec4 tmpvar_105;
          tmpvar_105.x = -1.0;
          tmpvar_105.y = (tmpvar_99 * tmpvar_99);
          tmpvar_105.z = tmpvar_99;
          tmpvar_105.w = (0.5 + (0.5 / RES_MU));
          tmpvar_103 = tmpvar_105;
        };
        uR_98 = ((0.5 / RES_R) + ((tmpvar_100 / tmpvar_99) * (1.0 - (1.0/(RES_R)))));
        uMu_97 = (tmpvar_103.w + ((((tmpvar_101 * tmpvar_103.x) + sqrt((tmpvar_102 + tmpvar_103.y))) / (tmpvar_100 + tmpvar_103.z)) * (0.5 - (1.0/(RES_MU)))));
        float y_over_x_106;
        y_over_x_106 = (max (tmpvar_74, -0.1975) * 5.34962);
        float x_107;
        x_107 = (y_over_x_106 * inversesqrt(((y_over_x_106 * y_over_x_106) + 1.0)));
        float tmpvar_108;
        tmpvar_108 = ((0.5 / RES_MU_S) + (((((sign(x_107) * (1.5708 - (sqrt((1.0 - abs(x_107))) * (1.5708 + (abs(x_107) * (-0.214602 + (abs(x_107) * (0.0865667 + (abs(x_107) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        float tmpvar_109;
        tmpvar_109 = (((tmpvar_73 + 1.0) / 2.0) * (RES_NU - 1.0));
        float tmpvar_110;
        tmpvar_110 = floor(tmpvar_109);
        float tmpvar_111;
        tmpvar_111 = (tmpvar_109 - tmpvar_110);
        float tmpvar_112;
        tmpvar_112 = (floor(((uR_98 * RES_R) - 1.0)) / RES_R);
        float tmpvar_113;
        tmpvar_113 = (floor((uR_98 * RES_R)) / RES_R);
        float tmpvar_114;
        tmpvar_114 = fract((uR_98 * RES_R));
        vec4 tmpvar_115;
        tmpvar_115.zw = vec2(0.0, 0.0);
        tmpvar_115.x = ((tmpvar_110 + tmpvar_108) / RES_NU);
        tmpvar_115.y = ((uMu_97 / RES_R) + tmpvar_112);
        vec4 tmpvar_116;
        tmpvar_116.zw = vec2(0.0, 0.0);
        tmpvar_116.x = (((tmpvar_110 + tmpvar_108) + 1.0) / RES_NU);
        tmpvar_116.y = ((uMu_97 / RES_R) + tmpvar_112);
        vec4 tmpvar_117;
        tmpvar_117.zw = vec2(0.0, 0.0);
        tmpvar_117.x = ((tmpvar_110 + tmpvar_108) / RES_NU);
        tmpvar_117.y = ((uMu_97 / RES_R) + tmpvar_113);
        vec4 tmpvar_118;
        tmpvar_118.zw = vec2(0.0, 0.0);
        tmpvar_118.x = (((tmpvar_110 + tmpvar_108) + 1.0) / RES_NU);
        tmpvar_118.y = ((uMu_97 / RES_R) + tmpvar_113);
        inScatter0_93 = ((((texture2DLod (_Inscatter, tmpvar_115.xy, 0.0) * (1.0 - tmpvar_111)) + (texture2DLod (_Inscatter, tmpvar_116.xy, 0.0) * tmpvar_111)) * (1.0 - tmpvar_114)) + (((texture2DLod (_Inscatter, tmpvar_117.xy, 0.0) * (1.0 - tmpvar_111)) + (texture2DLod (_Inscatter, tmpvar_118.xy, 0.0) * tmpvar_111)) * tmpvar_114));
        float uMu_119;
        float uR_120;
        float tmpvar_121;
        tmpvar_121 = sqrt(((tmpvar_62 * tmpvar_62) - (Rg * Rg)));
        float tmpvar_122;
        tmpvar_122 = sqrt(((tmpvar_96 * tmpvar_96) - (Rg * Rg)));
        float tmpvar_123;
        tmpvar_123 = (tmpvar_96 * mu1_70);
        float tmpvar_124;
        tmpvar_124 = (((tmpvar_123 * tmpvar_123) - (tmpvar_96 * tmpvar_96)) + (Rg * Rg));
        vec4 tmpvar_125;
        if (((tmpvar_123 < 0.0) && (tmpvar_124 > 0.0))) {
          vec4 tmpvar_126;
          tmpvar_126.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_126.w = (0.5 - (0.5 / RES_MU));
          tmpvar_125 = tmpvar_126;
        } else {
          vec4 tmpvar_127;
          tmpvar_127.x = -1.0;
          tmpvar_127.y = (tmpvar_121 * tmpvar_121);
          tmpvar_127.z = tmpvar_121;
          tmpvar_127.w = (0.5 + (0.5 / RES_MU));
          tmpvar_125 = tmpvar_127;
        };
        uR_120 = ((0.5 / RES_R) + ((tmpvar_122 / tmpvar_121) * (1.0 - (1.0/(RES_R)))));
        uMu_119 = (tmpvar_125.w + ((((tmpvar_123 * tmpvar_125.x) + sqrt((tmpvar_124 + tmpvar_125.y))) / (tmpvar_122 + tmpvar_125.z)) * (0.5 - (1.0/(RES_MU)))));
        float y_over_x_128;
        y_over_x_128 = (max (muS1_69, -0.1975) * 5.34962);
        float x_129;
        x_129 = (y_over_x_128 * inversesqrt(((y_over_x_128 * y_over_x_128) + 1.0)));
        float tmpvar_130;
        tmpvar_130 = ((0.5 / RES_MU_S) + (((((sign(x_129) * (1.5708 - (sqrt((1.0 - abs(x_129))) * (1.5708 + (abs(x_129) * (-0.214602 + (abs(x_129) * (0.0865667 + (abs(x_129) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        float tmpvar_131;
        tmpvar_131 = (((tmpvar_73 + 1.0) / 2.0) * (RES_NU - 1.0));
        float tmpvar_132;
        tmpvar_132 = floor(tmpvar_131);
        float tmpvar_133;
        tmpvar_133 = (tmpvar_131 - tmpvar_132);
        float tmpvar_134;
        tmpvar_134 = (floor(((uR_120 * RES_R) - 1.0)) / RES_R);
        float tmpvar_135;
        tmpvar_135 = (floor((uR_120 * RES_R)) / RES_R);
        float tmpvar_136;
        tmpvar_136 = fract((uR_120 * RES_R));
        vec4 tmpvar_137;
        tmpvar_137.zw = vec2(0.0, 0.0);
        tmpvar_137.x = ((tmpvar_132 + tmpvar_130) / RES_NU);
        tmpvar_137.y = ((uMu_119 / RES_R) + tmpvar_134);
        vec4 tmpvar_138;
        tmpvar_138.zw = vec2(0.0, 0.0);
        tmpvar_138.x = (((tmpvar_132 + tmpvar_130) + 1.0) / RES_NU);
        tmpvar_138.y = ((uMu_119 / RES_R) + tmpvar_134);
        vec4 tmpvar_139;
        tmpvar_139.zw = vec2(0.0, 0.0);
        tmpvar_139.x = ((tmpvar_132 + tmpvar_130) / RES_NU);
        tmpvar_139.y = ((uMu_119 / RES_R) + tmpvar_135);
        vec4 tmpvar_140;
        tmpvar_140.zw = vec2(0.0, 0.0);
        tmpvar_140.x = (((tmpvar_132 + tmpvar_130) + 1.0) / RES_NU);
        tmpvar_140.y = ((uMu_119 / RES_R) + tmpvar_135);
        inScatterA_92 = max ((inScatter0_93 - (((((texture2DLod (_Inscatter, tmpvar_137.xy, 0.0) * (1.0 - tmpvar_133)) + (texture2DLod (_Inscatter, tmpvar_138.xy, 0.0) * tmpvar_133)) * (1.0 - tmpvar_136)) + (((texture2DLod (_Inscatter, tmpvar_139.xy, 0.0) * (1.0 - tmpvar_133)) + (texture2DLod (_Inscatter, tmpvar_140.xy, 0.0) * tmpvar_133)) * tmpvar_136)) * extinction_52.xyzx)), vec4(0.0, 0.0, 0.0, 0.0));
        float tmpvar_141;
        tmpvar_141 = (tmpvar_90 + 0.004);
        mu_53 = tmpvar_141;
        float tmpvar_142;
        tmpvar_142 = sqrt((((r_55 * r_55) + (d_56 * d_56)) + (((2.0 * r_55) * d_56) * tmpvar_141)));
        r1_71 = tmpvar_142;
        mu1_70 = (((r_55 * tmpvar_141) + d_56) / tmpvar_142);
        float uMu_143;
        float uR_144;
        float tmpvar_145;
        tmpvar_145 = sqrt(((tmpvar_62 * tmpvar_62) - (Rg * Rg)));
        float tmpvar_146;
        tmpvar_146 = sqrt(((r_55 * r_55) - (Rg * Rg)));
        float tmpvar_147;
        tmpvar_147 = (r_55 * tmpvar_141);
        float tmpvar_148;
        tmpvar_148 = (((tmpvar_147 * tmpvar_147) - (r_55 * r_55)) + (Rg * Rg));
        vec4 tmpvar_149;
        if (((tmpvar_147 < 0.0) && (tmpvar_148 > 0.0))) {
          vec4 tmpvar_150;
          tmpvar_150.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_150.w = (0.5 - (0.5 / RES_MU));
          tmpvar_149 = tmpvar_150;
        } else {
          vec4 tmpvar_151;
          tmpvar_151.x = -1.0;
          tmpvar_151.y = (tmpvar_145 * tmpvar_145);
          tmpvar_151.z = tmpvar_145;
          tmpvar_151.w = (0.5 + (0.5 / RES_MU));
          tmpvar_149 = tmpvar_151;
        };
        uR_144 = ((0.5 / RES_R) + ((tmpvar_146 / tmpvar_145) * (1.0 - (1.0/(RES_R)))));
        uMu_143 = (tmpvar_149.w + ((((tmpvar_147 * tmpvar_149.x) + sqrt((tmpvar_148 + tmpvar_149.y))) / (tmpvar_146 + tmpvar_149.z)) * (0.5 - (1.0/(RES_MU)))));
        float y_over_x_152;
        y_over_x_152 = (max (tmpvar_74, -0.1975) * 5.34962);
        float x_153;
        x_153 = (y_over_x_152 * inversesqrt(((y_over_x_152 * y_over_x_152) + 1.0)));
        float tmpvar_154;
        tmpvar_154 = ((0.5 / RES_MU_S) + (((((sign(x_153) * (1.5708 - (sqrt((1.0 - abs(x_153))) * (1.5708 + (abs(x_153) * (-0.214602 + (abs(x_153) * (0.0865667 + (abs(x_153) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        float tmpvar_155;
        tmpvar_155 = (((tmpvar_73 + 1.0) / 2.0) * (RES_NU - 1.0));
        float tmpvar_156;
        tmpvar_156 = floor(tmpvar_155);
        float tmpvar_157;
        tmpvar_157 = (tmpvar_155 - tmpvar_156);
        float tmpvar_158;
        tmpvar_158 = (floor(((uR_144 * RES_R) - 1.0)) / RES_R);
        float tmpvar_159;
        tmpvar_159 = (floor((uR_144 * RES_R)) / RES_R);
        float tmpvar_160;
        tmpvar_160 = fract((uR_144 * RES_R));
        vec4 tmpvar_161;
        tmpvar_161.zw = vec2(0.0, 0.0);
        tmpvar_161.x = ((tmpvar_156 + tmpvar_154) / RES_NU);
        tmpvar_161.y = ((uMu_143 / RES_R) + tmpvar_158);
        vec4 tmpvar_162;
        tmpvar_162.zw = vec2(0.0, 0.0);
        tmpvar_162.x = (((tmpvar_156 + tmpvar_154) + 1.0) / RES_NU);
        tmpvar_162.y = ((uMu_143 / RES_R) + tmpvar_158);
        vec4 tmpvar_163;
        tmpvar_163.zw = vec2(0.0, 0.0);
        tmpvar_163.x = ((tmpvar_156 + tmpvar_154) / RES_NU);
        tmpvar_163.y = ((uMu_143 / RES_R) + tmpvar_159);
        vec4 tmpvar_164;
        tmpvar_164.zw = vec2(0.0, 0.0);
        tmpvar_164.x = (((tmpvar_156 + tmpvar_154) + 1.0) / RES_NU);
        tmpvar_164.y = ((uMu_143 / RES_R) + tmpvar_159);
        inScatter0_93 = ((((texture2DLod (_Inscatter, tmpvar_161.xy, 0.0) * (1.0 - tmpvar_157)) + (texture2DLod (_Inscatter, tmpvar_162.xy, 0.0) * tmpvar_157)) * (1.0 - tmpvar_160)) + (((texture2DLod (_Inscatter, tmpvar_163.xy, 0.0) * (1.0 - tmpvar_157)) + (texture2DLod (_Inscatter, tmpvar_164.xy, 0.0) * tmpvar_157)) * tmpvar_160));
        float uMu_165;
        float uR_166;
        float tmpvar_167;
        tmpvar_167 = sqrt(((tmpvar_62 * tmpvar_62) - (Rg * Rg)));
        float tmpvar_168;
        tmpvar_168 = sqrt(((tmpvar_142 * tmpvar_142) - (Rg * Rg)));
        float tmpvar_169;
        tmpvar_169 = (tmpvar_142 * mu1_70);
        float tmpvar_170;
        tmpvar_170 = (((tmpvar_169 * tmpvar_169) - (tmpvar_142 * tmpvar_142)) + (Rg * Rg));
        vec4 tmpvar_171;
        if (((tmpvar_169 < 0.0) && (tmpvar_170 > 0.0))) {
          vec4 tmpvar_172;
          tmpvar_172.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_172.w = (0.5 - (0.5 / RES_MU));
          tmpvar_171 = tmpvar_172;
        } else {
          vec4 tmpvar_173;
          tmpvar_173.x = -1.0;
          tmpvar_173.y = (tmpvar_167 * tmpvar_167);
          tmpvar_173.z = tmpvar_167;
          tmpvar_173.w = (0.5 + (0.5 / RES_MU));
          tmpvar_171 = tmpvar_173;
        };
        uR_166 = ((0.5 / RES_R) + ((tmpvar_168 / tmpvar_167) * (1.0 - (1.0/(RES_R)))));
        uMu_165 = (tmpvar_171.w + ((((tmpvar_169 * tmpvar_171.x) + sqrt((tmpvar_170 + tmpvar_171.y))) / (tmpvar_168 + tmpvar_171.z)) * (0.5 - (1.0/(RES_MU)))));
        float y_over_x_174;
        y_over_x_174 = (max (muS1_69, -0.1975) * 5.34962);
        float x_175;
        x_175 = (y_over_x_174 * inversesqrt(((y_over_x_174 * y_over_x_174) + 1.0)));
        float tmpvar_176;
        tmpvar_176 = ((0.5 / RES_MU_S) + (((((sign(x_175) * (1.5708 - (sqrt((1.0 - abs(x_175))) * (1.5708 + (abs(x_175) * (-0.214602 + (abs(x_175) * (0.0865667 + (abs(x_175) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        float tmpvar_177;
        tmpvar_177 = (((tmpvar_73 + 1.0) / 2.0) * (RES_NU - 1.0));
        float tmpvar_178;
        tmpvar_178 = floor(tmpvar_177);
        float tmpvar_179;
        tmpvar_179 = (tmpvar_177 - tmpvar_178);
        float tmpvar_180;
        tmpvar_180 = (floor(((uR_166 * RES_R) - 1.0)) / RES_R);
        float tmpvar_181;
        tmpvar_181 = (floor((uR_166 * RES_R)) / RES_R);
        float tmpvar_182;
        tmpvar_182 = fract((uR_166 * RES_R));
        vec4 tmpvar_183;
        tmpvar_183.zw = vec2(0.0, 0.0);
        tmpvar_183.x = ((tmpvar_178 + tmpvar_176) / RES_NU);
        tmpvar_183.y = ((uMu_165 / RES_R) + tmpvar_180);
        vec4 tmpvar_184;
        tmpvar_184.zw = vec2(0.0, 0.0);
        tmpvar_184.x = (((tmpvar_178 + tmpvar_176) + 1.0) / RES_NU);
        tmpvar_184.y = ((uMu_165 / RES_R) + tmpvar_180);
        vec4 tmpvar_185;
        tmpvar_185.zw = vec2(0.0, 0.0);
        tmpvar_185.x = ((tmpvar_178 + tmpvar_176) / RES_NU);
        tmpvar_185.y = ((uMu_165 / RES_R) + tmpvar_181);
        vec4 tmpvar_186;
        tmpvar_186.zw = vec2(0.0, 0.0);
        tmpvar_186.x = (((tmpvar_178 + tmpvar_176) + 1.0) / RES_NU);
        tmpvar_186.y = ((uMu_165 / RES_R) + tmpvar_181);
        inScatter_72 = mix (inScatterA_92, max ((inScatter0_93 - (((((texture2DLod (_Inscatter, tmpvar_183.xy, 0.0) * (1.0 - tmpvar_179)) + (texture2DLod (_Inscatter, tmpvar_184.xy, 0.0) * tmpvar_179)) * (1.0 - tmpvar_182)) + (((texture2DLod (_Inscatter, tmpvar_185.xy, 0.0) * (1.0 - tmpvar_179)) + (texture2DLod (_Inscatter, tmpvar_186.xy, 0.0) * tmpvar_179)) * tmpvar_182)) * extinction_52.xyzx)), vec4(0.0, 0.0, 0.0, 0.0)), vec4(a_94));
      } else {
        vec4 inScatter0_1_187;
        float uMu_188;
        float uR_189;
        float tmpvar_190;
        tmpvar_190 = sqrt(((tmpvar_62 * tmpvar_62) - (Rg * Rg)));
        float tmpvar_191;
        tmpvar_191 = sqrt(((r_55 * r_55) - (Rg * Rg)));
        float tmpvar_192;
        tmpvar_192 = (r_55 * mu_53);
        float tmpvar_193;
        tmpvar_193 = (((tmpvar_192 * tmpvar_192) - (r_55 * r_55)) + (Rg * Rg));
        vec4 tmpvar_194;
        if (((tmpvar_192 < 0.0) && (tmpvar_193 > 0.0))) {
          vec4 tmpvar_195;
          tmpvar_195.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_195.w = (0.5 - (0.5 / RES_MU));
          tmpvar_194 = tmpvar_195;
        } else {
          vec4 tmpvar_196;
          tmpvar_196.x = -1.0;
          tmpvar_196.y = (tmpvar_190 * tmpvar_190);
          tmpvar_196.z = tmpvar_190;
          tmpvar_196.w = (0.5 + (0.5 / RES_MU));
          tmpvar_194 = tmpvar_196;
        };
        uR_189 = ((0.5 / RES_R) + ((tmpvar_191 / tmpvar_190) * (1.0 - (1.0/(RES_R)))));
        uMu_188 = (tmpvar_194.w + ((((tmpvar_192 * tmpvar_194.x) + sqrt((tmpvar_193 + tmpvar_194.y))) / (tmpvar_191 + tmpvar_194.z)) * (0.5 - (1.0/(RES_MU)))));
        float y_over_x_197;
        y_over_x_197 = (max (tmpvar_74, -0.1975) * 5.34962);
        float x_198;
        x_198 = (y_over_x_197 * inversesqrt(((y_over_x_197 * y_over_x_197) + 1.0)));
        float tmpvar_199;
        tmpvar_199 = ((0.5 / RES_MU_S) + (((((sign(x_198) * (1.5708 - (sqrt((1.0 - abs(x_198))) * (1.5708 + (abs(x_198) * (-0.214602 + (abs(x_198) * (0.0865667 + (abs(x_198) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        float tmpvar_200;
        tmpvar_200 = (((tmpvar_73 + 1.0) / 2.0) * (RES_NU - 1.0));
        float tmpvar_201;
        tmpvar_201 = floor(tmpvar_200);
        float tmpvar_202;
        tmpvar_202 = (tmpvar_200 - tmpvar_201);
        float tmpvar_203;
        tmpvar_203 = (floor(((uR_189 * RES_R) - 1.0)) / RES_R);
        float tmpvar_204;
        tmpvar_204 = (floor((uR_189 * RES_R)) / RES_R);
        float tmpvar_205;
        tmpvar_205 = fract((uR_189 * RES_R));
        vec4 tmpvar_206;
        tmpvar_206.zw = vec2(0.0, 0.0);
        tmpvar_206.x = ((tmpvar_201 + tmpvar_199) / RES_NU);
        tmpvar_206.y = ((uMu_188 / RES_R) + tmpvar_203);
        vec4 tmpvar_207;
        tmpvar_207.zw = vec2(0.0, 0.0);
        tmpvar_207.x = (((tmpvar_201 + tmpvar_199) + 1.0) / RES_NU);
        tmpvar_207.y = ((uMu_188 / RES_R) + tmpvar_203);
        vec4 tmpvar_208;
        tmpvar_208.zw = vec2(0.0, 0.0);
        tmpvar_208.x = ((tmpvar_201 + tmpvar_199) / RES_NU);
        tmpvar_208.y = ((uMu_188 / RES_R) + tmpvar_204);
        vec4 tmpvar_209;
        tmpvar_209.zw = vec2(0.0, 0.0);
        tmpvar_209.x = (((tmpvar_201 + tmpvar_199) + 1.0) / RES_NU);
        tmpvar_209.y = ((uMu_188 / RES_R) + tmpvar_204);
        inScatter0_1_187 = ((((texture2DLod (_Inscatter, tmpvar_206.xy, 0.0) * (1.0 - tmpvar_202)) + (texture2DLod (_Inscatter, tmpvar_207.xy, 0.0) * tmpvar_202)) * (1.0 - tmpvar_205)) + (((texture2DLod (_Inscatter, tmpvar_208.xy, 0.0) * (1.0 - tmpvar_202)) + (texture2DLod (_Inscatter, tmpvar_209.xy, 0.0) * tmpvar_202)) * tmpvar_205));
        float uMu_210;
        float uR_211;
        float tmpvar_212;
        tmpvar_212 = sqrt(((tmpvar_62 * tmpvar_62) - (Rg * Rg)));
        float tmpvar_213;
        tmpvar_213 = sqrt(((r1_71 * r1_71) - (Rg * Rg)));
        float tmpvar_214;
        tmpvar_214 = (r1_71 * mu1_70);
        float tmpvar_215;
        tmpvar_215 = (((tmpvar_214 * tmpvar_214) - (r1_71 * r1_71)) + (Rg * Rg));
        vec4 tmpvar_216;
        if (((tmpvar_214 < 0.0) && (tmpvar_215 > 0.0))) {
          vec4 tmpvar_217;
          tmpvar_217.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_217.w = (0.5 - (0.5 / RES_MU));
          tmpvar_216 = tmpvar_217;
        } else {
          vec4 tmpvar_218;
          tmpvar_218.x = -1.0;
          tmpvar_218.y = (tmpvar_212 * tmpvar_212);
          tmpvar_218.z = tmpvar_212;
          tmpvar_218.w = (0.5 + (0.5 / RES_MU));
          tmpvar_216 = tmpvar_218;
        };
        uR_211 = ((0.5 / RES_R) + ((tmpvar_213 / tmpvar_212) * (1.0 - (1.0/(RES_R)))));
        uMu_210 = (tmpvar_216.w + ((((tmpvar_214 * tmpvar_216.x) + sqrt((tmpvar_215 + tmpvar_216.y))) / (tmpvar_213 + tmpvar_216.z)) * (0.5 - (1.0/(RES_MU)))));
        float y_over_x_219;
        y_over_x_219 = (max (muS1_69, -0.1975) * 5.34962);
        float x_220;
        x_220 = (y_over_x_219 * inversesqrt(((y_over_x_219 * y_over_x_219) + 1.0)));
        float tmpvar_221;
        tmpvar_221 = ((0.5 / RES_MU_S) + (((((sign(x_220) * (1.5708 - (sqrt((1.0 - abs(x_220))) * (1.5708 + (abs(x_220) * (-0.214602 + (abs(x_220) * (0.0865667 + (abs(x_220) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        float tmpvar_222;
        tmpvar_222 = (((tmpvar_73 + 1.0) / 2.0) * (RES_NU - 1.0));
        float tmpvar_223;
        tmpvar_223 = floor(tmpvar_222);
        float tmpvar_224;
        tmpvar_224 = (tmpvar_222 - tmpvar_223);
        float tmpvar_225;
        tmpvar_225 = (floor(((uR_211 * RES_R) - 1.0)) / RES_R);
        float tmpvar_226;
        tmpvar_226 = (floor((uR_211 * RES_R)) / RES_R);
        float tmpvar_227;
        tmpvar_227 = fract((uR_211 * RES_R));
        vec4 tmpvar_228;
        tmpvar_228.zw = vec2(0.0, 0.0);
        tmpvar_228.x = ((tmpvar_223 + tmpvar_221) / RES_NU);
        tmpvar_228.y = ((uMu_210 / RES_R) + tmpvar_225);
        vec4 tmpvar_229;
        tmpvar_229.zw = vec2(0.0, 0.0);
        tmpvar_229.x = (((tmpvar_223 + tmpvar_221) + 1.0) / RES_NU);
        tmpvar_229.y = ((uMu_210 / RES_R) + tmpvar_225);
        vec4 tmpvar_230;
        tmpvar_230.zw = vec2(0.0, 0.0);
        tmpvar_230.x = ((tmpvar_223 + tmpvar_221) / RES_NU);
        tmpvar_230.y = ((uMu_210 / RES_R) + tmpvar_226);
        vec4 tmpvar_231;
        tmpvar_231.zw = vec2(0.0, 0.0);
        tmpvar_231.x = (((tmpvar_223 + tmpvar_221) + 1.0) / RES_NU);
        tmpvar_231.y = ((uMu_210 / RES_R) + tmpvar_226);
        inScatter_72 = max ((inScatter0_1_187 - (((((texture2DLod (_Inscatter, tmpvar_228.xy, 0.0) * (1.0 - tmpvar_224)) + (texture2DLod (_Inscatter, tmpvar_229.xy, 0.0) * tmpvar_224)) * (1.0 - tmpvar_227)) + (((texture2DLod (_Inscatter, tmpvar_230.xy, 0.0) * (1.0 - tmpvar_224)) + (texture2DLod (_Inscatter, tmpvar_231.xy, 0.0) * tmpvar_224)) * tmpvar_227)) * extinction_52.xyzx)), vec4(0.0, 0.0, 0.0, 0.0));
      };
      float t_232;
      t_232 = max (min ((tmpvar_74 / 0.02), 1.0), 0.0);
      inScatter_72.w = (inScatter_72.w * (t_232 * (t_232 * (3.0 - (2.0 * t_232)))));
      result_58 = ((inScatter_72.xyz * ((3.0 / (16.0 * M_PI)) * (1.0 + (tmpvar_73 * tmpvar_73)))) + ((((inScatter_72.xyz * inScatter_72.w) / max (inScatter_72.x, 0.0001)) * (betaR.x / betaR)) * (((((1.5 / (4.0 * M_PI)) * (1.0 - (mieG * mieG))) * pow (((1.0 + (mieG * mieG)) - ((2.0 * mieG) * tmpvar_73)), -1.5)) * (1.0 + (tmpvar_73 * tmpvar_73))) / (2.0 + (mieG * mieG)))));
    };
    tmpvar_49 = (result_58 * SUN_INTENSITY);
    visib_2 = 1.0;
    float tmpvar_233;
    vec3 arg0_234;
    arg0_234 = (worldPos_4 - _camPos);
    tmpvar_233 = sqrt(dot (arg0_234, arg0_234));
    if ((tmpvar_233 <= _global_depth)) {
      visib_2 = (1.0 - exp((-1.0 * ((4.0 * tmpvar_233) / _global_depth))));
    };
    if (((tmpvar_13 && tmpvar_18) && (fakeOcean == 1.0))) {
      vec3 L_235;
      L_235 = (oceanColor_3 * extinction_52);
      vec3 tmpvar_236;
      tmpvar_236 = (L_235 * _Exposure);
      L_235 = tmpvar_236;
      float tmpvar_237;
      if ((tmpvar_236.x < 1.413)) {
        tmpvar_237 = pow ((tmpvar_236.x * 0.38317), 0.454545);
      } else {
        tmpvar_237 = (1.0 - exp(-(tmpvar_236.x)));
      };
      L_235.x = tmpvar_237;
      float tmpvar_238;
      if ((tmpvar_236.y < 1.413)) {
        tmpvar_238 = pow ((tmpvar_236.y * 0.38317), 0.454545);
      } else {
        tmpvar_238 = (1.0 - exp(-(tmpvar_236.y)));
      };
      L_235.y = tmpvar_238;
      float tmpvar_239;
      if ((tmpvar_236.z < 1.413)) {
        tmpvar_239 = pow ((tmpvar_236.z * 0.38317), 0.454545);
      } else {
        tmpvar_239 = (1.0 - exp(-(tmpvar_236.z)));
      };
      L_235.z = tmpvar_239;
      vec3 L_240;
      vec3 tmpvar_241;
      tmpvar_241 = (tmpvar_49 * _Exposure);
      L_240 = tmpvar_241;
      float tmpvar_242;
      if ((tmpvar_241.x < 1.413)) {
        tmpvar_242 = pow ((tmpvar_241.x * 0.38317), 0.454545);
      } else {
        tmpvar_242 = (1.0 - exp(-(tmpvar_241.x)));
      };
      L_240.x = tmpvar_242;
      float tmpvar_243;
      if ((tmpvar_241.y < 1.413)) {
        tmpvar_243 = pow ((tmpvar_241.y * 0.38317), 0.454545);
      } else {
        tmpvar_243 = (1.0 - exp(-(tmpvar_241.y)));
      };
      L_240.y = tmpvar_243;
      float tmpvar_244;
      if ((tmpvar_241.z < 1.413)) {
        tmpvar_244 = pow ((tmpvar_241.z * 0.38317), 0.454545);
      } else {
        tmpvar_244 = (1.0 - exp(-(tmpvar_241.z)));
      };
      L_240.z = tmpvar_244;
      vec4 tmpvar_245;
      tmpvar_245.xyz = mix (L_235, L_240, vec3((_global_alpha * visib_2)));
      tmpvar_245.w = _fade;
      tmpvar_1 = tmpvar_245;
    } else {
      vec3 L_246;
      vec3 tmpvar_247;
      tmpvar_247 = (tmpvar_49 * _Exposure);
      L_246 = tmpvar_247;
      float tmpvar_248;
      if ((tmpvar_247.x < 1.413)) {
        tmpvar_248 = pow ((tmpvar_247.x * 0.38317), 0.454545);
      } else {
        tmpvar_248 = (1.0 - exp(-(tmpvar_247.x)));
      };
      L_246.x = tmpvar_248;
      float tmpvar_249;
      if ((tmpvar_247.y < 1.413)) {
        tmpvar_249 = pow ((tmpvar_247.y * 0.38317), 0.454545);
      } else {
        tmpvar_249 = (1.0 - exp(-(tmpvar_247.y)));
      };
      L_246.y = tmpvar_249;
      float tmpvar_250;
      if ((tmpvar_247.z < 1.413)) {
        tmpvar_250 = pow ((tmpvar_247.z * 0.38317), 0.454545);
      } else {
        tmpvar_250 = (1.0 - exp(-(tmpvar_247.z)));
      };
      L_246.z = tmpvar_250;
      vec4 tmpvar_251;
      tmpvar_251.xyz = L_246;
      tmpvar_251.w = ((_global_alpha * visib_2) * _fade);
      tmpvar_1 = tmpvar_251;
    };
  };
  gl_FragData[0] = tmpvar_1;
}


#endif
"
}
SubProgram "d3d9 " {
// Stats: 20 math, 1 branches
Bind "vertex" Vertex
Matrix 0 [glstate_matrix_modelview0]
Matrix 4 [glstate_matrix_mvp]
Vector 8 [_ProjectionParams]
Vector 9 [_ScreenParams]
Vector 10 [_MainTex_TexelSize]
"vs_3_0
dcl_position o0
dcl_texcoord0 o1
dcl_texcoord1 o2
dcl_texcoord2 o3
def c11, 0.50000000, 0.00000000, 1.00000000, 0
dcl_position0 v0
dp4 r1.z, v0, c7
dp4 r0.x, v0, c4
rcp r0.z, r1.z
mov r0.w, r1.z
dp4 r0.y, v0, c5
mul r2.xyz, r0.xyww, c11.x
mov r1.w, c11.y
mov r1.x, r2
mul r1.y, r2, c8.x
mad r1.xy, r2.z, c9.zwzw, r1
mul r2.zw, r1.xyxy, r0.z
mov r2.xy, r2.zwzw
dp4 r0.z, v0, c6
if_lt c10.y, r1.w
add r2.y, -r2, c11.z
endif
mov o0, r0
dp4 r0.x, v0, c2
mov o1.xyw, r1.xyzz
mov o2.xy, r2
mov o3.xy, r2.zwzw
mov o1.z, -r0.x
"
}
SubProgram "d3d11 " {
// Stats: 15 math
Bind "vertex" Vertex
ConstBuffer "$Globals" 336
Vector 240 [_MainTex_TexelSize]
ConstBuffer "UnityPerCamera" 128
Vector 80 [_ProjectionParams]
ConstBuffer "UnityPerDraw" 336
Matrix 0 [glstate_matrix_mvp]
Matrix 64 [glstate_matrix_modelview0]
BindCB  "$Globals" 0
BindCB  "UnityPerCamera" 1
BindCB  "UnityPerDraw" 2
"vs_4_0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"
}
SubProgram "gles " {
"!!GLES


#ifdef VERTEX

attribute vec4 _glesVertex;
uniform highp vec4 _ProjectionParams;
uniform highp mat4 glstate_matrix_mvp;
uniform highp mat4 glstate_matrix_modelview0;
varying highp vec4 xlv_TEXCOORD0;
varying highp vec2 xlv_TEXCOORD1;
varying highp vec2 xlv_TEXCOORD2;
void main ()
{
  highp vec4 tmpvar_1;
  highp vec4 tmpvar_2;
  tmpvar_2 = (glstate_matrix_mvp * _glesVertex);
  highp vec4 o_3;
  highp vec4 tmpvar_4;
  tmpvar_4 = (tmpvar_2 * 0.5);
  highp vec2 tmpvar_5;
  tmpvar_5.x = tmpvar_4.x;
  tmpvar_5.y = (tmpvar_4.y * _ProjectionParams.x);
  o_3.xy = (tmpvar_5 + tmpvar_4.w);
  o_3.zw = tmpvar_2.zw;
  tmpvar_1.xyw = o_3.xyw;
  highp vec2 tmpvar_6;
  tmpvar_6 = (o_3.xy / tmpvar_2.w);
  tmpvar_1.z = -((glstate_matrix_modelview0 * _glesVertex).z);
  gl_Position = tmpvar_2;
  xlv_TEXCOORD0 = tmpvar_1;
  xlv_TEXCOORD1 = tmpvar_6;
  xlv_TEXCOORD2 = tmpvar_6;
}



#endif
#ifdef FRAGMENT

#extension GL_EXT_shader_texture_lod : enable
uniform sampler2D _Transmittance;
uniform sampler2D _Inscatter;
uniform sampler2D _Irradiance;
uniform highp float M_PI;
uniform highp float Rg;
uniform highp float Rt;
uniform highp float RES_R;
uniform highp float RES_MU;
uniform highp float RES_MU_S;
uniform highp float RES_NU;
uniform highp vec3 SUN_DIR;
uniform highp float SUN_INTENSITY;
uniform highp vec3 betaR;
uniform highp float mieG;
uniform highp mat4 _ViewProjInv;
uniform highp float _viewdirOffset;
uniform highp float _experimentalAtmoScale;
uniform highp float _global_alpha;
uniform highp float _Exposure;
uniform highp float _global_depth;
uniform highp float _Ocean_Sigma;
uniform highp float fakeOcean;
uniform highp float _fade;
uniform highp vec3 _Ocean_Color;
uniform highp vec3 _camPos;
uniform sampler2D _customDepthTexture;
uniform highp float _openglThreshold;
varying highp vec2 xlv_TEXCOORD2;
void main ()
{
  mediump vec4 tmpvar_1;
  highp float visib_2;
  highp vec3 oceanColor_3;
  highp vec3 worldPos_4;
  highp float depth_5;
  lowp float tmpvar_6;
  tmpvar_6 = texture2D (_customDepthTexture, xlv_TEXCOORD2).x;
  depth_5 = tmpvar_6;
  highp vec4 tmpvar_7;
  tmpvar_7.w = 1.0;
  tmpvar_7.x = ((xlv_TEXCOORD2.x * 2.0) - 1.0);
  tmpvar_7.y = ((xlv_TEXCOORD2.y * 2.0) - 1.0);
  tmpvar_7.z = depth_5;
  highp vec4 tmpvar_8;
  tmpvar_8 = (_ViewProjInv * tmpvar_7);
  highp vec3 tmpvar_9;
  tmpvar_9 = (tmpvar_8 / tmpvar_8.w).xyz;
  worldPos_4 = tmpvar_9;
  highp float tmpvar_10;
  highp vec3 tmpvar_11;
  tmpvar_11 = (tmpvar_9 - _camPos);
  highp float tmpvar_12;
  tmpvar_12 = dot (tmpvar_11, tmpvar_11);
  highp float tmpvar_13;
  tmpvar_13 = (2.0 * dot (tmpvar_11, _camPos));
  highp float tmpvar_14;
  tmpvar_14 = ((tmpvar_13 * tmpvar_13) - ((4.0 * tmpvar_12) * (dot (_camPos, _camPos) - (Rg * Rg))));
  if ((tmpvar_14 < 0.0)) {
    tmpvar_10 = -1.0;
  } else {
    tmpvar_10 = ((-(tmpvar_13) - sqrt(tmpvar_14)) / (2.0 * tmpvar_12));
  };
  bool tmpvar_15;
  tmpvar_15 = (tmpvar_10 > 0.0);
  bool tmpvar_16;
  tmpvar_16 = (sqrt(dot (tmpvar_9, tmpvar_9)) >= Rt);
  if ((!(tmpvar_15) && tmpvar_16)) {
    tmpvar_1 = vec4(0.0, 0.0, 0.0, 0.0);
  } else {
    highp vec3 tmpvar_17;
    tmpvar_17 = (_camPos + (tmpvar_10 * (tmpvar_9 - _camPos)));
    highp vec3 arg0_18;
    arg0_18 = (tmpvar_17 - _camPos);
    highp vec3 arg0_19;
    arg0_19 = (tmpvar_9 - _camPos);
    bool tmpvar_20;
    tmpvar_20 = (sqrt(dot (arg0_18, arg0_18)) < sqrt(dot (arg0_19, arg0_19)));
    oceanColor_3 = vec3(1.0, 1.0, 1.0);
    if ((tmpvar_15 && tmpvar_20)) {
      worldPos_4 = tmpvar_17;
      if ((fakeOcean == 1.0)) {
        highp vec3 tmpvar_21;
        tmpvar_21 = normalize(tmpvar_17);
        highp vec3 tmpvar_22;
        tmpvar_22 = (tmpvar_21 * max (sqrt(dot (tmpvar_17, tmpvar_17)), Rg));
        highp vec3 tmpvar_23;
        tmpvar_23 = normalize((tmpvar_22 - _camPos));
        highp vec3 worldP_24;
        worldP_24 = tmpvar_22;
        highp float r_25;
        highp float tmpvar_26;
        tmpvar_26 = sqrt(dot (tmpvar_22, tmpvar_22));
        r_25 = tmpvar_26;
        if ((tmpvar_26 < (0.9 * Rg))) {
          worldP_24.z = (tmpvar_22.z + Rg);
          r_25 = sqrt(dot (worldP_24, worldP_24));
        };
        highp vec3 tmpvar_27;
        tmpvar_27 = (worldP_24 / r_25);
        highp float tmpvar_28;
        tmpvar_28 = dot (tmpvar_27, SUN_DIR);
        highp float tmpvar_29;
        tmpvar_29 = sqrt((1.0 - ((Rg / r_25) * (Rg / r_25))));
        highp vec3 tmpvar_30;
        if ((tmpvar_28 < -(tmpvar_29))) {
          tmpvar_30 = vec3(0.0, 0.0, 0.0);
        } else {
          highp vec3 tmpvar_31;
          highp float y_over_x_32;
          y_over_x_32 = (((tmpvar_28 + 0.15) / 1.15) * 14.1014);
          highp float x_33;
          x_33 = (y_over_x_32 * inversesqrt(((y_over_x_32 * y_over_x_32) + 1.0)));
          highp vec4 tmpvar_34;
          tmpvar_34.zw = vec2(0.0, 0.0);
          tmpvar_34.x = ((sign(x_33) * (1.5708 - (sqrt((1.0 - abs(x_33))) * (1.5708 + (abs(x_33) * (-0.214602 + (abs(x_33) * (0.0865667 + (abs(x_33) * -0.0310296))))))))) / 1.5);
          tmpvar_34.y = sqrt(((r_25 - Rg) / (Rt - Rg)));
          lowp vec4 tmpvar_35;
          tmpvar_35 = texture2DLodEXT (_Transmittance, tmpvar_34.xy, 0.0);
          tmpvar_31 = tmpvar_35.xyz;
          tmpvar_30 = tmpvar_31;
        };
        highp vec3 tmpvar_36;
        tmpvar_36 = (tmpvar_30 * SUN_INTENSITY);
        highp vec3 tmpvar_37;
        highp vec2 tmpvar_38;
        tmpvar_38.x = ((tmpvar_28 + 0.2) / 1.2);
        tmpvar_38.y = ((r_25 - Rg) / (Rt - Rg));
        lowp vec4 tmpvar_39;
        tmpvar_39 = texture2DLodEXT (_Irradiance, tmpvar_38, 0.0);
        tmpvar_37 = tmpvar_39.xyz;
        highp vec3 tmpvar_40;
        tmpvar_40 = (((2.0 * tmpvar_37) * SUN_INTENSITY) * ((1.0 + tmpvar_27.z) * 0.5));
        highp vec3 V_41;
        V_41 = -(tmpvar_23);
        highp vec3 seaColor_42;
        seaColor_42 = (_Ocean_Color * 10.0);
        highp float tmpvar_43;
        tmpvar_43 = sqrt(_Ocean_Sigma);
        highp float tmpvar_44;
        tmpvar_44 = (pow ((1.0 - dot (V_41, tmpvar_21)), (5.0 * exp((-2.69 * tmpvar_43)))) / (1.0 + (22.7 * pow (tmpvar_43, 1.5))));
        highp vec3 tmpvar_45;
        tmpvar_45 = normalize((SUN_DIR + V_41));
        highp float tmpvar_46;
        tmpvar_46 = dot (tmpvar_45, tmpvar_21);
        highp float tmpvar_47;
        tmpvar_47 = (exp(((-2.0 * ((1.0 - (tmpvar_46 * tmpvar_46)) / _Ocean_Sigma)) / (1.0 + tmpvar_46))) / ((4.0 * M_PI) * _Ocean_Sigma));
        highp float tmpvar_48;
        tmpvar_48 = (1.0 - dot (V_41, tmpvar_45));
        highp float tmpvar_49;
        tmpvar_49 = (tmpvar_48 * tmpvar_48);
        highp float tmpvar_50;
        tmpvar_50 = (0.02 + (((0.98 * tmpvar_49) * tmpvar_49) * tmpvar_48));
        highp float tmpvar_51;
        tmpvar_51 = max (dot (SUN_DIR, tmpvar_21), 0.01);
        highp float tmpvar_52;
        tmpvar_52 = max (dot (V_41, tmpvar_21), 0.01);
        highp float tmpvar_53;
        if ((tmpvar_51 <= 0.0)) {
          tmpvar_53 = 0.0;
        } else {
          tmpvar_53 = max (((tmpvar_50 * tmpvar_47) * sqrt(abs((tmpvar_51 / tmpvar_52)))), 0.0);
        };
        oceanColor_3 = (((tmpvar_53 * tmpvar_36) + ((tmpvar_40 * tmpvar_44) / M_PI)) + ((((1.0 - tmpvar_44) * seaColor_42) * tmpvar_40) / M_PI));
      };
    };
    highp float tmpvar_54;
    tmpvar_54 = sqrt(dot (worldPos_4, worldPos_4));
    if ((tmpvar_54 < (Rg + _openglThreshold))) {
      worldPos_4 = ((Rg + _openglThreshold) * normalize(worldPos_4));
    };
    highp vec3 tmpvar_55;
    highp vec3 camera_56;
    camera_56 = _camPos;
    highp vec3 _point_57;
    _point_57 = worldPos_4;
    highp vec3 extinction_58;
    highp float mu_59;
    highp float rMu_60;
    highp float r_61;
    highp float d_62;
    highp vec3 viewdir_63;
    highp vec3 result_64;
    result_64 = vec3(0.0, 0.0, 0.0);
    extinction_58 = vec3(1.0, 1.0, 1.0);
    highp vec3 tmpvar_65;
    tmpvar_65 = (worldPos_4 - _camPos);
    highp float tmpvar_66;
    tmpvar_66 = sqrt(dot (tmpvar_65, tmpvar_65));
    d_62 = tmpvar_66;
    highp vec3 tmpvar_67;
    tmpvar_67 = (tmpvar_65 / tmpvar_66);
    viewdir_63.yz = tmpvar_67.yz;
    highp float tmpvar_68;
    tmpvar_68 = (Rg + ((Rt - Rg) * _experimentalAtmoScale));
    viewdir_63.x = (tmpvar_67.x + _viewdirOffset);
    highp vec3 tmpvar_69;
    tmpvar_69 = normalize(viewdir_63);
    viewdir_63 = tmpvar_69;
    highp float tmpvar_70;
    tmpvar_70 = sqrt(dot (_camPos, _camPos));
    r_61 = tmpvar_70;
    if ((tmpvar_70 < (0.9 * Rg))) {
      camera_56.y = (_camPos.y + Rg);
      _point_57.y = (worldPos_4.y + Rg);
      r_61 = sqrt(dot (camera_56, camera_56));
    };
    highp float tmpvar_71;
    tmpvar_71 = dot (camera_56, tmpvar_69);
    rMu_60 = tmpvar_71;
    mu_59 = (tmpvar_71 / r_61);
    highp vec3 tmpvar_72;
    tmpvar_72 = (_point_57 - (tmpvar_69 * clamp (1.0, 0.0, tmpvar_66)));
    _point_57 = tmpvar_72;
    highp float tmpvar_73;
    tmpvar_73 = max ((-(tmpvar_71) - sqrt((((tmpvar_71 * tmpvar_71) - (r_61 * r_61)) + (tmpvar_68 * tmpvar_68)))), 0.0);
    if (((tmpvar_73 > 0.0) && (tmpvar_73 < tmpvar_66))) {
      camera_56 = (camera_56 + (tmpvar_73 * tmpvar_69));
      highp float tmpvar_74;
      tmpvar_74 = (tmpvar_71 + tmpvar_73);
      rMu_60 = tmpvar_74;
      mu_59 = (tmpvar_74 / tmpvar_68);
      r_61 = tmpvar_68;
      d_62 = (tmpvar_66 - tmpvar_73);
    };
    if ((r_61 <= tmpvar_68)) {
      highp float muS1_75;
      highp float mu1_76;
      highp float r1_77;
      highp vec4 inScatter_78;
      highp float tmpvar_79;
      tmpvar_79 = dot (tmpvar_69, SUN_DIR);
      highp float tmpvar_80;
      tmpvar_80 = (dot (camera_56, SUN_DIR) / r_61);
      if ((r_61 < (Rg + 600.0))) {
        highp float tmpvar_81;
        tmpvar_81 = ((Rg + 600.0) / r_61);
        r_61 = (r_61 * tmpvar_81);
        rMu_60 = (rMu_60 * tmpvar_81);
        _point_57 = (tmpvar_72 * tmpvar_81);
      };
      highp float tmpvar_82;
      tmpvar_82 = sqrt(dot (_point_57, _point_57));
      r1_77 = tmpvar_82;
      highp float tmpvar_83;
      tmpvar_83 = (dot (_point_57, tmpvar_69) / tmpvar_82);
      mu1_76 = tmpvar_83;
      muS1_75 = (dot (_point_57, SUN_DIR) / tmpvar_82);
      if ((mu_59 > 0.0)) {
        highp vec3 tmpvar_84;
        highp float y_over_x_85;
        y_over_x_85 = (((mu_59 + 0.15) / 1.15) * 14.1014);
        highp float x_86;
        x_86 = (y_over_x_85 * inversesqrt(((y_over_x_85 * y_over_x_85) + 1.0)));
        highp vec4 tmpvar_87;
        tmpvar_87.zw = vec2(0.0, 0.0);
        tmpvar_87.x = ((sign(x_86) * (1.5708 - (sqrt((1.0 - abs(x_86))) * (1.5708 + (abs(x_86) * (-0.214602 + (abs(x_86) * (0.0865667 + (abs(x_86) * -0.0310296))))))))) / 1.5);
        tmpvar_87.y = sqrt(((r_61 - Rg) / (tmpvar_68 - Rg)));
        lowp vec4 tmpvar_88;
        tmpvar_88 = texture2DLodEXT (_Transmittance, tmpvar_87.xy, 0.0);
        tmpvar_84 = tmpvar_88.xyz;
        highp vec3 tmpvar_89;
        highp float y_over_x_90;
        y_over_x_90 = (((tmpvar_83 + 0.15) / 1.15) * 14.1014);
        highp float x_91;
        x_91 = (y_over_x_90 * inversesqrt(((y_over_x_90 * y_over_x_90) + 1.0)));
        highp vec4 tmpvar_92;
        tmpvar_92.zw = vec2(0.0, 0.0);
        tmpvar_92.x = ((sign(x_91) * (1.5708 - (sqrt((1.0 - abs(x_91))) * (1.5708 + (abs(x_91) * (-0.214602 + (abs(x_91) * (0.0865667 + (abs(x_91) * -0.0310296))))))))) / 1.5);
        tmpvar_92.y = sqrt(((tmpvar_82 - Rg) / (tmpvar_68 - Rg)));
        lowp vec4 tmpvar_93;
        tmpvar_93 = texture2DLodEXT (_Transmittance, tmpvar_92.xy, 0.0);
        tmpvar_89 = tmpvar_93.xyz;
        extinction_58 = min ((tmpvar_84 / tmpvar_89), vec3(1.0, 1.0, 1.0));
      } else {
        highp vec3 tmpvar_94;
        highp float y_over_x_95;
        y_over_x_95 = (((-(tmpvar_83) + 0.15) / 1.15) * 14.1014);
        highp float x_96;
        x_96 = (y_over_x_95 * inversesqrt(((y_over_x_95 * y_over_x_95) + 1.0)));
        highp vec4 tmpvar_97;
        tmpvar_97.zw = vec2(0.0, 0.0);
        tmpvar_97.x = ((sign(x_96) * (1.5708 - (sqrt((1.0 - abs(x_96))) * (1.5708 + (abs(x_96) * (-0.214602 + (abs(x_96) * (0.0865667 + (abs(x_96) * -0.0310296))))))))) / 1.5);
        tmpvar_97.y = sqrt(((tmpvar_82 - Rg) / (tmpvar_68 - Rg)));
        lowp vec4 tmpvar_98;
        tmpvar_98 = texture2DLodEXT (_Transmittance, tmpvar_97.xy, 0.0);
        tmpvar_94 = tmpvar_98.xyz;
        highp vec3 tmpvar_99;
        highp float y_over_x_100;
        y_over_x_100 = (((-(mu_59) + 0.15) / 1.15) * 14.1014);
        highp float x_101;
        x_101 = (y_over_x_100 * inversesqrt(((y_over_x_100 * y_over_x_100) + 1.0)));
        highp vec4 tmpvar_102;
        tmpvar_102.zw = vec2(0.0, 0.0);
        tmpvar_102.x = ((sign(x_101) * (1.5708 - (sqrt((1.0 - abs(x_101))) * (1.5708 + (abs(x_101) * (-0.214602 + (abs(x_101) * (0.0865667 + (abs(x_101) * -0.0310296))))))))) / 1.5);
        tmpvar_102.y = sqrt(((r_61 - Rg) / (tmpvar_68 - Rg)));
        lowp vec4 tmpvar_103;
        tmpvar_103 = texture2DLodEXT (_Transmittance, tmpvar_102.xy, 0.0);
        tmpvar_99 = tmpvar_103.xyz;
        extinction_58 = min ((tmpvar_94 / tmpvar_99), vec3(1.0, 1.0, 1.0));
      };
      highp float tmpvar_104;
      tmpvar_104 = -(sqrt((1.0 - ((Rg / r_61) * (Rg / r_61)))));
      highp float tmpvar_105;
      tmpvar_105 = abs((mu_59 - tmpvar_104));
      if ((tmpvar_105 < 0.004)) {
        highp vec4 inScatterA_106;
        highp vec4 inScatter0_107;
        highp float a_108;
        a_108 = (((mu_59 - tmpvar_104) + 0.004) / 0.008);
        highp float tmpvar_109;
        tmpvar_109 = (tmpvar_104 - 0.004);
        mu_59 = tmpvar_109;
        highp float tmpvar_110;
        tmpvar_110 = sqrt((((r_61 * r_61) + (d_62 * d_62)) + (((2.0 * r_61) * d_62) * tmpvar_109)));
        r1_77 = tmpvar_110;
        mu1_76 = (((r_61 * tmpvar_109) + d_62) / tmpvar_110);
        highp float uMu_111;
        highp float uR_112;
        highp float tmpvar_113;
        tmpvar_113 = sqrt(((tmpvar_68 * tmpvar_68) - (Rg * Rg)));
        highp float tmpvar_114;
        tmpvar_114 = sqrt(((r_61 * r_61) - (Rg * Rg)));
        highp float tmpvar_115;
        tmpvar_115 = (r_61 * tmpvar_109);
        highp float tmpvar_116;
        tmpvar_116 = (((tmpvar_115 * tmpvar_115) - (r_61 * r_61)) + (Rg * Rg));
        highp vec4 tmpvar_117;
        if (((tmpvar_115 < 0.0) && (tmpvar_116 > 0.0))) {
          highp vec4 tmpvar_118;
          tmpvar_118.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_118.w = (0.5 - (0.5 / RES_MU));
          tmpvar_117 = tmpvar_118;
        } else {
          highp vec4 tmpvar_119;
          tmpvar_119.x = -1.0;
          tmpvar_119.y = (tmpvar_113 * tmpvar_113);
          tmpvar_119.z = tmpvar_113;
          tmpvar_119.w = (0.5 + (0.5 / RES_MU));
          tmpvar_117 = tmpvar_119;
        };
        uR_112 = ((0.5 / RES_R) + ((tmpvar_114 / tmpvar_113) * (1.0 - (1.0/(RES_R)))));
        uMu_111 = (tmpvar_117.w + ((((tmpvar_115 * tmpvar_117.x) + sqrt((tmpvar_116 + tmpvar_117.y))) / (tmpvar_114 + tmpvar_117.z)) * (0.5 - (1.0/(RES_MU)))));
        highp float y_over_x_120;
        y_over_x_120 = (max (tmpvar_80, -0.1975) * 5.34962);
        highp float x_121;
        x_121 = (y_over_x_120 * inversesqrt(((y_over_x_120 * y_over_x_120) + 1.0)));
        highp float tmpvar_122;
        tmpvar_122 = ((0.5 / RES_MU_S) + (((((sign(x_121) * (1.5708 - (sqrt((1.0 - abs(x_121))) * (1.5708 + (abs(x_121) * (-0.214602 + (abs(x_121) * (0.0865667 + (abs(x_121) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        highp float tmpvar_123;
        tmpvar_123 = (((tmpvar_79 + 1.0) / 2.0) * (RES_NU - 1.0));
        highp float tmpvar_124;
        tmpvar_124 = floor(tmpvar_123);
        highp float tmpvar_125;
        tmpvar_125 = (tmpvar_123 - tmpvar_124);
        highp float tmpvar_126;
        tmpvar_126 = (floor(((uR_112 * RES_R) - 1.0)) / RES_R);
        highp float tmpvar_127;
        tmpvar_127 = (floor((uR_112 * RES_R)) / RES_R);
        highp float tmpvar_128;
        tmpvar_128 = fract((uR_112 * RES_R));
        highp vec4 tmpvar_129;
        tmpvar_129.zw = vec2(0.0, 0.0);
        tmpvar_129.x = ((tmpvar_124 + tmpvar_122) / RES_NU);
        tmpvar_129.y = ((uMu_111 / RES_R) + tmpvar_126);
        lowp vec4 tmpvar_130;
        tmpvar_130 = texture2DLodEXT (_Inscatter, tmpvar_129.xy, 0.0);
        highp vec4 tmpvar_131;
        tmpvar_131.zw = vec2(0.0, 0.0);
        tmpvar_131.x = (((tmpvar_124 + tmpvar_122) + 1.0) / RES_NU);
        tmpvar_131.y = ((uMu_111 / RES_R) + tmpvar_126);
        lowp vec4 tmpvar_132;
        tmpvar_132 = texture2DLodEXT (_Inscatter, tmpvar_131.xy, 0.0);
        highp vec4 tmpvar_133;
        tmpvar_133.zw = vec2(0.0, 0.0);
        tmpvar_133.x = ((tmpvar_124 + tmpvar_122) / RES_NU);
        tmpvar_133.y = ((uMu_111 / RES_R) + tmpvar_127);
        lowp vec4 tmpvar_134;
        tmpvar_134 = texture2DLodEXT (_Inscatter, tmpvar_133.xy, 0.0);
        highp vec4 tmpvar_135;
        tmpvar_135.zw = vec2(0.0, 0.0);
        tmpvar_135.x = (((tmpvar_124 + tmpvar_122) + 1.0) / RES_NU);
        tmpvar_135.y = ((uMu_111 / RES_R) + tmpvar_127);
        lowp vec4 tmpvar_136;
        tmpvar_136 = texture2DLodEXT (_Inscatter, tmpvar_135.xy, 0.0);
        inScatter0_107 = ((((tmpvar_130 * (1.0 - tmpvar_125)) + (tmpvar_132 * tmpvar_125)) * (1.0 - tmpvar_128)) + (((tmpvar_134 * (1.0 - tmpvar_125)) + (tmpvar_136 * tmpvar_125)) * tmpvar_128));
        highp float uMu_137;
        highp float uR_138;
        highp float tmpvar_139;
        tmpvar_139 = sqrt(((tmpvar_68 * tmpvar_68) - (Rg * Rg)));
        highp float tmpvar_140;
        tmpvar_140 = sqrt(((tmpvar_110 * tmpvar_110) - (Rg * Rg)));
        highp float tmpvar_141;
        tmpvar_141 = (tmpvar_110 * mu1_76);
        highp float tmpvar_142;
        tmpvar_142 = (((tmpvar_141 * tmpvar_141) - (tmpvar_110 * tmpvar_110)) + (Rg * Rg));
        highp vec4 tmpvar_143;
        if (((tmpvar_141 < 0.0) && (tmpvar_142 > 0.0))) {
          highp vec4 tmpvar_144;
          tmpvar_144.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_144.w = (0.5 - (0.5 / RES_MU));
          tmpvar_143 = tmpvar_144;
        } else {
          highp vec4 tmpvar_145;
          tmpvar_145.x = -1.0;
          tmpvar_145.y = (tmpvar_139 * tmpvar_139);
          tmpvar_145.z = tmpvar_139;
          tmpvar_145.w = (0.5 + (0.5 / RES_MU));
          tmpvar_143 = tmpvar_145;
        };
        uR_138 = ((0.5 / RES_R) + ((tmpvar_140 / tmpvar_139) * (1.0 - (1.0/(RES_R)))));
        uMu_137 = (tmpvar_143.w + ((((tmpvar_141 * tmpvar_143.x) + sqrt((tmpvar_142 + tmpvar_143.y))) / (tmpvar_140 + tmpvar_143.z)) * (0.5 - (1.0/(RES_MU)))));
        highp float y_over_x_146;
        y_over_x_146 = (max (muS1_75, -0.1975) * 5.34962);
        highp float x_147;
        x_147 = (y_over_x_146 * inversesqrt(((y_over_x_146 * y_over_x_146) + 1.0)));
        highp float tmpvar_148;
        tmpvar_148 = ((0.5 / RES_MU_S) + (((((sign(x_147) * (1.5708 - (sqrt((1.0 - abs(x_147))) * (1.5708 + (abs(x_147) * (-0.214602 + (abs(x_147) * (0.0865667 + (abs(x_147) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        highp float tmpvar_149;
        tmpvar_149 = (((tmpvar_79 + 1.0) / 2.0) * (RES_NU - 1.0));
        highp float tmpvar_150;
        tmpvar_150 = floor(tmpvar_149);
        highp float tmpvar_151;
        tmpvar_151 = (tmpvar_149 - tmpvar_150);
        highp float tmpvar_152;
        tmpvar_152 = (floor(((uR_138 * RES_R) - 1.0)) / RES_R);
        highp float tmpvar_153;
        tmpvar_153 = (floor((uR_138 * RES_R)) / RES_R);
        highp float tmpvar_154;
        tmpvar_154 = fract((uR_138 * RES_R));
        highp vec4 tmpvar_155;
        tmpvar_155.zw = vec2(0.0, 0.0);
        tmpvar_155.x = ((tmpvar_150 + tmpvar_148) / RES_NU);
        tmpvar_155.y = ((uMu_137 / RES_R) + tmpvar_152);
        lowp vec4 tmpvar_156;
        tmpvar_156 = texture2DLodEXT (_Inscatter, tmpvar_155.xy, 0.0);
        highp vec4 tmpvar_157;
        tmpvar_157.zw = vec2(0.0, 0.0);
        tmpvar_157.x = (((tmpvar_150 + tmpvar_148) + 1.0) / RES_NU);
        tmpvar_157.y = ((uMu_137 / RES_R) + tmpvar_152);
        lowp vec4 tmpvar_158;
        tmpvar_158 = texture2DLodEXT (_Inscatter, tmpvar_157.xy, 0.0);
        highp vec4 tmpvar_159;
        tmpvar_159.zw = vec2(0.0, 0.0);
        tmpvar_159.x = ((tmpvar_150 + tmpvar_148) / RES_NU);
        tmpvar_159.y = ((uMu_137 / RES_R) + tmpvar_153);
        lowp vec4 tmpvar_160;
        tmpvar_160 = texture2DLodEXT (_Inscatter, tmpvar_159.xy, 0.0);
        highp vec4 tmpvar_161;
        tmpvar_161.zw = vec2(0.0, 0.0);
        tmpvar_161.x = (((tmpvar_150 + tmpvar_148) + 1.0) / RES_NU);
        tmpvar_161.y = ((uMu_137 / RES_R) + tmpvar_153);
        lowp vec4 tmpvar_162;
        tmpvar_162 = texture2DLodEXT (_Inscatter, tmpvar_161.xy, 0.0);
        inScatterA_106 = max ((inScatter0_107 - (((((tmpvar_156 * (1.0 - tmpvar_151)) + (tmpvar_158 * tmpvar_151)) * (1.0 - tmpvar_154)) + (((tmpvar_160 * (1.0 - tmpvar_151)) + (tmpvar_162 * tmpvar_151)) * tmpvar_154)) * extinction_58.xyzx)), vec4(0.0, 0.0, 0.0, 0.0));
        highp float tmpvar_163;
        tmpvar_163 = (tmpvar_104 + 0.004);
        mu_59 = tmpvar_163;
        highp float tmpvar_164;
        tmpvar_164 = sqrt((((r_61 * r_61) + (d_62 * d_62)) + (((2.0 * r_61) * d_62) * tmpvar_163)));
        r1_77 = tmpvar_164;
        mu1_76 = (((r_61 * tmpvar_163) + d_62) / tmpvar_164);
        highp float uMu_165;
        highp float uR_166;
        highp float tmpvar_167;
        tmpvar_167 = sqrt(((tmpvar_68 * tmpvar_68) - (Rg * Rg)));
        highp float tmpvar_168;
        tmpvar_168 = sqrt(((r_61 * r_61) - (Rg * Rg)));
        highp float tmpvar_169;
        tmpvar_169 = (r_61 * tmpvar_163);
        highp float tmpvar_170;
        tmpvar_170 = (((tmpvar_169 * tmpvar_169) - (r_61 * r_61)) + (Rg * Rg));
        highp vec4 tmpvar_171;
        if (((tmpvar_169 < 0.0) && (tmpvar_170 > 0.0))) {
          highp vec4 tmpvar_172;
          tmpvar_172.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_172.w = (0.5 - (0.5 / RES_MU));
          tmpvar_171 = tmpvar_172;
        } else {
          highp vec4 tmpvar_173;
          tmpvar_173.x = -1.0;
          tmpvar_173.y = (tmpvar_167 * tmpvar_167);
          tmpvar_173.z = tmpvar_167;
          tmpvar_173.w = (0.5 + (0.5 / RES_MU));
          tmpvar_171 = tmpvar_173;
        };
        uR_166 = ((0.5 / RES_R) + ((tmpvar_168 / tmpvar_167) * (1.0 - (1.0/(RES_R)))));
        uMu_165 = (tmpvar_171.w + ((((tmpvar_169 * tmpvar_171.x) + sqrt((tmpvar_170 + tmpvar_171.y))) / (tmpvar_168 + tmpvar_171.z)) * (0.5 - (1.0/(RES_MU)))));
        highp float y_over_x_174;
        y_over_x_174 = (max (tmpvar_80, -0.1975) * 5.34962);
        highp float x_175;
        x_175 = (y_over_x_174 * inversesqrt(((y_over_x_174 * y_over_x_174) + 1.0)));
        highp float tmpvar_176;
        tmpvar_176 = ((0.5 / RES_MU_S) + (((((sign(x_175) * (1.5708 - (sqrt((1.0 - abs(x_175))) * (1.5708 + (abs(x_175) * (-0.214602 + (abs(x_175) * (0.0865667 + (abs(x_175) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        highp float tmpvar_177;
        tmpvar_177 = (((tmpvar_79 + 1.0) / 2.0) * (RES_NU - 1.0));
        highp float tmpvar_178;
        tmpvar_178 = floor(tmpvar_177);
        highp float tmpvar_179;
        tmpvar_179 = (tmpvar_177 - tmpvar_178);
        highp float tmpvar_180;
        tmpvar_180 = (floor(((uR_166 * RES_R) - 1.0)) / RES_R);
        highp float tmpvar_181;
        tmpvar_181 = (floor((uR_166 * RES_R)) / RES_R);
        highp float tmpvar_182;
        tmpvar_182 = fract((uR_166 * RES_R));
        highp vec4 tmpvar_183;
        tmpvar_183.zw = vec2(0.0, 0.0);
        tmpvar_183.x = ((tmpvar_178 + tmpvar_176) / RES_NU);
        tmpvar_183.y = ((uMu_165 / RES_R) + tmpvar_180);
        lowp vec4 tmpvar_184;
        tmpvar_184 = texture2DLodEXT (_Inscatter, tmpvar_183.xy, 0.0);
        highp vec4 tmpvar_185;
        tmpvar_185.zw = vec2(0.0, 0.0);
        tmpvar_185.x = (((tmpvar_178 + tmpvar_176) + 1.0) / RES_NU);
        tmpvar_185.y = ((uMu_165 / RES_R) + tmpvar_180);
        lowp vec4 tmpvar_186;
        tmpvar_186 = texture2DLodEXT (_Inscatter, tmpvar_185.xy, 0.0);
        highp vec4 tmpvar_187;
        tmpvar_187.zw = vec2(0.0, 0.0);
        tmpvar_187.x = ((tmpvar_178 + tmpvar_176) / RES_NU);
        tmpvar_187.y = ((uMu_165 / RES_R) + tmpvar_181);
        lowp vec4 tmpvar_188;
        tmpvar_188 = texture2DLodEXT (_Inscatter, tmpvar_187.xy, 0.0);
        highp vec4 tmpvar_189;
        tmpvar_189.zw = vec2(0.0, 0.0);
        tmpvar_189.x = (((tmpvar_178 + tmpvar_176) + 1.0) / RES_NU);
        tmpvar_189.y = ((uMu_165 / RES_R) + tmpvar_181);
        lowp vec4 tmpvar_190;
        tmpvar_190 = texture2DLodEXT (_Inscatter, tmpvar_189.xy, 0.0);
        inScatter0_107 = ((((tmpvar_184 * (1.0 - tmpvar_179)) + (tmpvar_186 * tmpvar_179)) * (1.0 - tmpvar_182)) + (((tmpvar_188 * (1.0 - tmpvar_179)) + (tmpvar_190 * tmpvar_179)) * tmpvar_182));
        highp float uMu_191;
        highp float uR_192;
        highp float tmpvar_193;
        tmpvar_193 = sqrt(((tmpvar_68 * tmpvar_68) - (Rg * Rg)));
        highp float tmpvar_194;
        tmpvar_194 = sqrt(((tmpvar_164 * tmpvar_164) - (Rg * Rg)));
        highp float tmpvar_195;
        tmpvar_195 = (tmpvar_164 * mu1_76);
        highp float tmpvar_196;
        tmpvar_196 = (((tmpvar_195 * tmpvar_195) - (tmpvar_164 * tmpvar_164)) + (Rg * Rg));
        highp vec4 tmpvar_197;
        if (((tmpvar_195 < 0.0) && (tmpvar_196 > 0.0))) {
          highp vec4 tmpvar_198;
          tmpvar_198.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_198.w = (0.5 - (0.5 / RES_MU));
          tmpvar_197 = tmpvar_198;
        } else {
          highp vec4 tmpvar_199;
          tmpvar_199.x = -1.0;
          tmpvar_199.y = (tmpvar_193 * tmpvar_193);
          tmpvar_199.z = tmpvar_193;
          tmpvar_199.w = (0.5 + (0.5 / RES_MU));
          tmpvar_197 = tmpvar_199;
        };
        uR_192 = ((0.5 / RES_R) + ((tmpvar_194 / tmpvar_193) * (1.0 - (1.0/(RES_R)))));
        uMu_191 = (tmpvar_197.w + ((((tmpvar_195 * tmpvar_197.x) + sqrt((tmpvar_196 + tmpvar_197.y))) / (tmpvar_194 + tmpvar_197.z)) * (0.5 - (1.0/(RES_MU)))));
        highp float y_over_x_200;
        y_over_x_200 = (max (muS1_75, -0.1975) * 5.34962);
        highp float x_201;
        x_201 = (y_over_x_200 * inversesqrt(((y_over_x_200 * y_over_x_200) + 1.0)));
        highp float tmpvar_202;
        tmpvar_202 = ((0.5 / RES_MU_S) + (((((sign(x_201) * (1.5708 - (sqrt((1.0 - abs(x_201))) * (1.5708 + (abs(x_201) * (-0.214602 + (abs(x_201) * (0.0865667 + (abs(x_201) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        highp float tmpvar_203;
        tmpvar_203 = (((tmpvar_79 + 1.0) / 2.0) * (RES_NU - 1.0));
        highp float tmpvar_204;
        tmpvar_204 = floor(tmpvar_203);
        highp float tmpvar_205;
        tmpvar_205 = (tmpvar_203 - tmpvar_204);
        highp float tmpvar_206;
        tmpvar_206 = (floor(((uR_192 * RES_R) - 1.0)) / RES_R);
        highp float tmpvar_207;
        tmpvar_207 = (floor((uR_192 * RES_R)) / RES_R);
        highp float tmpvar_208;
        tmpvar_208 = fract((uR_192 * RES_R));
        highp vec4 tmpvar_209;
        tmpvar_209.zw = vec2(0.0, 0.0);
        tmpvar_209.x = ((tmpvar_204 + tmpvar_202) / RES_NU);
        tmpvar_209.y = ((uMu_191 / RES_R) + tmpvar_206);
        lowp vec4 tmpvar_210;
        tmpvar_210 = texture2DLodEXT (_Inscatter, tmpvar_209.xy, 0.0);
        highp vec4 tmpvar_211;
        tmpvar_211.zw = vec2(0.0, 0.0);
        tmpvar_211.x = (((tmpvar_204 + tmpvar_202) + 1.0) / RES_NU);
        tmpvar_211.y = ((uMu_191 / RES_R) + tmpvar_206);
        lowp vec4 tmpvar_212;
        tmpvar_212 = texture2DLodEXT (_Inscatter, tmpvar_211.xy, 0.0);
        highp vec4 tmpvar_213;
        tmpvar_213.zw = vec2(0.0, 0.0);
        tmpvar_213.x = ((tmpvar_204 + tmpvar_202) / RES_NU);
        tmpvar_213.y = ((uMu_191 / RES_R) + tmpvar_207);
        lowp vec4 tmpvar_214;
        tmpvar_214 = texture2DLodEXT (_Inscatter, tmpvar_213.xy, 0.0);
        highp vec4 tmpvar_215;
        tmpvar_215.zw = vec2(0.0, 0.0);
        tmpvar_215.x = (((tmpvar_204 + tmpvar_202) + 1.0) / RES_NU);
        tmpvar_215.y = ((uMu_191 / RES_R) + tmpvar_207);
        lowp vec4 tmpvar_216;
        tmpvar_216 = texture2DLodEXT (_Inscatter, tmpvar_215.xy, 0.0);
        inScatter_78 = mix (inScatterA_106, max ((inScatter0_107 - (((((tmpvar_210 * (1.0 - tmpvar_205)) + (tmpvar_212 * tmpvar_205)) * (1.0 - tmpvar_208)) + (((tmpvar_214 * (1.0 - tmpvar_205)) + (tmpvar_216 * tmpvar_205)) * tmpvar_208)) * extinction_58.xyzx)), vec4(0.0, 0.0, 0.0, 0.0)), vec4(a_108));
      } else {
        highp vec4 inScatter0_1_217;
        highp float uMu_218;
        highp float uR_219;
        highp float tmpvar_220;
        tmpvar_220 = sqrt(((tmpvar_68 * tmpvar_68) - (Rg * Rg)));
        highp float tmpvar_221;
        tmpvar_221 = sqrt(((r_61 * r_61) - (Rg * Rg)));
        highp float tmpvar_222;
        tmpvar_222 = (r_61 * mu_59);
        highp float tmpvar_223;
        tmpvar_223 = (((tmpvar_222 * tmpvar_222) - (r_61 * r_61)) + (Rg * Rg));
        highp vec4 tmpvar_224;
        if (((tmpvar_222 < 0.0) && (tmpvar_223 > 0.0))) {
          highp vec4 tmpvar_225;
          tmpvar_225.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_225.w = (0.5 - (0.5 / RES_MU));
          tmpvar_224 = tmpvar_225;
        } else {
          highp vec4 tmpvar_226;
          tmpvar_226.x = -1.0;
          tmpvar_226.y = (tmpvar_220 * tmpvar_220);
          tmpvar_226.z = tmpvar_220;
          tmpvar_226.w = (0.5 + (0.5 / RES_MU));
          tmpvar_224 = tmpvar_226;
        };
        uR_219 = ((0.5 / RES_R) + ((tmpvar_221 / tmpvar_220) * (1.0 - (1.0/(RES_R)))));
        uMu_218 = (tmpvar_224.w + ((((tmpvar_222 * tmpvar_224.x) + sqrt((tmpvar_223 + tmpvar_224.y))) / (tmpvar_221 + tmpvar_224.z)) * (0.5 - (1.0/(RES_MU)))));
        highp float y_over_x_227;
        y_over_x_227 = (max (tmpvar_80, -0.1975) * 5.34962);
        highp float x_228;
        x_228 = (y_over_x_227 * inversesqrt(((y_over_x_227 * y_over_x_227) + 1.0)));
        highp float tmpvar_229;
        tmpvar_229 = ((0.5 / RES_MU_S) + (((((sign(x_228) * (1.5708 - (sqrt((1.0 - abs(x_228))) * (1.5708 + (abs(x_228) * (-0.214602 + (abs(x_228) * (0.0865667 + (abs(x_228) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        highp float tmpvar_230;
        tmpvar_230 = (((tmpvar_79 + 1.0) / 2.0) * (RES_NU - 1.0));
        highp float tmpvar_231;
        tmpvar_231 = floor(tmpvar_230);
        highp float tmpvar_232;
        tmpvar_232 = (tmpvar_230 - tmpvar_231);
        highp float tmpvar_233;
        tmpvar_233 = (floor(((uR_219 * RES_R) - 1.0)) / RES_R);
        highp float tmpvar_234;
        tmpvar_234 = (floor((uR_219 * RES_R)) / RES_R);
        highp float tmpvar_235;
        tmpvar_235 = fract((uR_219 * RES_R));
        highp vec4 tmpvar_236;
        tmpvar_236.zw = vec2(0.0, 0.0);
        tmpvar_236.x = ((tmpvar_231 + tmpvar_229) / RES_NU);
        tmpvar_236.y = ((uMu_218 / RES_R) + tmpvar_233);
        lowp vec4 tmpvar_237;
        tmpvar_237 = texture2DLodEXT (_Inscatter, tmpvar_236.xy, 0.0);
        highp vec4 tmpvar_238;
        tmpvar_238.zw = vec2(0.0, 0.0);
        tmpvar_238.x = (((tmpvar_231 + tmpvar_229) + 1.0) / RES_NU);
        tmpvar_238.y = ((uMu_218 / RES_R) + tmpvar_233);
        lowp vec4 tmpvar_239;
        tmpvar_239 = texture2DLodEXT (_Inscatter, tmpvar_238.xy, 0.0);
        highp vec4 tmpvar_240;
        tmpvar_240.zw = vec2(0.0, 0.0);
        tmpvar_240.x = ((tmpvar_231 + tmpvar_229) / RES_NU);
        tmpvar_240.y = ((uMu_218 / RES_R) + tmpvar_234);
        lowp vec4 tmpvar_241;
        tmpvar_241 = texture2DLodEXT (_Inscatter, tmpvar_240.xy, 0.0);
        highp vec4 tmpvar_242;
        tmpvar_242.zw = vec2(0.0, 0.0);
        tmpvar_242.x = (((tmpvar_231 + tmpvar_229) + 1.0) / RES_NU);
        tmpvar_242.y = ((uMu_218 / RES_R) + tmpvar_234);
        lowp vec4 tmpvar_243;
        tmpvar_243 = texture2DLodEXT (_Inscatter, tmpvar_242.xy, 0.0);
        inScatter0_1_217 = ((((tmpvar_237 * (1.0 - tmpvar_232)) + (tmpvar_239 * tmpvar_232)) * (1.0 - tmpvar_235)) + (((tmpvar_241 * (1.0 - tmpvar_232)) + (tmpvar_243 * tmpvar_232)) * tmpvar_235));
        highp float uMu_244;
        highp float uR_245;
        highp float tmpvar_246;
        tmpvar_246 = sqrt(((tmpvar_68 * tmpvar_68) - (Rg * Rg)));
        highp float tmpvar_247;
        tmpvar_247 = sqrt(((r1_77 * r1_77) - (Rg * Rg)));
        highp float tmpvar_248;
        tmpvar_248 = (r1_77 * mu1_76);
        highp float tmpvar_249;
        tmpvar_249 = (((tmpvar_248 * tmpvar_248) - (r1_77 * r1_77)) + (Rg * Rg));
        highp vec4 tmpvar_250;
        if (((tmpvar_248 < 0.0) && (tmpvar_249 > 0.0))) {
          highp vec4 tmpvar_251;
          tmpvar_251.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_251.w = (0.5 - (0.5 / RES_MU));
          tmpvar_250 = tmpvar_251;
        } else {
          highp vec4 tmpvar_252;
          tmpvar_252.x = -1.0;
          tmpvar_252.y = (tmpvar_246 * tmpvar_246);
          tmpvar_252.z = tmpvar_246;
          tmpvar_252.w = (0.5 + (0.5 / RES_MU));
          tmpvar_250 = tmpvar_252;
        };
        uR_245 = ((0.5 / RES_R) + ((tmpvar_247 / tmpvar_246) * (1.0 - (1.0/(RES_R)))));
        uMu_244 = (tmpvar_250.w + ((((tmpvar_248 * tmpvar_250.x) + sqrt((tmpvar_249 + tmpvar_250.y))) / (tmpvar_247 + tmpvar_250.z)) * (0.5 - (1.0/(RES_MU)))));
        highp float y_over_x_253;
        y_over_x_253 = (max (muS1_75, -0.1975) * 5.34962);
        highp float x_254;
        x_254 = (y_over_x_253 * inversesqrt(((y_over_x_253 * y_over_x_253) + 1.0)));
        highp float tmpvar_255;
        tmpvar_255 = ((0.5 / RES_MU_S) + (((((sign(x_254) * (1.5708 - (sqrt((1.0 - abs(x_254))) * (1.5708 + (abs(x_254) * (-0.214602 + (abs(x_254) * (0.0865667 + (abs(x_254) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        highp float tmpvar_256;
        tmpvar_256 = (((tmpvar_79 + 1.0) / 2.0) * (RES_NU - 1.0));
        highp float tmpvar_257;
        tmpvar_257 = floor(tmpvar_256);
        highp float tmpvar_258;
        tmpvar_258 = (tmpvar_256 - tmpvar_257);
        highp float tmpvar_259;
        tmpvar_259 = (floor(((uR_245 * RES_R) - 1.0)) / RES_R);
        highp float tmpvar_260;
        tmpvar_260 = (floor((uR_245 * RES_R)) / RES_R);
        highp float tmpvar_261;
        tmpvar_261 = fract((uR_245 * RES_R));
        highp vec4 tmpvar_262;
        tmpvar_262.zw = vec2(0.0, 0.0);
        tmpvar_262.x = ((tmpvar_257 + tmpvar_255) / RES_NU);
        tmpvar_262.y = ((uMu_244 / RES_R) + tmpvar_259);
        lowp vec4 tmpvar_263;
        tmpvar_263 = texture2DLodEXT (_Inscatter, tmpvar_262.xy, 0.0);
        highp vec4 tmpvar_264;
        tmpvar_264.zw = vec2(0.0, 0.0);
        tmpvar_264.x = (((tmpvar_257 + tmpvar_255) + 1.0) / RES_NU);
        tmpvar_264.y = ((uMu_244 / RES_R) + tmpvar_259);
        lowp vec4 tmpvar_265;
        tmpvar_265 = texture2DLodEXT (_Inscatter, tmpvar_264.xy, 0.0);
        highp vec4 tmpvar_266;
        tmpvar_266.zw = vec2(0.0, 0.0);
        tmpvar_266.x = ((tmpvar_257 + tmpvar_255) / RES_NU);
        tmpvar_266.y = ((uMu_244 / RES_R) + tmpvar_260);
        lowp vec4 tmpvar_267;
        tmpvar_267 = texture2DLodEXT (_Inscatter, tmpvar_266.xy, 0.0);
        highp vec4 tmpvar_268;
        tmpvar_268.zw = vec2(0.0, 0.0);
        tmpvar_268.x = (((tmpvar_257 + tmpvar_255) + 1.0) / RES_NU);
        tmpvar_268.y = ((uMu_244 / RES_R) + tmpvar_260);
        lowp vec4 tmpvar_269;
        tmpvar_269 = texture2DLodEXT (_Inscatter, tmpvar_268.xy, 0.0);
        inScatter_78 = max ((inScatter0_1_217 - (((((tmpvar_263 * (1.0 - tmpvar_258)) + (tmpvar_265 * tmpvar_258)) * (1.0 - tmpvar_261)) + (((tmpvar_267 * (1.0 - tmpvar_258)) + (tmpvar_269 * tmpvar_258)) * tmpvar_261)) * extinction_58.xyzx)), vec4(0.0, 0.0, 0.0, 0.0));
      };
      highp float t_270;
      t_270 = max (min ((tmpvar_80 / 0.02), 1.0), 0.0);
      inScatter_78.w = (inScatter_78.w * (t_270 * (t_270 * (3.0 - (2.0 * t_270)))));
      result_64 = ((inScatter_78.xyz * ((3.0 / (16.0 * M_PI)) * (1.0 + (tmpvar_79 * tmpvar_79)))) + ((((inScatter_78.xyz * inScatter_78.w) / max (inScatter_78.x, 0.0001)) * (betaR.x / betaR)) * (((((1.5 / (4.0 * M_PI)) * (1.0 - (mieG * mieG))) * pow (((1.0 + (mieG * mieG)) - ((2.0 * mieG) * tmpvar_79)), -1.5)) * (1.0 + (tmpvar_79 * tmpvar_79))) / (2.0 + (mieG * mieG)))));
    };
    tmpvar_55 = (result_64 * SUN_INTENSITY);
    visib_2 = 1.0;
    highp float tmpvar_271;
    highp vec3 arg0_272;
    arg0_272 = (worldPos_4 - _camPos);
    tmpvar_271 = sqrt(dot (arg0_272, arg0_272));
    if ((tmpvar_271 <= _global_depth)) {
      visib_2 = (1.0 - exp((-1.0 * ((4.0 * tmpvar_271) / _global_depth))));
    };
    if (((tmpvar_15 && tmpvar_20) && (fakeOcean == 1.0))) {
      highp vec3 L_273;
      L_273 = (oceanColor_3 * extinction_58);
      highp vec3 tmpvar_274;
      tmpvar_274 = (L_273 * _Exposure);
      L_273 = tmpvar_274;
      highp float tmpvar_275;
      if ((tmpvar_274.x < 1.413)) {
        tmpvar_275 = pow ((tmpvar_274.x * 0.38317), 0.454545);
      } else {
        tmpvar_275 = (1.0 - exp(-(tmpvar_274.x)));
      };
      L_273.x = tmpvar_275;
      highp float tmpvar_276;
      if ((tmpvar_274.y < 1.413)) {
        tmpvar_276 = pow ((tmpvar_274.y * 0.38317), 0.454545);
      } else {
        tmpvar_276 = (1.0 - exp(-(tmpvar_274.y)));
      };
      L_273.y = tmpvar_276;
      highp float tmpvar_277;
      if ((tmpvar_274.z < 1.413)) {
        tmpvar_277 = pow ((tmpvar_274.z * 0.38317), 0.454545);
      } else {
        tmpvar_277 = (1.0 - exp(-(tmpvar_274.z)));
      };
      L_273.z = tmpvar_277;
      highp vec3 L_278;
      highp vec3 tmpvar_279;
      tmpvar_279 = (tmpvar_55 * _Exposure);
      L_278 = tmpvar_279;
      highp float tmpvar_280;
      if ((tmpvar_279.x < 1.413)) {
        tmpvar_280 = pow ((tmpvar_279.x * 0.38317), 0.454545);
      } else {
        tmpvar_280 = (1.0 - exp(-(tmpvar_279.x)));
      };
      L_278.x = tmpvar_280;
      highp float tmpvar_281;
      if ((tmpvar_279.y < 1.413)) {
        tmpvar_281 = pow ((tmpvar_279.y * 0.38317), 0.454545);
      } else {
        tmpvar_281 = (1.0 - exp(-(tmpvar_279.y)));
      };
      L_278.y = tmpvar_281;
      highp float tmpvar_282;
      if ((tmpvar_279.z < 1.413)) {
        tmpvar_282 = pow ((tmpvar_279.z * 0.38317), 0.454545);
      } else {
        tmpvar_282 = (1.0 - exp(-(tmpvar_279.z)));
      };
      L_278.z = tmpvar_282;
      highp vec4 tmpvar_283;
      tmpvar_283.xyz = mix (L_273, L_278, vec3((_global_alpha * visib_2)));
      tmpvar_283.w = _fade;
      tmpvar_1 = tmpvar_283;
    } else {
      highp vec3 L_284;
      highp vec3 tmpvar_285;
      tmpvar_285 = (tmpvar_55 * _Exposure);
      L_284 = tmpvar_285;
      highp float tmpvar_286;
      if ((tmpvar_285.x < 1.413)) {
        tmpvar_286 = pow ((tmpvar_285.x * 0.38317), 0.454545);
      } else {
        tmpvar_286 = (1.0 - exp(-(tmpvar_285.x)));
      };
      L_284.x = tmpvar_286;
      highp float tmpvar_287;
      if ((tmpvar_285.y < 1.413)) {
        tmpvar_287 = pow ((tmpvar_285.y * 0.38317), 0.454545);
      } else {
        tmpvar_287 = (1.0 - exp(-(tmpvar_285.y)));
      };
      L_284.y = tmpvar_287;
      highp float tmpvar_288;
      if ((tmpvar_285.z < 1.413)) {
        tmpvar_288 = pow ((tmpvar_285.z * 0.38317), 0.454545);
      } else {
        tmpvar_288 = (1.0 - exp(-(tmpvar_285.z)));
      };
      L_284.z = tmpvar_288;
      highp vec4 tmpvar_289;
      tmpvar_289.xyz = L_284;
      tmpvar_289.w = ((_global_alpha * visib_2) * _fade);
      tmpvar_1 = tmpvar_289;
    };
  };
  gl_FragData[0] = tmpvar_1;
}



#endif"
}
SubProgram "glesdesktop " {
"!!GLES


#ifdef VERTEX

attribute vec4 _glesVertex;
uniform highp vec4 _ProjectionParams;
uniform highp mat4 glstate_matrix_mvp;
uniform highp mat4 glstate_matrix_modelview0;
varying highp vec4 xlv_TEXCOORD0;
varying highp vec2 xlv_TEXCOORD1;
varying highp vec2 xlv_TEXCOORD2;
void main ()
{
  highp vec4 tmpvar_1;
  highp vec4 tmpvar_2;
  tmpvar_2 = (glstate_matrix_mvp * _glesVertex);
  highp vec4 o_3;
  highp vec4 tmpvar_4;
  tmpvar_4 = (tmpvar_2 * 0.5);
  highp vec2 tmpvar_5;
  tmpvar_5.x = tmpvar_4.x;
  tmpvar_5.y = (tmpvar_4.y * _ProjectionParams.x);
  o_3.xy = (tmpvar_5 + tmpvar_4.w);
  o_3.zw = tmpvar_2.zw;
  tmpvar_1.xyw = o_3.xyw;
  highp vec2 tmpvar_6;
  tmpvar_6 = (o_3.xy / tmpvar_2.w);
  tmpvar_1.z = -((glstate_matrix_modelview0 * _glesVertex).z);
  gl_Position = tmpvar_2;
  xlv_TEXCOORD0 = tmpvar_1;
  xlv_TEXCOORD1 = tmpvar_6;
  xlv_TEXCOORD2 = tmpvar_6;
}



#endif
#ifdef FRAGMENT

#extension GL_EXT_shader_texture_lod : enable
uniform sampler2D _Transmittance;
uniform sampler2D _Inscatter;
uniform sampler2D _Irradiance;
uniform highp float M_PI;
uniform highp float Rg;
uniform highp float Rt;
uniform highp float RES_R;
uniform highp float RES_MU;
uniform highp float RES_MU_S;
uniform highp float RES_NU;
uniform highp vec3 SUN_DIR;
uniform highp float SUN_INTENSITY;
uniform highp vec3 betaR;
uniform highp float mieG;
uniform highp mat4 _ViewProjInv;
uniform highp float _viewdirOffset;
uniform highp float _experimentalAtmoScale;
uniform highp float _global_alpha;
uniform highp float _Exposure;
uniform highp float _global_depth;
uniform highp float _Ocean_Sigma;
uniform highp float fakeOcean;
uniform highp float _fade;
uniform highp vec3 _Ocean_Color;
uniform highp vec3 _camPos;
uniform sampler2D _customDepthTexture;
uniform highp float _openglThreshold;
varying highp vec2 xlv_TEXCOORD2;
void main ()
{
  mediump vec4 tmpvar_1;
  highp float visib_2;
  highp vec3 oceanColor_3;
  highp vec3 worldPos_4;
  highp float depth_5;
  lowp float tmpvar_6;
  tmpvar_6 = texture2D (_customDepthTexture, xlv_TEXCOORD2).x;
  depth_5 = tmpvar_6;
  highp vec4 tmpvar_7;
  tmpvar_7.w = 1.0;
  tmpvar_7.x = ((xlv_TEXCOORD2.x * 2.0) - 1.0);
  tmpvar_7.y = ((xlv_TEXCOORD2.y * 2.0) - 1.0);
  tmpvar_7.z = depth_5;
  highp vec4 tmpvar_8;
  tmpvar_8 = (_ViewProjInv * tmpvar_7);
  highp vec3 tmpvar_9;
  tmpvar_9 = (tmpvar_8 / tmpvar_8.w).xyz;
  worldPos_4 = tmpvar_9;
  highp float tmpvar_10;
  highp vec3 tmpvar_11;
  tmpvar_11 = (tmpvar_9 - _camPos);
  highp float tmpvar_12;
  tmpvar_12 = dot (tmpvar_11, tmpvar_11);
  highp float tmpvar_13;
  tmpvar_13 = (2.0 * dot (tmpvar_11, _camPos));
  highp float tmpvar_14;
  tmpvar_14 = ((tmpvar_13 * tmpvar_13) - ((4.0 * tmpvar_12) * (dot (_camPos, _camPos) - (Rg * Rg))));
  if ((tmpvar_14 < 0.0)) {
    tmpvar_10 = -1.0;
  } else {
    tmpvar_10 = ((-(tmpvar_13) - sqrt(tmpvar_14)) / (2.0 * tmpvar_12));
  };
  bool tmpvar_15;
  tmpvar_15 = (tmpvar_10 > 0.0);
  bool tmpvar_16;
  tmpvar_16 = (sqrt(dot (tmpvar_9, tmpvar_9)) >= Rt);
  if ((!(tmpvar_15) && tmpvar_16)) {
    tmpvar_1 = vec4(0.0, 0.0, 0.0, 0.0);
  } else {
    highp vec3 tmpvar_17;
    tmpvar_17 = (_camPos + (tmpvar_10 * (tmpvar_9 - _camPos)));
    highp vec3 arg0_18;
    arg0_18 = (tmpvar_17 - _camPos);
    highp vec3 arg0_19;
    arg0_19 = (tmpvar_9 - _camPos);
    bool tmpvar_20;
    tmpvar_20 = (sqrt(dot (arg0_18, arg0_18)) < sqrt(dot (arg0_19, arg0_19)));
    oceanColor_3 = vec3(1.0, 1.0, 1.0);
    if ((tmpvar_15 && tmpvar_20)) {
      worldPos_4 = tmpvar_17;
      if ((fakeOcean == 1.0)) {
        highp vec3 tmpvar_21;
        tmpvar_21 = normalize(tmpvar_17);
        highp vec3 tmpvar_22;
        tmpvar_22 = (tmpvar_21 * max (sqrt(dot (tmpvar_17, tmpvar_17)), Rg));
        highp vec3 tmpvar_23;
        tmpvar_23 = normalize((tmpvar_22 - _camPos));
        highp vec3 worldP_24;
        worldP_24 = tmpvar_22;
        highp float r_25;
        highp float tmpvar_26;
        tmpvar_26 = sqrt(dot (tmpvar_22, tmpvar_22));
        r_25 = tmpvar_26;
        if ((tmpvar_26 < (0.9 * Rg))) {
          worldP_24.z = (tmpvar_22.z + Rg);
          r_25 = sqrt(dot (worldP_24, worldP_24));
        };
        highp vec3 tmpvar_27;
        tmpvar_27 = (worldP_24 / r_25);
        highp float tmpvar_28;
        tmpvar_28 = dot (tmpvar_27, SUN_DIR);
        highp float tmpvar_29;
        tmpvar_29 = sqrt((1.0 - ((Rg / r_25) * (Rg / r_25))));
        highp vec3 tmpvar_30;
        if ((tmpvar_28 < -(tmpvar_29))) {
          tmpvar_30 = vec3(0.0, 0.0, 0.0);
        } else {
          highp vec3 tmpvar_31;
          highp float y_over_x_32;
          y_over_x_32 = (((tmpvar_28 + 0.15) / 1.15) * 14.1014);
          highp float x_33;
          x_33 = (y_over_x_32 * inversesqrt(((y_over_x_32 * y_over_x_32) + 1.0)));
          highp vec4 tmpvar_34;
          tmpvar_34.zw = vec2(0.0, 0.0);
          tmpvar_34.x = ((sign(x_33) * (1.5708 - (sqrt((1.0 - abs(x_33))) * (1.5708 + (abs(x_33) * (-0.214602 + (abs(x_33) * (0.0865667 + (abs(x_33) * -0.0310296))))))))) / 1.5);
          tmpvar_34.y = sqrt(((r_25 - Rg) / (Rt - Rg)));
          lowp vec4 tmpvar_35;
          tmpvar_35 = texture2DLodEXT (_Transmittance, tmpvar_34.xy, 0.0);
          tmpvar_31 = tmpvar_35.xyz;
          tmpvar_30 = tmpvar_31;
        };
        highp vec3 tmpvar_36;
        tmpvar_36 = (tmpvar_30 * SUN_INTENSITY);
        highp vec3 tmpvar_37;
        highp vec2 tmpvar_38;
        tmpvar_38.x = ((tmpvar_28 + 0.2) / 1.2);
        tmpvar_38.y = ((r_25 - Rg) / (Rt - Rg));
        lowp vec4 tmpvar_39;
        tmpvar_39 = texture2DLodEXT (_Irradiance, tmpvar_38, 0.0);
        tmpvar_37 = tmpvar_39.xyz;
        highp vec3 tmpvar_40;
        tmpvar_40 = (((2.0 * tmpvar_37) * SUN_INTENSITY) * ((1.0 + tmpvar_27.z) * 0.5));
        highp vec3 V_41;
        V_41 = -(tmpvar_23);
        highp vec3 seaColor_42;
        seaColor_42 = (_Ocean_Color * 10.0);
        highp float tmpvar_43;
        tmpvar_43 = sqrt(_Ocean_Sigma);
        highp float tmpvar_44;
        tmpvar_44 = (pow ((1.0 - dot (V_41, tmpvar_21)), (5.0 * exp((-2.69 * tmpvar_43)))) / (1.0 + (22.7 * pow (tmpvar_43, 1.5))));
        highp vec3 tmpvar_45;
        tmpvar_45 = normalize((SUN_DIR + V_41));
        highp float tmpvar_46;
        tmpvar_46 = dot (tmpvar_45, tmpvar_21);
        highp float tmpvar_47;
        tmpvar_47 = (exp(((-2.0 * ((1.0 - (tmpvar_46 * tmpvar_46)) / _Ocean_Sigma)) / (1.0 + tmpvar_46))) / ((4.0 * M_PI) * _Ocean_Sigma));
        highp float tmpvar_48;
        tmpvar_48 = (1.0 - dot (V_41, tmpvar_45));
        highp float tmpvar_49;
        tmpvar_49 = (tmpvar_48 * tmpvar_48);
        highp float tmpvar_50;
        tmpvar_50 = (0.02 + (((0.98 * tmpvar_49) * tmpvar_49) * tmpvar_48));
        highp float tmpvar_51;
        tmpvar_51 = max (dot (SUN_DIR, tmpvar_21), 0.01);
        highp float tmpvar_52;
        tmpvar_52 = max (dot (V_41, tmpvar_21), 0.01);
        highp float tmpvar_53;
        if ((tmpvar_51 <= 0.0)) {
          tmpvar_53 = 0.0;
        } else {
          tmpvar_53 = max (((tmpvar_50 * tmpvar_47) * sqrt(abs((tmpvar_51 / tmpvar_52)))), 0.0);
        };
        oceanColor_3 = (((tmpvar_53 * tmpvar_36) + ((tmpvar_40 * tmpvar_44) / M_PI)) + ((((1.0 - tmpvar_44) * seaColor_42) * tmpvar_40) / M_PI));
      };
    };
    highp float tmpvar_54;
    tmpvar_54 = sqrt(dot (worldPos_4, worldPos_4));
    if ((tmpvar_54 < (Rg + _openglThreshold))) {
      worldPos_4 = ((Rg + _openglThreshold) * normalize(worldPos_4));
    };
    highp vec3 tmpvar_55;
    highp vec3 camera_56;
    camera_56 = _camPos;
    highp vec3 _point_57;
    _point_57 = worldPos_4;
    highp vec3 extinction_58;
    highp float mu_59;
    highp float rMu_60;
    highp float r_61;
    highp float d_62;
    highp vec3 viewdir_63;
    highp vec3 result_64;
    result_64 = vec3(0.0, 0.0, 0.0);
    extinction_58 = vec3(1.0, 1.0, 1.0);
    highp vec3 tmpvar_65;
    tmpvar_65 = (worldPos_4 - _camPos);
    highp float tmpvar_66;
    tmpvar_66 = sqrt(dot (tmpvar_65, tmpvar_65));
    d_62 = tmpvar_66;
    highp vec3 tmpvar_67;
    tmpvar_67 = (tmpvar_65 / tmpvar_66);
    viewdir_63.yz = tmpvar_67.yz;
    highp float tmpvar_68;
    tmpvar_68 = (Rg + ((Rt - Rg) * _experimentalAtmoScale));
    viewdir_63.x = (tmpvar_67.x + _viewdirOffset);
    highp vec3 tmpvar_69;
    tmpvar_69 = normalize(viewdir_63);
    viewdir_63 = tmpvar_69;
    highp float tmpvar_70;
    tmpvar_70 = sqrt(dot (_camPos, _camPos));
    r_61 = tmpvar_70;
    if ((tmpvar_70 < (0.9 * Rg))) {
      camera_56.y = (_camPos.y + Rg);
      _point_57.y = (worldPos_4.y + Rg);
      r_61 = sqrt(dot (camera_56, camera_56));
    };
    highp float tmpvar_71;
    tmpvar_71 = dot (camera_56, tmpvar_69);
    rMu_60 = tmpvar_71;
    mu_59 = (tmpvar_71 / r_61);
    highp vec3 tmpvar_72;
    tmpvar_72 = (_point_57 - (tmpvar_69 * clamp (1.0, 0.0, tmpvar_66)));
    _point_57 = tmpvar_72;
    highp float tmpvar_73;
    tmpvar_73 = max ((-(tmpvar_71) - sqrt((((tmpvar_71 * tmpvar_71) - (r_61 * r_61)) + (tmpvar_68 * tmpvar_68)))), 0.0);
    if (((tmpvar_73 > 0.0) && (tmpvar_73 < tmpvar_66))) {
      camera_56 = (camera_56 + (tmpvar_73 * tmpvar_69));
      highp float tmpvar_74;
      tmpvar_74 = (tmpvar_71 + tmpvar_73);
      rMu_60 = tmpvar_74;
      mu_59 = (tmpvar_74 / tmpvar_68);
      r_61 = tmpvar_68;
      d_62 = (tmpvar_66 - tmpvar_73);
    };
    if ((r_61 <= tmpvar_68)) {
      highp float muS1_75;
      highp float mu1_76;
      highp float r1_77;
      highp vec4 inScatter_78;
      highp float tmpvar_79;
      tmpvar_79 = dot (tmpvar_69, SUN_DIR);
      highp float tmpvar_80;
      tmpvar_80 = (dot (camera_56, SUN_DIR) / r_61);
      if ((r_61 < (Rg + 600.0))) {
        highp float tmpvar_81;
        tmpvar_81 = ((Rg + 600.0) / r_61);
        r_61 = (r_61 * tmpvar_81);
        rMu_60 = (rMu_60 * tmpvar_81);
        _point_57 = (tmpvar_72 * tmpvar_81);
      };
      highp float tmpvar_82;
      tmpvar_82 = sqrt(dot (_point_57, _point_57));
      r1_77 = tmpvar_82;
      highp float tmpvar_83;
      tmpvar_83 = (dot (_point_57, tmpvar_69) / tmpvar_82);
      mu1_76 = tmpvar_83;
      muS1_75 = (dot (_point_57, SUN_DIR) / tmpvar_82);
      if ((mu_59 > 0.0)) {
        highp vec3 tmpvar_84;
        highp float y_over_x_85;
        y_over_x_85 = (((mu_59 + 0.15) / 1.15) * 14.1014);
        highp float x_86;
        x_86 = (y_over_x_85 * inversesqrt(((y_over_x_85 * y_over_x_85) + 1.0)));
        highp vec4 tmpvar_87;
        tmpvar_87.zw = vec2(0.0, 0.0);
        tmpvar_87.x = ((sign(x_86) * (1.5708 - (sqrt((1.0 - abs(x_86))) * (1.5708 + (abs(x_86) * (-0.214602 + (abs(x_86) * (0.0865667 + (abs(x_86) * -0.0310296))))))))) / 1.5);
        tmpvar_87.y = sqrt(((r_61 - Rg) / (tmpvar_68 - Rg)));
        lowp vec4 tmpvar_88;
        tmpvar_88 = texture2DLodEXT (_Transmittance, tmpvar_87.xy, 0.0);
        tmpvar_84 = tmpvar_88.xyz;
        highp vec3 tmpvar_89;
        highp float y_over_x_90;
        y_over_x_90 = (((tmpvar_83 + 0.15) / 1.15) * 14.1014);
        highp float x_91;
        x_91 = (y_over_x_90 * inversesqrt(((y_over_x_90 * y_over_x_90) + 1.0)));
        highp vec4 tmpvar_92;
        tmpvar_92.zw = vec2(0.0, 0.0);
        tmpvar_92.x = ((sign(x_91) * (1.5708 - (sqrt((1.0 - abs(x_91))) * (1.5708 + (abs(x_91) * (-0.214602 + (abs(x_91) * (0.0865667 + (abs(x_91) * -0.0310296))))))))) / 1.5);
        tmpvar_92.y = sqrt(((tmpvar_82 - Rg) / (tmpvar_68 - Rg)));
        lowp vec4 tmpvar_93;
        tmpvar_93 = texture2DLodEXT (_Transmittance, tmpvar_92.xy, 0.0);
        tmpvar_89 = tmpvar_93.xyz;
        extinction_58 = min ((tmpvar_84 / tmpvar_89), vec3(1.0, 1.0, 1.0));
      } else {
        highp vec3 tmpvar_94;
        highp float y_over_x_95;
        y_over_x_95 = (((-(tmpvar_83) + 0.15) / 1.15) * 14.1014);
        highp float x_96;
        x_96 = (y_over_x_95 * inversesqrt(((y_over_x_95 * y_over_x_95) + 1.0)));
        highp vec4 tmpvar_97;
        tmpvar_97.zw = vec2(0.0, 0.0);
        tmpvar_97.x = ((sign(x_96) * (1.5708 - (sqrt((1.0 - abs(x_96))) * (1.5708 + (abs(x_96) * (-0.214602 + (abs(x_96) * (0.0865667 + (abs(x_96) * -0.0310296))))))))) / 1.5);
        tmpvar_97.y = sqrt(((tmpvar_82 - Rg) / (tmpvar_68 - Rg)));
        lowp vec4 tmpvar_98;
        tmpvar_98 = texture2DLodEXT (_Transmittance, tmpvar_97.xy, 0.0);
        tmpvar_94 = tmpvar_98.xyz;
        highp vec3 tmpvar_99;
        highp float y_over_x_100;
        y_over_x_100 = (((-(mu_59) + 0.15) / 1.15) * 14.1014);
        highp float x_101;
        x_101 = (y_over_x_100 * inversesqrt(((y_over_x_100 * y_over_x_100) + 1.0)));
        highp vec4 tmpvar_102;
        tmpvar_102.zw = vec2(0.0, 0.0);
        tmpvar_102.x = ((sign(x_101) * (1.5708 - (sqrt((1.0 - abs(x_101))) * (1.5708 + (abs(x_101) * (-0.214602 + (abs(x_101) * (0.0865667 + (abs(x_101) * -0.0310296))))))))) / 1.5);
        tmpvar_102.y = sqrt(((r_61 - Rg) / (tmpvar_68 - Rg)));
        lowp vec4 tmpvar_103;
        tmpvar_103 = texture2DLodEXT (_Transmittance, tmpvar_102.xy, 0.0);
        tmpvar_99 = tmpvar_103.xyz;
        extinction_58 = min ((tmpvar_94 / tmpvar_99), vec3(1.0, 1.0, 1.0));
      };
      highp float tmpvar_104;
      tmpvar_104 = -(sqrt((1.0 - ((Rg / r_61) * (Rg / r_61)))));
      highp float tmpvar_105;
      tmpvar_105 = abs((mu_59 - tmpvar_104));
      if ((tmpvar_105 < 0.004)) {
        highp vec4 inScatterA_106;
        highp vec4 inScatter0_107;
        highp float a_108;
        a_108 = (((mu_59 - tmpvar_104) + 0.004) / 0.008);
        highp float tmpvar_109;
        tmpvar_109 = (tmpvar_104 - 0.004);
        mu_59 = tmpvar_109;
        highp float tmpvar_110;
        tmpvar_110 = sqrt((((r_61 * r_61) + (d_62 * d_62)) + (((2.0 * r_61) * d_62) * tmpvar_109)));
        r1_77 = tmpvar_110;
        mu1_76 = (((r_61 * tmpvar_109) + d_62) / tmpvar_110);
        highp float uMu_111;
        highp float uR_112;
        highp float tmpvar_113;
        tmpvar_113 = sqrt(((tmpvar_68 * tmpvar_68) - (Rg * Rg)));
        highp float tmpvar_114;
        tmpvar_114 = sqrt(((r_61 * r_61) - (Rg * Rg)));
        highp float tmpvar_115;
        tmpvar_115 = (r_61 * tmpvar_109);
        highp float tmpvar_116;
        tmpvar_116 = (((tmpvar_115 * tmpvar_115) - (r_61 * r_61)) + (Rg * Rg));
        highp vec4 tmpvar_117;
        if (((tmpvar_115 < 0.0) && (tmpvar_116 > 0.0))) {
          highp vec4 tmpvar_118;
          tmpvar_118.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_118.w = (0.5 - (0.5 / RES_MU));
          tmpvar_117 = tmpvar_118;
        } else {
          highp vec4 tmpvar_119;
          tmpvar_119.x = -1.0;
          tmpvar_119.y = (tmpvar_113 * tmpvar_113);
          tmpvar_119.z = tmpvar_113;
          tmpvar_119.w = (0.5 + (0.5 / RES_MU));
          tmpvar_117 = tmpvar_119;
        };
        uR_112 = ((0.5 / RES_R) + ((tmpvar_114 / tmpvar_113) * (1.0 - (1.0/(RES_R)))));
        uMu_111 = (tmpvar_117.w + ((((tmpvar_115 * tmpvar_117.x) + sqrt((tmpvar_116 + tmpvar_117.y))) / (tmpvar_114 + tmpvar_117.z)) * (0.5 - (1.0/(RES_MU)))));
        highp float y_over_x_120;
        y_over_x_120 = (max (tmpvar_80, -0.1975) * 5.34962);
        highp float x_121;
        x_121 = (y_over_x_120 * inversesqrt(((y_over_x_120 * y_over_x_120) + 1.0)));
        highp float tmpvar_122;
        tmpvar_122 = ((0.5 / RES_MU_S) + (((((sign(x_121) * (1.5708 - (sqrt((1.0 - abs(x_121))) * (1.5708 + (abs(x_121) * (-0.214602 + (abs(x_121) * (0.0865667 + (abs(x_121) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        highp float tmpvar_123;
        tmpvar_123 = (((tmpvar_79 + 1.0) / 2.0) * (RES_NU - 1.0));
        highp float tmpvar_124;
        tmpvar_124 = floor(tmpvar_123);
        highp float tmpvar_125;
        tmpvar_125 = (tmpvar_123 - tmpvar_124);
        highp float tmpvar_126;
        tmpvar_126 = (floor(((uR_112 * RES_R) - 1.0)) / RES_R);
        highp float tmpvar_127;
        tmpvar_127 = (floor((uR_112 * RES_R)) / RES_R);
        highp float tmpvar_128;
        tmpvar_128 = fract((uR_112 * RES_R));
        highp vec4 tmpvar_129;
        tmpvar_129.zw = vec2(0.0, 0.0);
        tmpvar_129.x = ((tmpvar_124 + tmpvar_122) / RES_NU);
        tmpvar_129.y = ((uMu_111 / RES_R) + tmpvar_126);
        lowp vec4 tmpvar_130;
        tmpvar_130 = texture2DLodEXT (_Inscatter, tmpvar_129.xy, 0.0);
        highp vec4 tmpvar_131;
        tmpvar_131.zw = vec2(0.0, 0.0);
        tmpvar_131.x = (((tmpvar_124 + tmpvar_122) + 1.0) / RES_NU);
        tmpvar_131.y = ((uMu_111 / RES_R) + tmpvar_126);
        lowp vec4 tmpvar_132;
        tmpvar_132 = texture2DLodEXT (_Inscatter, tmpvar_131.xy, 0.0);
        highp vec4 tmpvar_133;
        tmpvar_133.zw = vec2(0.0, 0.0);
        tmpvar_133.x = ((tmpvar_124 + tmpvar_122) / RES_NU);
        tmpvar_133.y = ((uMu_111 / RES_R) + tmpvar_127);
        lowp vec4 tmpvar_134;
        tmpvar_134 = texture2DLodEXT (_Inscatter, tmpvar_133.xy, 0.0);
        highp vec4 tmpvar_135;
        tmpvar_135.zw = vec2(0.0, 0.0);
        tmpvar_135.x = (((tmpvar_124 + tmpvar_122) + 1.0) / RES_NU);
        tmpvar_135.y = ((uMu_111 / RES_R) + tmpvar_127);
        lowp vec4 tmpvar_136;
        tmpvar_136 = texture2DLodEXT (_Inscatter, tmpvar_135.xy, 0.0);
        inScatter0_107 = ((((tmpvar_130 * (1.0 - tmpvar_125)) + (tmpvar_132 * tmpvar_125)) * (1.0 - tmpvar_128)) + (((tmpvar_134 * (1.0 - tmpvar_125)) + (tmpvar_136 * tmpvar_125)) * tmpvar_128));
        highp float uMu_137;
        highp float uR_138;
        highp float tmpvar_139;
        tmpvar_139 = sqrt(((tmpvar_68 * tmpvar_68) - (Rg * Rg)));
        highp float tmpvar_140;
        tmpvar_140 = sqrt(((tmpvar_110 * tmpvar_110) - (Rg * Rg)));
        highp float tmpvar_141;
        tmpvar_141 = (tmpvar_110 * mu1_76);
        highp float tmpvar_142;
        tmpvar_142 = (((tmpvar_141 * tmpvar_141) - (tmpvar_110 * tmpvar_110)) + (Rg * Rg));
        highp vec4 tmpvar_143;
        if (((tmpvar_141 < 0.0) && (tmpvar_142 > 0.0))) {
          highp vec4 tmpvar_144;
          tmpvar_144.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_144.w = (0.5 - (0.5 / RES_MU));
          tmpvar_143 = tmpvar_144;
        } else {
          highp vec4 tmpvar_145;
          tmpvar_145.x = -1.0;
          tmpvar_145.y = (tmpvar_139 * tmpvar_139);
          tmpvar_145.z = tmpvar_139;
          tmpvar_145.w = (0.5 + (0.5 / RES_MU));
          tmpvar_143 = tmpvar_145;
        };
        uR_138 = ((0.5 / RES_R) + ((tmpvar_140 / tmpvar_139) * (1.0 - (1.0/(RES_R)))));
        uMu_137 = (tmpvar_143.w + ((((tmpvar_141 * tmpvar_143.x) + sqrt((tmpvar_142 + tmpvar_143.y))) / (tmpvar_140 + tmpvar_143.z)) * (0.5 - (1.0/(RES_MU)))));
        highp float y_over_x_146;
        y_over_x_146 = (max (muS1_75, -0.1975) * 5.34962);
        highp float x_147;
        x_147 = (y_over_x_146 * inversesqrt(((y_over_x_146 * y_over_x_146) + 1.0)));
        highp float tmpvar_148;
        tmpvar_148 = ((0.5 / RES_MU_S) + (((((sign(x_147) * (1.5708 - (sqrt((1.0 - abs(x_147))) * (1.5708 + (abs(x_147) * (-0.214602 + (abs(x_147) * (0.0865667 + (abs(x_147) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        highp float tmpvar_149;
        tmpvar_149 = (((tmpvar_79 + 1.0) / 2.0) * (RES_NU - 1.0));
        highp float tmpvar_150;
        tmpvar_150 = floor(tmpvar_149);
        highp float tmpvar_151;
        tmpvar_151 = (tmpvar_149 - tmpvar_150);
        highp float tmpvar_152;
        tmpvar_152 = (floor(((uR_138 * RES_R) - 1.0)) / RES_R);
        highp float tmpvar_153;
        tmpvar_153 = (floor((uR_138 * RES_R)) / RES_R);
        highp float tmpvar_154;
        tmpvar_154 = fract((uR_138 * RES_R));
        highp vec4 tmpvar_155;
        tmpvar_155.zw = vec2(0.0, 0.0);
        tmpvar_155.x = ((tmpvar_150 + tmpvar_148) / RES_NU);
        tmpvar_155.y = ((uMu_137 / RES_R) + tmpvar_152);
        lowp vec4 tmpvar_156;
        tmpvar_156 = texture2DLodEXT (_Inscatter, tmpvar_155.xy, 0.0);
        highp vec4 tmpvar_157;
        tmpvar_157.zw = vec2(0.0, 0.0);
        tmpvar_157.x = (((tmpvar_150 + tmpvar_148) + 1.0) / RES_NU);
        tmpvar_157.y = ((uMu_137 / RES_R) + tmpvar_152);
        lowp vec4 tmpvar_158;
        tmpvar_158 = texture2DLodEXT (_Inscatter, tmpvar_157.xy, 0.0);
        highp vec4 tmpvar_159;
        tmpvar_159.zw = vec2(0.0, 0.0);
        tmpvar_159.x = ((tmpvar_150 + tmpvar_148) / RES_NU);
        tmpvar_159.y = ((uMu_137 / RES_R) + tmpvar_153);
        lowp vec4 tmpvar_160;
        tmpvar_160 = texture2DLodEXT (_Inscatter, tmpvar_159.xy, 0.0);
        highp vec4 tmpvar_161;
        tmpvar_161.zw = vec2(0.0, 0.0);
        tmpvar_161.x = (((tmpvar_150 + tmpvar_148) + 1.0) / RES_NU);
        tmpvar_161.y = ((uMu_137 / RES_R) + tmpvar_153);
        lowp vec4 tmpvar_162;
        tmpvar_162 = texture2DLodEXT (_Inscatter, tmpvar_161.xy, 0.0);
        inScatterA_106 = max ((inScatter0_107 - (((((tmpvar_156 * (1.0 - tmpvar_151)) + (tmpvar_158 * tmpvar_151)) * (1.0 - tmpvar_154)) + (((tmpvar_160 * (1.0 - tmpvar_151)) + (tmpvar_162 * tmpvar_151)) * tmpvar_154)) * extinction_58.xyzx)), vec4(0.0, 0.0, 0.0, 0.0));
        highp float tmpvar_163;
        tmpvar_163 = (tmpvar_104 + 0.004);
        mu_59 = tmpvar_163;
        highp float tmpvar_164;
        tmpvar_164 = sqrt((((r_61 * r_61) + (d_62 * d_62)) + (((2.0 * r_61) * d_62) * tmpvar_163)));
        r1_77 = tmpvar_164;
        mu1_76 = (((r_61 * tmpvar_163) + d_62) / tmpvar_164);
        highp float uMu_165;
        highp float uR_166;
        highp float tmpvar_167;
        tmpvar_167 = sqrt(((tmpvar_68 * tmpvar_68) - (Rg * Rg)));
        highp float tmpvar_168;
        tmpvar_168 = sqrt(((r_61 * r_61) - (Rg * Rg)));
        highp float tmpvar_169;
        tmpvar_169 = (r_61 * tmpvar_163);
        highp float tmpvar_170;
        tmpvar_170 = (((tmpvar_169 * tmpvar_169) - (r_61 * r_61)) + (Rg * Rg));
        highp vec4 tmpvar_171;
        if (((tmpvar_169 < 0.0) && (tmpvar_170 > 0.0))) {
          highp vec4 tmpvar_172;
          tmpvar_172.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_172.w = (0.5 - (0.5 / RES_MU));
          tmpvar_171 = tmpvar_172;
        } else {
          highp vec4 tmpvar_173;
          tmpvar_173.x = -1.0;
          tmpvar_173.y = (tmpvar_167 * tmpvar_167);
          tmpvar_173.z = tmpvar_167;
          tmpvar_173.w = (0.5 + (0.5 / RES_MU));
          tmpvar_171 = tmpvar_173;
        };
        uR_166 = ((0.5 / RES_R) + ((tmpvar_168 / tmpvar_167) * (1.0 - (1.0/(RES_R)))));
        uMu_165 = (tmpvar_171.w + ((((tmpvar_169 * tmpvar_171.x) + sqrt((tmpvar_170 + tmpvar_171.y))) / (tmpvar_168 + tmpvar_171.z)) * (0.5 - (1.0/(RES_MU)))));
        highp float y_over_x_174;
        y_over_x_174 = (max (tmpvar_80, -0.1975) * 5.34962);
        highp float x_175;
        x_175 = (y_over_x_174 * inversesqrt(((y_over_x_174 * y_over_x_174) + 1.0)));
        highp float tmpvar_176;
        tmpvar_176 = ((0.5 / RES_MU_S) + (((((sign(x_175) * (1.5708 - (sqrt((1.0 - abs(x_175))) * (1.5708 + (abs(x_175) * (-0.214602 + (abs(x_175) * (0.0865667 + (abs(x_175) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        highp float tmpvar_177;
        tmpvar_177 = (((tmpvar_79 + 1.0) / 2.0) * (RES_NU - 1.0));
        highp float tmpvar_178;
        tmpvar_178 = floor(tmpvar_177);
        highp float tmpvar_179;
        tmpvar_179 = (tmpvar_177 - tmpvar_178);
        highp float tmpvar_180;
        tmpvar_180 = (floor(((uR_166 * RES_R) - 1.0)) / RES_R);
        highp float tmpvar_181;
        tmpvar_181 = (floor((uR_166 * RES_R)) / RES_R);
        highp float tmpvar_182;
        tmpvar_182 = fract((uR_166 * RES_R));
        highp vec4 tmpvar_183;
        tmpvar_183.zw = vec2(0.0, 0.0);
        tmpvar_183.x = ((tmpvar_178 + tmpvar_176) / RES_NU);
        tmpvar_183.y = ((uMu_165 / RES_R) + tmpvar_180);
        lowp vec4 tmpvar_184;
        tmpvar_184 = texture2DLodEXT (_Inscatter, tmpvar_183.xy, 0.0);
        highp vec4 tmpvar_185;
        tmpvar_185.zw = vec2(0.0, 0.0);
        tmpvar_185.x = (((tmpvar_178 + tmpvar_176) + 1.0) / RES_NU);
        tmpvar_185.y = ((uMu_165 / RES_R) + tmpvar_180);
        lowp vec4 tmpvar_186;
        tmpvar_186 = texture2DLodEXT (_Inscatter, tmpvar_185.xy, 0.0);
        highp vec4 tmpvar_187;
        tmpvar_187.zw = vec2(0.0, 0.0);
        tmpvar_187.x = ((tmpvar_178 + tmpvar_176) / RES_NU);
        tmpvar_187.y = ((uMu_165 / RES_R) + tmpvar_181);
        lowp vec4 tmpvar_188;
        tmpvar_188 = texture2DLodEXT (_Inscatter, tmpvar_187.xy, 0.0);
        highp vec4 tmpvar_189;
        tmpvar_189.zw = vec2(0.0, 0.0);
        tmpvar_189.x = (((tmpvar_178 + tmpvar_176) + 1.0) / RES_NU);
        tmpvar_189.y = ((uMu_165 / RES_R) + tmpvar_181);
        lowp vec4 tmpvar_190;
        tmpvar_190 = texture2DLodEXT (_Inscatter, tmpvar_189.xy, 0.0);
        inScatter0_107 = ((((tmpvar_184 * (1.0 - tmpvar_179)) + (tmpvar_186 * tmpvar_179)) * (1.0 - tmpvar_182)) + (((tmpvar_188 * (1.0 - tmpvar_179)) + (tmpvar_190 * tmpvar_179)) * tmpvar_182));
        highp float uMu_191;
        highp float uR_192;
        highp float tmpvar_193;
        tmpvar_193 = sqrt(((tmpvar_68 * tmpvar_68) - (Rg * Rg)));
        highp float tmpvar_194;
        tmpvar_194 = sqrt(((tmpvar_164 * tmpvar_164) - (Rg * Rg)));
        highp float tmpvar_195;
        tmpvar_195 = (tmpvar_164 * mu1_76);
        highp float tmpvar_196;
        tmpvar_196 = (((tmpvar_195 * tmpvar_195) - (tmpvar_164 * tmpvar_164)) + (Rg * Rg));
        highp vec4 tmpvar_197;
        if (((tmpvar_195 < 0.0) && (tmpvar_196 > 0.0))) {
          highp vec4 tmpvar_198;
          tmpvar_198.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_198.w = (0.5 - (0.5 / RES_MU));
          tmpvar_197 = tmpvar_198;
        } else {
          highp vec4 tmpvar_199;
          tmpvar_199.x = -1.0;
          tmpvar_199.y = (tmpvar_193 * tmpvar_193);
          tmpvar_199.z = tmpvar_193;
          tmpvar_199.w = (0.5 + (0.5 / RES_MU));
          tmpvar_197 = tmpvar_199;
        };
        uR_192 = ((0.5 / RES_R) + ((tmpvar_194 / tmpvar_193) * (1.0 - (1.0/(RES_R)))));
        uMu_191 = (tmpvar_197.w + ((((tmpvar_195 * tmpvar_197.x) + sqrt((tmpvar_196 + tmpvar_197.y))) / (tmpvar_194 + tmpvar_197.z)) * (0.5 - (1.0/(RES_MU)))));
        highp float y_over_x_200;
        y_over_x_200 = (max (muS1_75, -0.1975) * 5.34962);
        highp float x_201;
        x_201 = (y_over_x_200 * inversesqrt(((y_over_x_200 * y_over_x_200) + 1.0)));
        highp float tmpvar_202;
        tmpvar_202 = ((0.5 / RES_MU_S) + (((((sign(x_201) * (1.5708 - (sqrt((1.0 - abs(x_201))) * (1.5708 + (abs(x_201) * (-0.214602 + (abs(x_201) * (0.0865667 + (abs(x_201) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        highp float tmpvar_203;
        tmpvar_203 = (((tmpvar_79 + 1.0) / 2.0) * (RES_NU - 1.0));
        highp float tmpvar_204;
        tmpvar_204 = floor(tmpvar_203);
        highp float tmpvar_205;
        tmpvar_205 = (tmpvar_203 - tmpvar_204);
        highp float tmpvar_206;
        tmpvar_206 = (floor(((uR_192 * RES_R) - 1.0)) / RES_R);
        highp float tmpvar_207;
        tmpvar_207 = (floor((uR_192 * RES_R)) / RES_R);
        highp float tmpvar_208;
        tmpvar_208 = fract((uR_192 * RES_R));
        highp vec4 tmpvar_209;
        tmpvar_209.zw = vec2(0.0, 0.0);
        tmpvar_209.x = ((tmpvar_204 + tmpvar_202) / RES_NU);
        tmpvar_209.y = ((uMu_191 / RES_R) + tmpvar_206);
        lowp vec4 tmpvar_210;
        tmpvar_210 = texture2DLodEXT (_Inscatter, tmpvar_209.xy, 0.0);
        highp vec4 tmpvar_211;
        tmpvar_211.zw = vec2(0.0, 0.0);
        tmpvar_211.x = (((tmpvar_204 + tmpvar_202) + 1.0) / RES_NU);
        tmpvar_211.y = ((uMu_191 / RES_R) + tmpvar_206);
        lowp vec4 tmpvar_212;
        tmpvar_212 = texture2DLodEXT (_Inscatter, tmpvar_211.xy, 0.0);
        highp vec4 tmpvar_213;
        tmpvar_213.zw = vec2(0.0, 0.0);
        tmpvar_213.x = ((tmpvar_204 + tmpvar_202) / RES_NU);
        tmpvar_213.y = ((uMu_191 / RES_R) + tmpvar_207);
        lowp vec4 tmpvar_214;
        tmpvar_214 = texture2DLodEXT (_Inscatter, tmpvar_213.xy, 0.0);
        highp vec4 tmpvar_215;
        tmpvar_215.zw = vec2(0.0, 0.0);
        tmpvar_215.x = (((tmpvar_204 + tmpvar_202) + 1.0) / RES_NU);
        tmpvar_215.y = ((uMu_191 / RES_R) + tmpvar_207);
        lowp vec4 tmpvar_216;
        tmpvar_216 = texture2DLodEXT (_Inscatter, tmpvar_215.xy, 0.0);
        inScatter_78 = mix (inScatterA_106, max ((inScatter0_107 - (((((tmpvar_210 * (1.0 - tmpvar_205)) + (tmpvar_212 * tmpvar_205)) * (1.0 - tmpvar_208)) + (((tmpvar_214 * (1.0 - tmpvar_205)) + (tmpvar_216 * tmpvar_205)) * tmpvar_208)) * extinction_58.xyzx)), vec4(0.0, 0.0, 0.0, 0.0)), vec4(a_108));
      } else {
        highp vec4 inScatter0_1_217;
        highp float uMu_218;
        highp float uR_219;
        highp float tmpvar_220;
        tmpvar_220 = sqrt(((tmpvar_68 * tmpvar_68) - (Rg * Rg)));
        highp float tmpvar_221;
        tmpvar_221 = sqrt(((r_61 * r_61) - (Rg * Rg)));
        highp float tmpvar_222;
        tmpvar_222 = (r_61 * mu_59);
        highp float tmpvar_223;
        tmpvar_223 = (((tmpvar_222 * tmpvar_222) - (r_61 * r_61)) + (Rg * Rg));
        highp vec4 tmpvar_224;
        if (((tmpvar_222 < 0.0) && (tmpvar_223 > 0.0))) {
          highp vec4 tmpvar_225;
          tmpvar_225.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_225.w = (0.5 - (0.5 / RES_MU));
          tmpvar_224 = tmpvar_225;
        } else {
          highp vec4 tmpvar_226;
          tmpvar_226.x = -1.0;
          tmpvar_226.y = (tmpvar_220 * tmpvar_220);
          tmpvar_226.z = tmpvar_220;
          tmpvar_226.w = (0.5 + (0.5 / RES_MU));
          tmpvar_224 = tmpvar_226;
        };
        uR_219 = ((0.5 / RES_R) + ((tmpvar_221 / tmpvar_220) * (1.0 - (1.0/(RES_R)))));
        uMu_218 = (tmpvar_224.w + ((((tmpvar_222 * tmpvar_224.x) + sqrt((tmpvar_223 + tmpvar_224.y))) / (tmpvar_221 + tmpvar_224.z)) * (0.5 - (1.0/(RES_MU)))));
        highp float y_over_x_227;
        y_over_x_227 = (max (tmpvar_80, -0.1975) * 5.34962);
        highp float x_228;
        x_228 = (y_over_x_227 * inversesqrt(((y_over_x_227 * y_over_x_227) + 1.0)));
        highp float tmpvar_229;
        tmpvar_229 = ((0.5 / RES_MU_S) + (((((sign(x_228) * (1.5708 - (sqrt((1.0 - abs(x_228))) * (1.5708 + (abs(x_228) * (-0.214602 + (abs(x_228) * (0.0865667 + (abs(x_228) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        highp float tmpvar_230;
        tmpvar_230 = (((tmpvar_79 + 1.0) / 2.0) * (RES_NU - 1.0));
        highp float tmpvar_231;
        tmpvar_231 = floor(tmpvar_230);
        highp float tmpvar_232;
        tmpvar_232 = (tmpvar_230 - tmpvar_231);
        highp float tmpvar_233;
        tmpvar_233 = (floor(((uR_219 * RES_R) - 1.0)) / RES_R);
        highp float tmpvar_234;
        tmpvar_234 = (floor((uR_219 * RES_R)) / RES_R);
        highp float tmpvar_235;
        tmpvar_235 = fract((uR_219 * RES_R));
        highp vec4 tmpvar_236;
        tmpvar_236.zw = vec2(0.0, 0.0);
        tmpvar_236.x = ((tmpvar_231 + tmpvar_229) / RES_NU);
        tmpvar_236.y = ((uMu_218 / RES_R) + tmpvar_233);
        lowp vec4 tmpvar_237;
        tmpvar_237 = texture2DLodEXT (_Inscatter, tmpvar_236.xy, 0.0);
        highp vec4 tmpvar_238;
        tmpvar_238.zw = vec2(0.0, 0.0);
        tmpvar_238.x = (((tmpvar_231 + tmpvar_229) + 1.0) / RES_NU);
        tmpvar_238.y = ((uMu_218 / RES_R) + tmpvar_233);
        lowp vec4 tmpvar_239;
        tmpvar_239 = texture2DLodEXT (_Inscatter, tmpvar_238.xy, 0.0);
        highp vec4 tmpvar_240;
        tmpvar_240.zw = vec2(0.0, 0.0);
        tmpvar_240.x = ((tmpvar_231 + tmpvar_229) / RES_NU);
        tmpvar_240.y = ((uMu_218 / RES_R) + tmpvar_234);
        lowp vec4 tmpvar_241;
        tmpvar_241 = texture2DLodEXT (_Inscatter, tmpvar_240.xy, 0.0);
        highp vec4 tmpvar_242;
        tmpvar_242.zw = vec2(0.0, 0.0);
        tmpvar_242.x = (((tmpvar_231 + tmpvar_229) + 1.0) / RES_NU);
        tmpvar_242.y = ((uMu_218 / RES_R) + tmpvar_234);
        lowp vec4 tmpvar_243;
        tmpvar_243 = texture2DLodEXT (_Inscatter, tmpvar_242.xy, 0.0);
        inScatter0_1_217 = ((((tmpvar_237 * (1.0 - tmpvar_232)) + (tmpvar_239 * tmpvar_232)) * (1.0 - tmpvar_235)) + (((tmpvar_241 * (1.0 - tmpvar_232)) + (tmpvar_243 * tmpvar_232)) * tmpvar_235));
        highp float uMu_244;
        highp float uR_245;
        highp float tmpvar_246;
        tmpvar_246 = sqrt(((tmpvar_68 * tmpvar_68) - (Rg * Rg)));
        highp float tmpvar_247;
        tmpvar_247 = sqrt(((r1_77 * r1_77) - (Rg * Rg)));
        highp float tmpvar_248;
        tmpvar_248 = (r1_77 * mu1_76);
        highp float tmpvar_249;
        tmpvar_249 = (((tmpvar_248 * tmpvar_248) - (r1_77 * r1_77)) + (Rg * Rg));
        highp vec4 tmpvar_250;
        if (((tmpvar_248 < 0.0) && (tmpvar_249 > 0.0))) {
          highp vec4 tmpvar_251;
          tmpvar_251.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_251.w = (0.5 - (0.5 / RES_MU));
          tmpvar_250 = tmpvar_251;
        } else {
          highp vec4 tmpvar_252;
          tmpvar_252.x = -1.0;
          tmpvar_252.y = (tmpvar_246 * tmpvar_246);
          tmpvar_252.z = tmpvar_246;
          tmpvar_252.w = (0.5 + (0.5 / RES_MU));
          tmpvar_250 = tmpvar_252;
        };
        uR_245 = ((0.5 / RES_R) + ((tmpvar_247 / tmpvar_246) * (1.0 - (1.0/(RES_R)))));
        uMu_244 = (tmpvar_250.w + ((((tmpvar_248 * tmpvar_250.x) + sqrt((tmpvar_249 + tmpvar_250.y))) / (tmpvar_247 + tmpvar_250.z)) * (0.5 - (1.0/(RES_MU)))));
        highp float y_over_x_253;
        y_over_x_253 = (max (muS1_75, -0.1975) * 5.34962);
        highp float x_254;
        x_254 = (y_over_x_253 * inversesqrt(((y_over_x_253 * y_over_x_253) + 1.0)));
        highp float tmpvar_255;
        tmpvar_255 = ((0.5 / RES_MU_S) + (((((sign(x_254) * (1.5708 - (sqrt((1.0 - abs(x_254))) * (1.5708 + (abs(x_254) * (-0.214602 + (abs(x_254) * (0.0865667 + (abs(x_254) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        highp float tmpvar_256;
        tmpvar_256 = (((tmpvar_79 + 1.0) / 2.0) * (RES_NU - 1.0));
        highp float tmpvar_257;
        tmpvar_257 = floor(tmpvar_256);
        highp float tmpvar_258;
        tmpvar_258 = (tmpvar_256 - tmpvar_257);
        highp float tmpvar_259;
        tmpvar_259 = (floor(((uR_245 * RES_R) - 1.0)) / RES_R);
        highp float tmpvar_260;
        tmpvar_260 = (floor((uR_245 * RES_R)) / RES_R);
        highp float tmpvar_261;
        tmpvar_261 = fract((uR_245 * RES_R));
        highp vec4 tmpvar_262;
        tmpvar_262.zw = vec2(0.0, 0.0);
        tmpvar_262.x = ((tmpvar_257 + tmpvar_255) / RES_NU);
        tmpvar_262.y = ((uMu_244 / RES_R) + tmpvar_259);
        lowp vec4 tmpvar_263;
        tmpvar_263 = texture2DLodEXT (_Inscatter, tmpvar_262.xy, 0.0);
        highp vec4 tmpvar_264;
        tmpvar_264.zw = vec2(0.0, 0.0);
        tmpvar_264.x = (((tmpvar_257 + tmpvar_255) + 1.0) / RES_NU);
        tmpvar_264.y = ((uMu_244 / RES_R) + tmpvar_259);
        lowp vec4 tmpvar_265;
        tmpvar_265 = texture2DLodEXT (_Inscatter, tmpvar_264.xy, 0.0);
        highp vec4 tmpvar_266;
        tmpvar_266.zw = vec2(0.0, 0.0);
        tmpvar_266.x = ((tmpvar_257 + tmpvar_255) / RES_NU);
        tmpvar_266.y = ((uMu_244 / RES_R) + tmpvar_260);
        lowp vec4 tmpvar_267;
        tmpvar_267 = texture2DLodEXT (_Inscatter, tmpvar_266.xy, 0.0);
        highp vec4 tmpvar_268;
        tmpvar_268.zw = vec2(0.0, 0.0);
        tmpvar_268.x = (((tmpvar_257 + tmpvar_255) + 1.0) / RES_NU);
        tmpvar_268.y = ((uMu_244 / RES_R) + tmpvar_260);
        lowp vec4 tmpvar_269;
        tmpvar_269 = texture2DLodEXT (_Inscatter, tmpvar_268.xy, 0.0);
        inScatter_78 = max ((inScatter0_1_217 - (((((tmpvar_263 * (1.0 - tmpvar_258)) + (tmpvar_265 * tmpvar_258)) * (1.0 - tmpvar_261)) + (((tmpvar_267 * (1.0 - tmpvar_258)) + (tmpvar_269 * tmpvar_258)) * tmpvar_261)) * extinction_58.xyzx)), vec4(0.0, 0.0, 0.0, 0.0));
      };
      highp float t_270;
      t_270 = max (min ((tmpvar_80 / 0.02), 1.0), 0.0);
      inScatter_78.w = (inScatter_78.w * (t_270 * (t_270 * (3.0 - (2.0 * t_270)))));
      result_64 = ((inScatter_78.xyz * ((3.0 / (16.0 * M_PI)) * (1.0 + (tmpvar_79 * tmpvar_79)))) + ((((inScatter_78.xyz * inScatter_78.w) / max (inScatter_78.x, 0.0001)) * (betaR.x / betaR)) * (((((1.5 / (4.0 * M_PI)) * (1.0 - (mieG * mieG))) * pow (((1.0 + (mieG * mieG)) - ((2.0 * mieG) * tmpvar_79)), -1.5)) * (1.0 + (tmpvar_79 * tmpvar_79))) / (2.0 + (mieG * mieG)))));
    };
    tmpvar_55 = (result_64 * SUN_INTENSITY);
    visib_2 = 1.0;
    highp float tmpvar_271;
    highp vec3 arg0_272;
    arg0_272 = (worldPos_4 - _camPos);
    tmpvar_271 = sqrt(dot (arg0_272, arg0_272));
    if ((tmpvar_271 <= _global_depth)) {
      visib_2 = (1.0 - exp((-1.0 * ((4.0 * tmpvar_271) / _global_depth))));
    };
    if (((tmpvar_15 && tmpvar_20) && (fakeOcean == 1.0))) {
      highp vec3 L_273;
      L_273 = (oceanColor_3 * extinction_58);
      highp vec3 tmpvar_274;
      tmpvar_274 = (L_273 * _Exposure);
      L_273 = tmpvar_274;
      highp float tmpvar_275;
      if ((tmpvar_274.x < 1.413)) {
        tmpvar_275 = pow ((tmpvar_274.x * 0.38317), 0.454545);
      } else {
        tmpvar_275 = (1.0 - exp(-(tmpvar_274.x)));
      };
      L_273.x = tmpvar_275;
      highp float tmpvar_276;
      if ((tmpvar_274.y < 1.413)) {
        tmpvar_276 = pow ((tmpvar_274.y * 0.38317), 0.454545);
      } else {
        tmpvar_276 = (1.0 - exp(-(tmpvar_274.y)));
      };
      L_273.y = tmpvar_276;
      highp float tmpvar_277;
      if ((tmpvar_274.z < 1.413)) {
        tmpvar_277 = pow ((tmpvar_274.z * 0.38317), 0.454545);
      } else {
        tmpvar_277 = (1.0 - exp(-(tmpvar_274.z)));
      };
      L_273.z = tmpvar_277;
      highp vec3 L_278;
      highp vec3 tmpvar_279;
      tmpvar_279 = (tmpvar_55 * _Exposure);
      L_278 = tmpvar_279;
      highp float tmpvar_280;
      if ((tmpvar_279.x < 1.413)) {
        tmpvar_280 = pow ((tmpvar_279.x * 0.38317), 0.454545);
      } else {
        tmpvar_280 = (1.0 - exp(-(tmpvar_279.x)));
      };
      L_278.x = tmpvar_280;
      highp float tmpvar_281;
      if ((tmpvar_279.y < 1.413)) {
        tmpvar_281 = pow ((tmpvar_279.y * 0.38317), 0.454545);
      } else {
        tmpvar_281 = (1.0 - exp(-(tmpvar_279.y)));
      };
      L_278.y = tmpvar_281;
      highp float tmpvar_282;
      if ((tmpvar_279.z < 1.413)) {
        tmpvar_282 = pow ((tmpvar_279.z * 0.38317), 0.454545);
      } else {
        tmpvar_282 = (1.0 - exp(-(tmpvar_279.z)));
      };
      L_278.z = tmpvar_282;
      highp vec4 tmpvar_283;
      tmpvar_283.xyz = mix (L_273, L_278, vec3((_global_alpha * visib_2)));
      tmpvar_283.w = _fade;
      tmpvar_1 = tmpvar_283;
    } else {
      highp vec3 L_284;
      highp vec3 tmpvar_285;
      tmpvar_285 = (tmpvar_55 * _Exposure);
      L_284 = tmpvar_285;
      highp float tmpvar_286;
      if ((tmpvar_285.x < 1.413)) {
        tmpvar_286 = pow ((tmpvar_285.x * 0.38317), 0.454545);
      } else {
        tmpvar_286 = (1.0 - exp(-(tmpvar_285.x)));
      };
      L_284.x = tmpvar_286;
      highp float tmpvar_287;
      if ((tmpvar_285.y < 1.413)) {
        tmpvar_287 = pow ((tmpvar_285.y * 0.38317), 0.454545);
      } else {
        tmpvar_287 = (1.0 - exp(-(tmpvar_285.y)));
      };
      L_284.y = tmpvar_287;
      highp float tmpvar_288;
      if ((tmpvar_285.z < 1.413)) {
        tmpvar_288 = pow ((tmpvar_285.z * 0.38317), 0.454545);
      } else {
        tmpvar_288 = (1.0 - exp(-(tmpvar_285.z)));
      };
      L_284.z = tmpvar_288;
      highp vec4 tmpvar_289;
      tmpvar_289.xyz = L_284;
      tmpvar_289.w = ((_global_alpha * visib_2) * _fade);
      tmpvar_1 = tmpvar_289;
    };
  };
  gl_FragData[0] = tmpvar_1;
}



#endif"
}
SubProgram "gles3 " {
"!!GLES3#version 300 es


#ifdef VERTEX

in vec4 _glesVertex;
uniform highp vec4 _ProjectionParams;
uniform highp mat4 glstate_matrix_mvp;
uniform highp mat4 glstate_matrix_modelview0;
out highp vec4 xlv_TEXCOORD0;
out highp vec2 xlv_TEXCOORD1;
out highp vec2 xlv_TEXCOORD2;
void main ()
{
  highp vec4 tmpvar_1;
  highp vec4 tmpvar_2;
  tmpvar_2 = (glstate_matrix_mvp * _glesVertex);
  highp vec4 o_3;
  highp vec4 tmpvar_4;
  tmpvar_4 = (tmpvar_2 * 0.5);
  highp vec2 tmpvar_5;
  tmpvar_5.x = tmpvar_4.x;
  tmpvar_5.y = (tmpvar_4.y * _ProjectionParams.x);
  o_3.xy = (tmpvar_5 + tmpvar_4.w);
  o_3.zw = tmpvar_2.zw;
  tmpvar_1.xyw = o_3.xyw;
  highp vec2 tmpvar_6;
  tmpvar_6 = (o_3.xy / tmpvar_2.w);
  tmpvar_1.z = -((glstate_matrix_modelview0 * _glesVertex).z);
  gl_Position = tmpvar_2;
  xlv_TEXCOORD0 = tmpvar_1;
  xlv_TEXCOORD1 = tmpvar_6;
  xlv_TEXCOORD2 = tmpvar_6;
}



#endif
#ifdef FRAGMENT

out mediump vec4 _glesFragData[4];
uniform sampler2D _Transmittance;
uniform sampler2D _Inscatter;
uniform sampler2D _Irradiance;
uniform highp float M_PI;
uniform highp float Rg;
uniform highp float Rt;
uniform highp float RES_R;
uniform highp float RES_MU;
uniform highp float RES_MU_S;
uniform highp float RES_NU;
uniform highp vec3 SUN_DIR;
uniform highp float SUN_INTENSITY;
uniform highp vec3 betaR;
uniform highp float mieG;
uniform highp mat4 _ViewProjInv;
uniform highp float _viewdirOffset;
uniform highp float _experimentalAtmoScale;
uniform highp float _global_alpha;
uniform highp float _Exposure;
uniform highp float _global_depth;
uniform highp float _Ocean_Sigma;
uniform highp float fakeOcean;
uniform highp float _fade;
uniform highp vec3 _Ocean_Color;
uniform highp vec3 _camPos;
uniform sampler2D _customDepthTexture;
uniform highp float _openglThreshold;
in highp vec2 xlv_TEXCOORD2;
void main ()
{
  mediump vec4 tmpvar_1;
  highp float visib_2;
  highp vec3 oceanColor_3;
  highp vec3 worldPos_4;
  highp float depth_5;
  lowp float tmpvar_6;
  tmpvar_6 = texture (_customDepthTexture, xlv_TEXCOORD2).x;
  depth_5 = tmpvar_6;
  highp vec4 tmpvar_7;
  tmpvar_7.w = 1.0;
  tmpvar_7.x = ((xlv_TEXCOORD2.x * 2.0) - 1.0);
  tmpvar_7.y = ((xlv_TEXCOORD2.y * 2.0) - 1.0);
  tmpvar_7.z = depth_5;
  highp vec4 tmpvar_8;
  tmpvar_8 = (_ViewProjInv * tmpvar_7);
  highp vec3 tmpvar_9;
  tmpvar_9 = (tmpvar_8 / tmpvar_8.w).xyz;
  worldPos_4 = tmpvar_9;
  highp float tmpvar_10;
  highp vec3 tmpvar_11;
  tmpvar_11 = (tmpvar_9 - _camPos);
  highp float tmpvar_12;
  tmpvar_12 = dot (tmpvar_11, tmpvar_11);
  highp float tmpvar_13;
  tmpvar_13 = (2.0 * dot (tmpvar_11, _camPos));
  highp float tmpvar_14;
  tmpvar_14 = ((tmpvar_13 * tmpvar_13) - ((4.0 * tmpvar_12) * (dot (_camPos, _camPos) - (Rg * Rg))));
  if ((tmpvar_14 < 0.0)) {
    tmpvar_10 = -1.0;
  } else {
    tmpvar_10 = ((-(tmpvar_13) - sqrt(tmpvar_14)) / (2.0 * tmpvar_12));
  };
  bool tmpvar_15;
  tmpvar_15 = (tmpvar_10 > 0.0);
  bool tmpvar_16;
  tmpvar_16 = (sqrt(dot (tmpvar_9, tmpvar_9)) >= Rt);
  if ((!(tmpvar_15) && tmpvar_16)) {
    tmpvar_1 = vec4(0.0, 0.0, 0.0, 0.0);
  } else {
    highp vec3 tmpvar_17;
    tmpvar_17 = (_camPos + (tmpvar_10 * (tmpvar_9 - _camPos)));
    highp vec3 arg0_18;
    arg0_18 = (tmpvar_17 - _camPos);
    highp vec3 arg0_19;
    arg0_19 = (tmpvar_9 - _camPos);
    bool tmpvar_20;
    tmpvar_20 = (sqrt(dot (arg0_18, arg0_18)) < sqrt(dot (arg0_19, arg0_19)));
    oceanColor_3 = vec3(1.0, 1.0, 1.0);
    if ((tmpvar_15 && tmpvar_20)) {
      worldPos_4 = tmpvar_17;
      if ((fakeOcean == 1.0)) {
        highp vec3 tmpvar_21;
        tmpvar_21 = normalize(tmpvar_17);
        highp vec3 tmpvar_22;
        tmpvar_22 = (tmpvar_21 * max (sqrt(dot (tmpvar_17, tmpvar_17)), Rg));
        highp vec3 tmpvar_23;
        tmpvar_23 = normalize((tmpvar_22 - _camPos));
        highp vec3 worldP_24;
        worldP_24 = tmpvar_22;
        highp float r_25;
        highp float tmpvar_26;
        tmpvar_26 = sqrt(dot (tmpvar_22, tmpvar_22));
        r_25 = tmpvar_26;
        if ((tmpvar_26 < (0.9 * Rg))) {
          worldP_24.z = (tmpvar_22.z + Rg);
          r_25 = sqrt(dot (worldP_24, worldP_24));
        };
        highp vec3 tmpvar_27;
        tmpvar_27 = (worldP_24 / r_25);
        highp float tmpvar_28;
        tmpvar_28 = dot (tmpvar_27, SUN_DIR);
        highp float tmpvar_29;
        tmpvar_29 = sqrt((1.0 - ((Rg / r_25) * (Rg / r_25))));
        highp vec3 tmpvar_30;
        if ((tmpvar_28 < -(tmpvar_29))) {
          tmpvar_30 = vec3(0.0, 0.0, 0.0);
        } else {
          highp vec3 tmpvar_31;
          highp float y_over_x_32;
          y_over_x_32 = (((tmpvar_28 + 0.15) / 1.15) * 14.1014);
          highp float x_33;
          x_33 = (y_over_x_32 * inversesqrt(((y_over_x_32 * y_over_x_32) + 1.0)));
          highp vec4 tmpvar_34;
          tmpvar_34.zw = vec2(0.0, 0.0);
          tmpvar_34.x = ((sign(x_33) * (1.5708 - (sqrt((1.0 - abs(x_33))) * (1.5708 + (abs(x_33) * (-0.214602 + (abs(x_33) * (0.0865667 + (abs(x_33) * -0.0310296))))))))) / 1.5);
          tmpvar_34.y = sqrt(((r_25 - Rg) / (Rt - Rg)));
          lowp vec4 tmpvar_35;
          tmpvar_35 = textureLod (_Transmittance, tmpvar_34.xy, 0.0);
          tmpvar_31 = tmpvar_35.xyz;
          tmpvar_30 = tmpvar_31;
        };
        highp vec3 tmpvar_36;
        tmpvar_36 = (tmpvar_30 * SUN_INTENSITY);
        highp vec3 tmpvar_37;
        highp vec2 tmpvar_38;
        tmpvar_38.x = ((tmpvar_28 + 0.2) / 1.2);
        tmpvar_38.y = ((r_25 - Rg) / (Rt - Rg));
        lowp vec4 tmpvar_39;
        tmpvar_39 = textureLod (_Irradiance, tmpvar_38, 0.0);
        tmpvar_37 = tmpvar_39.xyz;
        highp vec3 tmpvar_40;
        tmpvar_40 = (((2.0 * tmpvar_37) * SUN_INTENSITY) * ((1.0 + tmpvar_27.z) * 0.5));
        highp vec3 V_41;
        V_41 = -(tmpvar_23);
        highp vec3 seaColor_42;
        seaColor_42 = (_Ocean_Color * 10.0);
        highp float tmpvar_43;
        tmpvar_43 = sqrt(_Ocean_Sigma);
        highp float tmpvar_44;
        tmpvar_44 = (pow ((1.0 - dot (V_41, tmpvar_21)), (5.0 * exp((-2.69 * tmpvar_43)))) / (1.0 + (22.7 * pow (tmpvar_43, 1.5))));
        highp vec3 tmpvar_45;
        tmpvar_45 = normalize((SUN_DIR + V_41));
        highp float tmpvar_46;
        tmpvar_46 = dot (tmpvar_45, tmpvar_21);
        highp float tmpvar_47;
        tmpvar_47 = (exp(((-2.0 * ((1.0 - (tmpvar_46 * tmpvar_46)) / _Ocean_Sigma)) / (1.0 + tmpvar_46))) / ((4.0 * M_PI) * _Ocean_Sigma));
        highp float tmpvar_48;
        tmpvar_48 = (1.0 - dot (V_41, tmpvar_45));
        highp float tmpvar_49;
        tmpvar_49 = (tmpvar_48 * tmpvar_48);
        highp float tmpvar_50;
        tmpvar_50 = (0.02 + (((0.98 * tmpvar_49) * tmpvar_49) * tmpvar_48));
        highp float tmpvar_51;
        tmpvar_51 = max (dot (SUN_DIR, tmpvar_21), 0.01);
        highp float tmpvar_52;
        tmpvar_52 = max (dot (V_41, tmpvar_21), 0.01);
        highp float tmpvar_53;
        if ((tmpvar_51 <= 0.0)) {
          tmpvar_53 = 0.0;
        } else {
          tmpvar_53 = max (((tmpvar_50 * tmpvar_47) * sqrt(abs((tmpvar_51 / tmpvar_52)))), 0.0);
        };
        oceanColor_3 = (((tmpvar_53 * tmpvar_36) + ((tmpvar_40 * tmpvar_44) / M_PI)) + ((((1.0 - tmpvar_44) * seaColor_42) * tmpvar_40) / M_PI));
      };
    };
    highp float tmpvar_54;
    tmpvar_54 = sqrt(dot (worldPos_4, worldPos_4));
    if ((tmpvar_54 < (Rg + _openglThreshold))) {
      worldPos_4 = ((Rg + _openglThreshold) * normalize(worldPos_4));
    };
    highp vec3 tmpvar_55;
    highp vec3 camera_56;
    camera_56 = _camPos;
    highp vec3 _point_57;
    _point_57 = worldPos_4;
    highp vec3 extinction_58;
    highp float mu_59;
    highp float rMu_60;
    highp float r_61;
    highp float d_62;
    highp vec3 viewdir_63;
    highp vec3 result_64;
    result_64 = vec3(0.0, 0.0, 0.0);
    extinction_58 = vec3(1.0, 1.0, 1.0);
    highp vec3 tmpvar_65;
    tmpvar_65 = (worldPos_4 - _camPos);
    highp float tmpvar_66;
    tmpvar_66 = sqrt(dot (tmpvar_65, tmpvar_65));
    d_62 = tmpvar_66;
    highp vec3 tmpvar_67;
    tmpvar_67 = (tmpvar_65 / tmpvar_66);
    viewdir_63.yz = tmpvar_67.yz;
    highp float tmpvar_68;
    tmpvar_68 = (Rg + ((Rt - Rg) * _experimentalAtmoScale));
    viewdir_63.x = (tmpvar_67.x + _viewdirOffset);
    highp vec3 tmpvar_69;
    tmpvar_69 = normalize(viewdir_63);
    viewdir_63 = tmpvar_69;
    highp float tmpvar_70;
    tmpvar_70 = sqrt(dot (_camPos, _camPos));
    r_61 = tmpvar_70;
    if ((tmpvar_70 < (0.9 * Rg))) {
      camera_56.y = (_camPos.y + Rg);
      _point_57.y = (worldPos_4.y + Rg);
      r_61 = sqrt(dot (camera_56, camera_56));
    };
    highp float tmpvar_71;
    tmpvar_71 = dot (camera_56, tmpvar_69);
    rMu_60 = tmpvar_71;
    mu_59 = (tmpvar_71 / r_61);
    highp vec3 tmpvar_72;
    tmpvar_72 = (_point_57 - (tmpvar_69 * clamp (1.0, 0.0, tmpvar_66)));
    _point_57 = tmpvar_72;
    highp float tmpvar_73;
    tmpvar_73 = max ((-(tmpvar_71) - sqrt((((tmpvar_71 * tmpvar_71) - (r_61 * r_61)) + (tmpvar_68 * tmpvar_68)))), 0.0);
    if (((tmpvar_73 > 0.0) && (tmpvar_73 < tmpvar_66))) {
      camera_56 = (camera_56 + (tmpvar_73 * tmpvar_69));
      highp float tmpvar_74;
      tmpvar_74 = (tmpvar_71 + tmpvar_73);
      rMu_60 = tmpvar_74;
      mu_59 = (tmpvar_74 / tmpvar_68);
      r_61 = tmpvar_68;
      d_62 = (tmpvar_66 - tmpvar_73);
    };
    if ((r_61 <= tmpvar_68)) {
      highp float muS1_75;
      highp float mu1_76;
      highp float r1_77;
      highp vec4 inScatter_78;
      highp float tmpvar_79;
      tmpvar_79 = dot (tmpvar_69, SUN_DIR);
      highp float tmpvar_80;
      tmpvar_80 = (dot (camera_56, SUN_DIR) / r_61);
      if ((r_61 < (Rg + 600.0))) {
        highp float tmpvar_81;
        tmpvar_81 = ((Rg + 600.0) / r_61);
        r_61 = (r_61 * tmpvar_81);
        rMu_60 = (rMu_60 * tmpvar_81);
        _point_57 = (tmpvar_72 * tmpvar_81);
      };
      highp float tmpvar_82;
      tmpvar_82 = sqrt(dot (_point_57, _point_57));
      r1_77 = tmpvar_82;
      highp float tmpvar_83;
      tmpvar_83 = (dot (_point_57, tmpvar_69) / tmpvar_82);
      mu1_76 = tmpvar_83;
      muS1_75 = (dot (_point_57, SUN_DIR) / tmpvar_82);
      if ((mu_59 > 0.0)) {
        highp vec3 tmpvar_84;
        highp float y_over_x_85;
        y_over_x_85 = (((mu_59 + 0.15) / 1.15) * 14.1014);
        highp float x_86;
        x_86 = (y_over_x_85 * inversesqrt(((y_over_x_85 * y_over_x_85) + 1.0)));
        highp vec4 tmpvar_87;
        tmpvar_87.zw = vec2(0.0, 0.0);
        tmpvar_87.x = ((sign(x_86) * (1.5708 - (sqrt((1.0 - abs(x_86))) * (1.5708 + (abs(x_86) * (-0.214602 + (abs(x_86) * (0.0865667 + (abs(x_86) * -0.0310296))))))))) / 1.5);
        tmpvar_87.y = sqrt(((r_61 - Rg) / (tmpvar_68 - Rg)));
        lowp vec4 tmpvar_88;
        tmpvar_88 = textureLod (_Transmittance, tmpvar_87.xy, 0.0);
        tmpvar_84 = tmpvar_88.xyz;
        highp vec3 tmpvar_89;
        highp float y_over_x_90;
        y_over_x_90 = (((tmpvar_83 + 0.15) / 1.15) * 14.1014);
        highp float x_91;
        x_91 = (y_over_x_90 * inversesqrt(((y_over_x_90 * y_over_x_90) + 1.0)));
        highp vec4 tmpvar_92;
        tmpvar_92.zw = vec2(0.0, 0.0);
        tmpvar_92.x = ((sign(x_91) * (1.5708 - (sqrt((1.0 - abs(x_91))) * (1.5708 + (abs(x_91) * (-0.214602 + (abs(x_91) * (0.0865667 + (abs(x_91) * -0.0310296))))))))) / 1.5);
        tmpvar_92.y = sqrt(((tmpvar_82 - Rg) / (tmpvar_68 - Rg)));
        lowp vec4 tmpvar_93;
        tmpvar_93 = textureLod (_Transmittance, tmpvar_92.xy, 0.0);
        tmpvar_89 = tmpvar_93.xyz;
        extinction_58 = min ((tmpvar_84 / tmpvar_89), vec3(1.0, 1.0, 1.0));
      } else {
        highp vec3 tmpvar_94;
        highp float y_over_x_95;
        y_over_x_95 = (((-(tmpvar_83) + 0.15) / 1.15) * 14.1014);
        highp float x_96;
        x_96 = (y_over_x_95 * inversesqrt(((y_over_x_95 * y_over_x_95) + 1.0)));
        highp vec4 tmpvar_97;
        tmpvar_97.zw = vec2(0.0, 0.0);
        tmpvar_97.x = ((sign(x_96) * (1.5708 - (sqrt((1.0 - abs(x_96))) * (1.5708 + (abs(x_96) * (-0.214602 + (abs(x_96) * (0.0865667 + (abs(x_96) * -0.0310296))))))))) / 1.5);
        tmpvar_97.y = sqrt(((tmpvar_82 - Rg) / (tmpvar_68 - Rg)));
        lowp vec4 tmpvar_98;
        tmpvar_98 = textureLod (_Transmittance, tmpvar_97.xy, 0.0);
        tmpvar_94 = tmpvar_98.xyz;
        highp vec3 tmpvar_99;
        highp float y_over_x_100;
        y_over_x_100 = (((-(mu_59) + 0.15) / 1.15) * 14.1014);
        highp float x_101;
        x_101 = (y_over_x_100 * inversesqrt(((y_over_x_100 * y_over_x_100) + 1.0)));
        highp vec4 tmpvar_102;
        tmpvar_102.zw = vec2(0.0, 0.0);
        tmpvar_102.x = ((sign(x_101) * (1.5708 - (sqrt((1.0 - abs(x_101))) * (1.5708 + (abs(x_101) * (-0.214602 + (abs(x_101) * (0.0865667 + (abs(x_101) * -0.0310296))))))))) / 1.5);
        tmpvar_102.y = sqrt(((r_61 - Rg) / (tmpvar_68 - Rg)));
        lowp vec4 tmpvar_103;
        tmpvar_103 = textureLod (_Transmittance, tmpvar_102.xy, 0.0);
        tmpvar_99 = tmpvar_103.xyz;
        extinction_58 = min ((tmpvar_94 / tmpvar_99), vec3(1.0, 1.0, 1.0));
      };
      highp float tmpvar_104;
      tmpvar_104 = -(sqrt((1.0 - ((Rg / r_61) * (Rg / r_61)))));
      highp float tmpvar_105;
      tmpvar_105 = abs((mu_59 - tmpvar_104));
      if ((tmpvar_105 < 0.004)) {
        highp vec4 inScatterA_106;
        highp vec4 inScatter0_107;
        highp float a_108;
        a_108 = (((mu_59 - tmpvar_104) + 0.004) / 0.008);
        highp float tmpvar_109;
        tmpvar_109 = (tmpvar_104 - 0.004);
        mu_59 = tmpvar_109;
        highp float tmpvar_110;
        tmpvar_110 = sqrt((((r_61 * r_61) + (d_62 * d_62)) + (((2.0 * r_61) * d_62) * tmpvar_109)));
        r1_77 = tmpvar_110;
        mu1_76 = (((r_61 * tmpvar_109) + d_62) / tmpvar_110);
        highp float uMu_111;
        highp float uR_112;
        highp float tmpvar_113;
        tmpvar_113 = sqrt(((tmpvar_68 * tmpvar_68) - (Rg * Rg)));
        highp float tmpvar_114;
        tmpvar_114 = sqrt(((r_61 * r_61) - (Rg * Rg)));
        highp float tmpvar_115;
        tmpvar_115 = (r_61 * tmpvar_109);
        highp float tmpvar_116;
        tmpvar_116 = (((tmpvar_115 * tmpvar_115) - (r_61 * r_61)) + (Rg * Rg));
        highp vec4 tmpvar_117;
        if (((tmpvar_115 < 0.0) && (tmpvar_116 > 0.0))) {
          highp vec4 tmpvar_118;
          tmpvar_118.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_118.w = (0.5 - (0.5 / RES_MU));
          tmpvar_117 = tmpvar_118;
        } else {
          highp vec4 tmpvar_119;
          tmpvar_119.x = -1.0;
          tmpvar_119.y = (tmpvar_113 * tmpvar_113);
          tmpvar_119.z = tmpvar_113;
          tmpvar_119.w = (0.5 + (0.5 / RES_MU));
          tmpvar_117 = tmpvar_119;
        };
        uR_112 = ((0.5 / RES_R) + ((tmpvar_114 / tmpvar_113) * (1.0 - (1.0/(RES_R)))));
        uMu_111 = (tmpvar_117.w + ((((tmpvar_115 * tmpvar_117.x) + sqrt((tmpvar_116 + tmpvar_117.y))) / (tmpvar_114 + tmpvar_117.z)) * (0.5 - (1.0/(RES_MU)))));
        highp float y_over_x_120;
        y_over_x_120 = (max (tmpvar_80, -0.1975) * 5.34962);
        highp float x_121;
        x_121 = (y_over_x_120 * inversesqrt(((y_over_x_120 * y_over_x_120) + 1.0)));
        highp float tmpvar_122;
        tmpvar_122 = ((0.5 / RES_MU_S) + (((((sign(x_121) * (1.5708 - (sqrt((1.0 - abs(x_121))) * (1.5708 + (abs(x_121) * (-0.214602 + (abs(x_121) * (0.0865667 + (abs(x_121) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        highp float tmpvar_123;
        tmpvar_123 = (((tmpvar_79 + 1.0) / 2.0) * (RES_NU - 1.0));
        highp float tmpvar_124;
        tmpvar_124 = floor(tmpvar_123);
        highp float tmpvar_125;
        tmpvar_125 = (tmpvar_123 - tmpvar_124);
        highp float tmpvar_126;
        tmpvar_126 = (floor(((uR_112 * RES_R) - 1.0)) / RES_R);
        highp float tmpvar_127;
        tmpvar_127 = (floor((uR_112 * RES_R)) / RES_R);
        highp float tmpvar_128;
        tmpvar_128 = fract((uR_112 * RES_R));
        highp vec4 tmpvar_129;
        tmpvar_129.zw = vec2(0.0, 0.0);
        tmpvar_129.x = ((tmpvar_124 + tmpvar_122) / RES_NU);
        tmpvar_129.y = ((uMu_111 / RES_R) + tmpvar_126);
        lowp vec4 tmpvar_130;
        tmpvar_130 = textureLod (_Inscatter, tmpvar_129.xy, 0.0);
        highp vec4 tmpvar_131;
        tmpvar_131.zw = vec2(0.0, 0.0);
        tmpvar_131.x = (((tmpvar_124 + tmpvar_122) + 1.0) / RES_NU);
        tmpvar_131.y = ((uMu_111 / RES_R) + tmpvar_126);
        lowp vec4 tmpvar_132;
        tmpvar_132 = textureLod (_Inscatter, tmpvar_131.xy, 0.0);
        highp vec4 tmpvar_133;
        tmpvar_133.zw = vec2(0.0, 0.0);
        tmpvar_133.x = ((tmpvar_124 + tmpvar_122) / RES_NU);
        tmpvar_133.y = ((uMu_111 / RES_R) + tmpvar_127);
        lowp vec4 tmpvar_134;
        tmpvar_134 = textureLod (_Inscatter, tmpvar_133.xy, 0.0);
        highp vec4 tmpvar_135;
        tmpvar_135.zw = vec2(0.0, 0.0);
        tmpvar_135.x = (((tmpvar_124 + tmpvar_122) + 1.0) / RES_NU);
        tmpvar_135.y = ((uMu_111 / RES_R) + tmpvar_127);
        lowp vec4 tmpvar_136;
        tmpvar_136 = textureLod (_Inscatter, tmpvar_135.xy, 0.0);
        inScatter0_107 = ((((tmpvar_130 * (1.0 - tmpvar_125)) + (tmpvar_132 * tmpvar_125)) * (1.0 - tmpvar_128)) + (((tmpvar_134 * (1.0 - tmpvar_125)) + (tmpvar_136 * tmpvar_125)) * tmpvar_128));
        highp float uMu_137;
        highp float uR_138;
        highp float tmpvar_139;
        tmpvar_139 = sqrt(((tmpvar_68 * tmpvar_68) - (Rg * Rg)));
        highp float tmpvar_140;
        tmpvar_140 = sqrt(((tmpvar_110 * tmpvar_110) - (Rg * Rg)));
        highp float tmpvar_141;
        tmpvar_141 = (tmpvar_110 * mu1_76);
        highp float tmpvar_142;
        tmpvar_142 = (((tmpvar_141 * tmpvar_141) - (tmpvar_110 * tmpvar_110)) + (Rg * Rg));
        highp vec4 tmpvar_143;
        if (((tmpvar_141 < 0.0) && (tmpvar_142 > 0.0))) {
          highp vec4 tmpvar_144;
          tmpvar_144.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_144.w = (0.5 - (0.5 / RES_MU));
          tmpvar_143 = tmpvar_144;
        } else {
          highp vec4 tmpvar_145;
          tmpvar_145.x = -1.0;
          tmpvar_145.y = (tmpvar_139 * tmpvar_139);
          tmpvar_145.z = tmpvar_139;
          tmpvar_145.w = (0.5 + (0.5 / RES_MU));
          tmpvar_143 = tmpvar_145;
        };
        uR_138 = ((0.5 / RES_R) + ((tmpvar_140 / tmpvar_139) * (1.0 - (1.0/(RES_R)))));
        uMu_137 = (tmpvar_143.w + ((((tmpvar_141 * tmpvar_143.x) + sqrt((tmpvar_142 + tmpvar_143.y))) / (tmpvar_140 + tmpvar_143.z)) * (0.5 - (1.0/(RES_MU)))));
        highp float y_over_x_146;
        y_over_x_146 = (max (muS1_75, -0.1975) * 5.34962);
        highp float x_147;
        x_147 = (y_over_x_146 * inversesqrt(((y_over_x_146 * y_over_x_146) + 1.0)));
        highp float tmpvar_148;
        tmpvar_148 = ((0.5 / RES_MU_S) + (((((sign(x_147) * (1.5708 - (sqrt((1.0 - abs(x_147))) * (1.5708 + (abs(x_147) * (-0.214602 + (abs(x_147) * (0.0865667 + (abs(x_147) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        highp float tmpvar_149;
        tmpvar_149 = (((tmpvar_79 + 1.0) / 2.0) * (RES_NU - 1.0));
        highp float tmpvar_150;
        tmpvar_150 = floor(tmpvar_149);
        highp float tmpvar_151;
        tmpvar_151 = (tmpvar_149 - tmpvar_150);
        highp float tmpvar_152;
        tmpvar_152 = (floor(((uR_138 * RES_R) - 1.0)) / RES_R);
        highp float tmpvar_153;
        tmpvar_153 = (floor((uR_138 * RES_R)) / RES_R);
        highp float tmpvar_154;
        tmpvar_154 = fract((uR_138 * RES_R));
        highp vec4 tmpvar_155;
        tmpvar_155.zw = vec2(0.0, 0.0);
        tmpvar_155.x = ((tmpvar_150 + tmpvar_148) / RES_NU);
        tmpvar_155.y = ((uMu_137 / RES_R) + tmpvar_152);
        lowp vec4 tmpvar_156;
        tmpvar_156 = textureLod (_Inscatter, tmpvar_155.xy, 0.0);
        highp vec4 tmpvar_157;
        tmpvar_157.zw = vec2(0.0, 0.0);
        tmpvar_157.x = (((tmpvar_150 + tmpvar_148) + 1.0) / RES_NU);
        tmpvar_157.y = ((uMu_137 / RES_R) + tmpvar_152);
        lowp vec4 tmpvar_158;
        tmpvar_158 = textureLod (_Inscatter, tmpvar_157.xy, 0.0);
        highp vec4 tmpvar_159;
        tmpvar_159.zw = vec2(0.0, 0.0);
        tmpvar_159.x = ((tmpvar_150 + tmpvar_148) / RES_NU);
        tmpvar_159.y = ((uMu_137 / RES_R) + tmpvar_153);
        lowp vec4 tmpvar_160;
        tmpvar_160 = textureLod (_Inscatter, tmpvar_159.xy, 0.0);
        highp vec4 tmpvar_161;
        tmpvar_161.zw = vec2(0.0, 0.0);
        tmpvar_161.x = (((tmpvar_150 + tmpvar_148) + 1.0) / RES_NU);
        tmpvar_161.y = ((uMu_137 / RES_R) + tmpvar_153);
        lowp vec4 tmpvar_162;
        tmpvar_162 = textureLod (_Inscatter, tmpvar_161.xy, 0.0);
        inScatterA_106 = max ((inScatter0_107 - (((((tmpvar_156 * (1.0 - tmpvar_151)) + (tmpvar_158 * tmpvar_151)) * (1.0 - tmpvar_154)) + (((tmpvar_160 * (1.0 - tmpvar_151)) + (tmpvar_162 * tmpvar_151)) * tmpvar_154)) * extinction_58.xyzx)), vec4(0.0, 0.0, 0.0, 0.0));
        highp float tmpvar_163;
        tmpvar_163 = (tmpvar_104 + 0.004);
        mu_59 = tmpvar_163;
        highp float tmpvar_164;
        tmpvar_164 = sqrt((((r_61 * r_61) + (d_62 * d_62)) + (((2.0 * r_61) * d_62) * tmpvar_163)));
        r1_77 = tmpvar_164;
        mu1_76 = (((r_61 * tmpvar_163) + d_62) / tmpvar_164);
        highp float uMu_165;
        highp float uR_166;
        highp float tmpvar_167;
        tmpvar_167 = sqrt(((tmpvar_68 * tmpvar_68) - (Rg * Rg)));
        highp float tmpvar_168;
        tmpvar_168 = sqrt(((r_61 * r_61) - (Rg * Rg)));
        highp float tmpvar_169;
        tmpvar_169 = (r_61 * tmpvar_163);
        highp float tmpvar_170;
        tmpvar_170 = (((tmpvar_169 * tmpvar_169) - (r_61 * r_61)) + (Rg * Rg));
        highp vec4 tmpvar_171;
        if (((tmpvar_169 < 0.0) && (tmpvar_170 > 0.0))) {
          highp vec4 tmpvar_172;
          tmpvar_172.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_172.w = (0.5 - (0.5 / RES_MU));
          tmpvar_171 = tmpvar_172;
        } else {
          highp vec4 tmpvar_173;
          tmpvar_173.x = -1.0;
          tmpvar_173.y = (tmpvar_167 * tmpvar_167);
          tmpvar_173.z = tmpvar_167;
          tmpvar_173.w = (0.5 + (0.5 / RES_MU));
          tmpvar_171 = tmpvar_173;
        };
        uR_166 = ((0.5 / RES_R) + ((tmpvar_168 / tmpvar_167) * (1.0 - (1.0/(RES_R)))));
        uMu_165 = (tmpvar_171.w + ((((tmpvar_169 * tmpvar_171.x) + sqrt((tmpvar_170 + tmpvar_171.y))) / (tmpvar_168 + tmpvar_171.z)) * (0.5 - (1.0/(RES_MU)))));
        highp float y_over_x_174;
        y_over_x_174 = (max (tmpvar_80, -0.1975) * 5.34962);
        highp float x_175;
        x_175 = (y_over_x_174 * inversesqrt(((y_over_x_174 * y_over_x_174) + 1.0)));
        highp float tmpvar_176;
        tmpvar_176 = ((0.5 / RES_MU_S) + (((((sign(x_175) * (1.5708 - (sqrt((1.0 - abs(x_175))) * (1.5708 + (abs(x_175) * (-0.214602 + (abs(x_175) * (0.0865667 + (abs(x_175) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        highp float tmpvar_177;
        tmpvar_177 = (((tmpvar_79 + 1.0) / 2.0) * (RES_NU - 1.0));
        highp float tmpvar_178;
        tmpvar_178 = floor(tmpvar_177);
        highp float tmpvar_179;
        tmpvar_179 = (tmpvar_177 - tmpvar_178);
        highp float tmpvar_180;
        tmpvar_180 = (floor(((uR_166 * RES_R) - 1.0)) / RES_R);
        highp float tmpvar_181;
        tmpvar_181 = (floor((uR_166 * RES_R)) / RES_R);
        highp float tmpvar_182;
        tmpvar_182 = fract((uR_166 * RES_R));
        highp vec4 tmpvar_183;
        tmpvar_183.zw = vec2(0.0, 0.0);
        tmpvar_183.x = ((tmpvar_178 + tmpvar_176) / RES_NU);
        tmpvar_183.y = ((uMu_165 / RES_R) + tmpvar_180);
        lowp vec4 tmpvar_184;
        tmpvar_184 = textureLod (_Inscatter, tmpvar_183.xy, 0.0);
        highp vec4 tmpvar_185;
        tmpvar_185.zw = vec2(0.0, 0.0);
        tmpvar_185.x = (((tmpvar_178 + tmpvar_176) + 1.0) / RES_NU);
        tmpvar_185.y = ((uMu_165 / RES_R) + tmpvar_180);
        lowp vec4 tmpvar_186;
        tmpvar_186 = textureLod (_Inscatter, tmpvar_185.xy, 0.0);
        highp vec4 tmpvar_187;
        tmpvar_187.zw = vec2(0.0, 0.0);
        tmpvar_187.x = ((tmpvar_178 + tmpvar_176) / RES_NU);
        tmpvar_187.y = ((uMu_165 / RES_R) + tmpvar_181);
        lowp vec4 tmpvar_188;
        tmpvar_188 = textureLod (_Inscatter, tmpvar_187.xy, 0.0);
        highp vec4 tmpvar_189;
        tmpvar_189.zw = vec2(0.0, 0.0);
        tmpvar_189.x = (((tmpvar_178 + tmpvar_176) + 1.0) / RES_NU);
        tmpvar_189.y = ((uMu_165 / RES_R) + tmpvar_181);
        lowp vec4 tmpvar_190;
        tmpvar_190 = textureLod (_Inscatter, tmpvar_189.xy, 0.0);
        inScatter0_107 = ((((tmpvar_184 * (1.0 - tmpvar_179)) + (tmpvar_186 * tmpvar_179)) * (1.0 - tmpvar_182)) + (((tmpvar_188 * (1.0 - tmpvar_179)) + (tmpvar_190 * tmpvar_179)) * tmpvar_182));
        highp float uMu_191;
        highp float uR_192;
        highp float tmpvar_193;
        tmpvar_193 = sqrt(((tmpvar_68 * tmpvar_68) - (Rg * Rg)));
        highp float tmpvar_194;
        tmpvar_194 = sqrt(((tmpvar_164 * tmpvar_164) - (Rg * Rg)));
        highp float tmpvar_195;
        tmpvar_195 = (tmpvar_164 * mu1_76);
        highp float tmpvar_196;
        tmpvar_196 = (((tmpvar_195 * tmpvar_195) - (tmpvar_164 * tmpvar_164)) + (Rg * Rg));
        highp vec4 tmpvar_197;
        if (((tmpvar_195 < 0.0) && (tmpvar_196 > 0.0))) {
          highp vec4 tmpvar_198;
          tmpvar_198.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_198.w = (0.5 - (0.5 / RES_MU));
          tmpvar_197 = tmpvar_198;
        } else {
          highp vec4 tmpvar_199;
          tmpvar_199.x = -1.0;
          tmpvar_199.y = (tmpvar_193 * tmpvar_193);
          tmpvar_199.z = tmpvar_193;
          tmpvar_199.w = (0.5 + (0.5 / RES_MU));
          tmpvar_197 = tmpvar_199;
        };
        uR_192 = ((0.5 / RES_R) + ((tmpvar_194 / tmpvar_193) * (1.0 - (1.0/(RES_R)))));
        uMu_191 = (tmpvar_197.w + ((((tmpvar_195 * tmpvar_197.x) + sqrt((tmpvar_196 + tmpvar_197.y))) / (tmpvar_194 + tmpvar_197.z)) * (0.5 - (1.0/(RES_MU)))));
        highp float y_over_x_200;
        y_over_x_200 = (max (muS1_75, -0.1975) * 5.34962);
        highp float x_201;
        x_201 = (y_over_x_200 * inversesqrt(((y_over_x_200 * y_over_x_200) + 1.0)));
        highp float tmpvar_202;
        tmpvar_202 = ((0.5 / RES_MU_S) + (((((sign(x_201) * (1.5708 - (sqrt((1.0 - abs(x_201))) * (1.5708 + (abs(x_201) * (-0.214602 + (abs(x_201) * (0.0865667 + (abs(x_201) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        highp float tmpvar_203;
        tmpvar_203 = (((tmpvar_79 + 1.0) / 2.0) * (RES_NU - 1.0));
        highp float tmpvar_204;
        tmpvar_204 = floor(tmpvar_203);
        highp float tmpvar_205;
        tmpvar_205 = (tmpvar_203 - tmpvar_204);
        highp float tmpvar_206;
        tmpvar_206 = (floor(((uR_192 * RES_R) - 1.0)) / RES_R);
        highp float tmpvar_207;
        tmpvar_207 = (floor((uR_192 * RES_R)) / RES_R);
        highp float tmpvar_208;
        tmpvar_208 = fract((uR_192 * RES_R));
        highp vec4 tmpvar_209;
        tmpvar_209.zw = vec2(0.0, 0.0);
        tmpvar_209.x = ((tmpvar_204 + tmpvar_202) / RES_NU);
        tmpvar_209.y = ((uMu_191 / RES_R) + tmpvar_206);
        lowp vec4 tmpvar_210;
        tmpvar_210 = textureLod (_Inscatter, tmpvar_209.xy, 0.0);
        highp vec4 tmpvar_211;
        tmpvar_211.zw = vec2(0.0, 0.0);
        tmpvar_211.x = (((tmpvar_204 + tmpvar_202) + 1.0) / RES_NU);
        tmpvar_211.y = ((uMu_191 / RES_R) + tmpvar_206);
        lowp vec4 tmpvar_212;
        tmpvar_212 = textureLod (_Inscatter, tmpvar_211.xy, 0.0);
        highp vec4 tmpvar_213;
        tmpvar_213.zw = vec2(0.0, 0.0);
        tmpvar_213.x = ((tmpvar_204 + tmpvar_202) / RES_NU);
        tmpvar_213.y = ((uMu_191 / RES_R) + tmpvar_207);
        lowp vec4 tmpvar_214;
        tmpvar_214 = textureLod (_Inscatter, tmpvar_213.xy, 0.0);
        highp vec4 tmpvar_215;
        tmpvar_215.zw = vec2(0.0, 0.0);
        tmpvar_215.x = (((tmpvar_204 + tmpvar_202) + 1.0) / RES_NU);
        tmpvar_215.y = ((uMu_191 / RES_R) + tmpvar_207);
        lowp vec4 tmpvar_216;
        tmpvar_216 = textureLod (_Inscatter, tmpvar_215.xy, 0.0);
        inScatter_78 = mix (inScatterA_106, max ((inScatter0_107 - (((((tmpvar_210 * (1.0 - tmpvar_205)) + (tmpvar_212 * tmpvar_205)) * (1.0 - tmpvar_208)) + (((tmpvar_214 * (1.0 - tmpvar_205)) + (tmpvar_216 * tmpvar_205)) * tmpvar_208)) * extinction_58.xyzx)), vec4(0.0, 0.0, 0.0, 0.0)), vec4(a_108));
      } else {
        highp vec4 inScatter0_1_217;
        highp float uMu_218;
        highp float uR_219;
        highp float tmpvar_220;
        tmpvar_220 = sqrt(((tmpvar_68 * tmpvar_68) - (Rg * Rg)));
        highp float tmpvar_221;
        tmpvar_221 = sqrt(((r_61 * r_61) - (Rg * Rg)));
        highp float tmpvar_222;
        tmpvar_222 = (r_61 * mu_59);
        highp float tmpvar_223;
        tmpvar_223 = (((tmpvar_222 * tmpvar_222) - (r_61 * r_61)) + (Rg * Rg));
        highp vec4 tmpvar_224;
        if (((tmpvar_222 < 0.0) && (tmpvar_223 > 0.0))) {
          highp vec4 tmpvar_225;
          tmpvar_225.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_225.w = (0.5 - (0.5 / RES_MU));
          tmpvar_224 = tmpvar_225;
        } else {
          highp vec4 tmpvar_226;
          tmpvar_226.x = -1.0;
          tmpvar_226.y = (tmpvar_220 * tmpvar_220);
          tmpvar_226.z = tmpvar_220;
          tmpvar_226.w = (0.5 + (0.5 / RES_MU));
          tmpvar_224 = tmpvar_226;
        };
        uR_219 = ((0.5 / RES_R) + ((tmpvar_221 / tmpvar_220) * (1.0 - (1.0/(RES_R)))));
        uMu_218 = (tmpvar_224.w + ((((tmpvar_222 * tmpvar_224.x) + sqrt((tmpvar_223 + tmpvar_224.y))) / (tmpvar_221 + tmpvar_224.z)) * (0.5 - (1.0/(RES_MU)))));
        highp float y_over_x_227;
        y_over_x_227 = (max (tmpvar_80, -0.1975) * 5.34962);
        highp float x_228;
        x_228 = (y_over_x_227 * inversesqrt(((y_over_x_227 * y_over_x_227) + 1.0)));
        highp float tmpvar_229;
        tmpvar_229 = ((0.5 / RES_MU_S) + (((((sign(x_228) * (1.5708 - (sqrt((1.0 - abs(x_228))) * (1.5708 + (abs(x_228) * (-0.214602 + (abs(x_228) * (0.0865667 + (abs(x_228) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        highp float tmpvar_230;
        tmpvar_230 = (((tmpvar_79 + 1.0) / 2.0) * (RES_NU - 1.0));
        highp float tmpvar_231;
        tmpvar_231 = floor(tmpvar_230);
        highp float tmpvar_232;
        tmpvar_232 = (tmpvar_230 - tmpvar_231);
        highp float tmpvar_233;
        tmpvar_233 = (floor(((uR_219 * RES_R) - 1.0)) / RES_R);
        highp float tmpvar_234;
        tmpvar_234 = (floor((uR_219 * RES_R)) / RES_R);
        highp float tmpvar_235;
        tmpvar_235 = fract((uR_219 * RES_R));
        highp vec4 tmpvar_236;
        tmpvar_236.zw = vec2(0.0, 0.0);
        tmpvar_236.x = ((tmpvar_231 + tmpvar_229) / RES_NU);
        tmpvar_236.y = ((uMu_218 / RES_R) + tmpvar_233);
        lowp vec4 tmpvar_237;
        tmpvar_237 = textureLod (_Inscatter, tmpvar_236.xy, 0.0);
        highp vec4 tmpvar_238;
        tmpvar_238.zw = vec2(0.0, 0.0);
        tmpvar_238.x = (((tmpvar_231 + tmpvar_229) + 1.0) / RES_NU);
        tmpvar_238.y = ((uMu_218 / RES_R) + tmpvar_233);
        lowp vec4 tmpvar_239;
        tmpvar_239 = textureLod (_Inscatter, tmpvar_238.xy, 0.0);
        highp vec4 tmpvar_240;
        tmpvar_240.zw = vec2(0.0, 0.0);
        tmpvar_240.x = ((tmpvar_231 + tmpvar_229) / RES_NU);
        tmpvar_240.y = ((uMu_218 / RES_R) + tmpvar_234);
        lowp vec4 tmpvar_241;
        tmpvar_241 = textureLod (_Inscatter, tmpvar_240.xy, 0.0);
        highp vec4 tmpvar_242;
        tmpvar_242.zw = vec2(0.0, 0.0);
        tmpvar_242.x = (((tmpvar_231 + tmpvar_229) + 1.0) / RES_NU);
        tmpvar_242.y = ((uMu_218 / RES_R) + tmpvar_234);
        lowp vec4 tmpvar_243;
        tmpvar_243 = textureLod (_Inscatter, tmpvar_242.xy, 0.0);
        inScatter0_1_217 = ((((tmpvar_237 * (1.0 - tmpvar_232)) + (tmpvar_239 * tmpvar_232)) * (1.0 - tmpvar_235)) + (((tmpvar_241 * (1.0 - tmpvar_232)) + (tmpvar_243 * tmpvar_232)) * tmpvar_235));
        highp float uMu_244;
        highp float uR_245;
        highp float tmpvar_246;
        tmpvar_246 = sqrt(((tmpvar_68 * tmpvar_68) - (Rg * Rg)));
        highp float tmpvar_247;
        tmpvar_247 = sqrt(((r1_77 * r1_77) - (Rg * Rg)));
        highp float tmpvar_248;
        tmpvar_248 = (r1_77 * mu1_76);
        highp float tmpvar_249;
        tmpvar_249 = (((tmpvar_248 * tmpvar_248) - (r1_77 * r1_77)) + (Rg * Rg));
        highp vec4 tmpvar_250;
        if (((tmpvar_248 < 0.0) && (tmpvar_249 > 0.0))) {
          highp vec4 tmpvar_251;
          tmpvar_251.xyz = vec3(1.0, 0.0, 0.0);
          tmpvar_251.w = (0.5 - (0.5 / RES_MU));
          tmpvar_250 = tmpvar_251;
        } else {
          highp vec4 tmpvar_252;
          tmpvar_252.x = -1.0;
          tmpvar_252.y = (tmpvar_246 * tmpvar_246);
          tmpvar_252.z = tmpvar_246;
          tmpvar_252.w = (0.5 + (0.5 / RES_MU));
          tmpvar_250 = tmpvar_252;
        };
        uR_245 = ((0.5 / RES_R) + ((tmpvar_247 / tmpvar_246) * (1.0 - (1.0/(RES_R)))));
        uMu_244 = (tmpvar_250.w + ((((tmpvar_248 * tmpvar_250.x) + sqrt((tmpvar_249 + tmpvar_250.y))) / (tmpvar_247 + tmpvar_250.z)) * (0.5 - (1.0/(RES_MU)))));
        highp float y_over_x_253;
        y_over_x_253 = (max (muS1_75, -0.1975) * 5.34962);
        highp float x_254;
        x_254 = (y_over_x_253 * inversesqrt(((y_over_x_253 * y_over_x_253) + 1.0)));
        highp float tmpvar_255;
        tmpvar_255 = ((0.5 / RES_MU_S) + (((((sign(x_254) * (1.5708 - (sqrt((1.0 - abs(x_254))) * (1.5708 + (abs(x_254) * (-0.214602 + (abs(x_254) * (0.0865667 + (abs(x_254) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
        highp float tmpvar_256;
        tmpvar_256 = (((tmpvar_79 + 1.0) / 2.0) * (RES_NU - 1.0));
        highp float tmpvar_257;
        tmpvar_257 = floor(tmpvar_256);
        highp float tmpvar_258;
        tmpvar_258 = (tmpvar_256 - tmpvar_257);
        highp float tmpvar_259;
        tmpvar_259 = (floor(((uR_245 * RES_R) - 1.0)) / RES_R);
        highp float tmpvar_260;
        tmpvar_260 = (floor((uR_245 * RES_R)) / RES_R);
        highp float tmpvar_261;
        tmpvar_261 = fract((uR_245 * RES_R));
        highp vec4 tmpvar_262;
        tmpvar_262.zw = vec2(0.0, 0.0);
        tmpvar_262.x = ((tmpvar_257 + tmpvar_255) / RES_NU);
        tmpvar_262.y = ((uMu_244 / RES_R) + tmpvar_259);
        lowp vec4 tmpvar_263;
        tmpvar_263 = textureLod (_Inscatter, tmpvar_262.xy, 0.0);
        highp vec4 tmpvar_264;
        tmpvar_264.zw = vec2(0.0, 0.0);
        tmpvar_264.x = (((tmpvar_257 + tmpvar_255) + 1.0) / RES_NU);
        tmpvar_264.y = ((uMu_244 / RES_R) + tmpvar_259);
        lowp vec4 tmpvar_265;
        tmpvar_265 = textureLod (_Inscatter, tmpvar_264.xy, 0.0);
        highp vec4 tmpvar_266;
        tmpvar_266.zw = vec2(0.0, 0.0);
        tmpvar_266.x = ((tmpvar_257 + tmpvar_255) / RES_NU);
        tmpvar_266.y = ((uMu_244 / RES_R) + tmpvar_260);
        lowp vec4 tmpvar_267;
        tmpvar_267 = textureLod (_Inscatter, tmpvar_266.xy, 0.0);
        highp vec4 tmpvar_268;
        tmpvar_268.zw = vec2(0.0, 0.0);
        tmpvar_268.x = (((tmpvar_257 + tmpvar_255) + 1.0) / RES_NU);
        tmpvar_268.y = ((uMu_244 / RES_R) + tmpvar_260);
        lowp vec4 tmpvar_269;
        tmpvar_269 = textureLod (_Inscatter, tmpvar_268.xy, 0.0);
        inScatter_78 = max ((inScatter0_1_217 - (((((tmpvar_263 * (1.0 - tmpvar_258)) + (tmpvar_265 * tmpvar_258)) * (1.0 - tmpvar_261)) + (((tmpvar_267 * (1.0 - tmpvar_258)) + (tmpvar_269 * tmpvar_258)) * tmpvar_261)) * extinction_58.xyzx)), vec4(0.0, 0.0, 0.0, 0.0));
      };
      highp float t_270;
      t_270 = max (min ((tmpvar_80 / 0.02), 1.0), 0.0);
      inScatter_78.w = (inScatter_78.w * (t_270 * (t_270 * (3.0 - (2.0 * t_270)))));
      result_64 = ((inScatter_78.xyz * ((3.0 / (16.0 * M_PI)) * (1.0 + (tmpvar_79 * tmpvar_79)))) + ((((inScatter_78.xyz * inScatter_78.w) / max (inScatter_78.x, 0.0001)) * (betaR.x / betaR)) * (((((1.5 / (4.0 * M_PI)) * (1.0 - (mieG * mieG))) * pow (((1.0 + (mieG * mieG)) - ((2.0 * mieG) * tmpvar_79)), -1.5)) * (1.0 + (tmpvar_79 * tmpvar_79))) / (2.0 + (mieG * mieG)))));
    };
    tmpvar_55 = (result_64 * SUN_INTENSITY);
    visib_2 = 1.0;
    highp float tmpvar_271;
    highp vec3 arg0_272;
    arg0_272 = (worldPos_4 - _camPos);
    tmpvar_271 = sqrt(dot (arg0_272, arg0_272));
    if ((tmpvar_271 <= _global_depth)) {
      visib_2 = (1.0 - exp((-1.0 * ((4.0 * tmpvar_271) / _global_depth))));
    };
    if (((tmpvar_15 && tmpvar_20) && (fakeOcean == 1.0))) {
      highp vec3 L_273;
      L_273 = (oceanColor_3 * extinction_58);
      highp vec3 tmpvar_274;
      tmpvar_274 = (L_273 * _Exposure);
      L_273 = tmpvar_274;
      highp float tmpvar_275;
      if ((tmpvar_274.x < 1.413)) {
        tmpvar_275 = pow ((tmpvar_274.x * 0.38317), 0.454545);
      } else {
        tmpvar_275 = (1.0 - exp(-(tmpvar_274.x)));
      };
      L_273.x = tmpvar_275;
      highp float tmpvar_276;
      if ((tmpvar_274.y < 1.413)) {
        tmpvar_276 = pow ((tmpvar_274.y * 0.38317), 0.454545);
      } else {
        tmpvar_276 = (1.0 - exp(-(tmpvar_274.y)));
      };
      L_273.y = tmpvar_276;
      highp float tmpvar_277;
      if ((tmpvar_274.z < 1.413)) {
        tmpvar_277 = pow ((tmpvar_274.z * 0.38317), 0.454545);
      } else {
        tmpvar_277 = (1.0 - exp(-(tmpvar_274.z)));
      };
      L_273.z = tmpvar_277;
      highp vec3 L_278;
      highp vec3 tmpvar_279;
      tmpvar_279 = (tmpvar_55 * _Exposure);
      L_278 = tmpvar_279;
      highp float tmpvar_280;
      if ((tmpvar_279.x < 1.413)) {
        tmpvar_280 = pow ((tmpvar_279.x * 0.38317), 0.454545);
      } else {
        tmpvar_280 = (1.0 - exp(-(tmpvar_279.x)));
      };
      L_278.x = tmpvar_280;
      highp float tmpvar_281;
      if ((tmpvar_279.y < 1.413)) {
        tmpvar_281 = pow ((tmpvar_279.y * 0.38317), 0.454545);
      } else {
        tmpvar_281 = (1.0 - exp(-(tmpvar_279.y)));
      };
      L_278.y = tmpvar_281;
      highp float tmpvar_282;
      if ((tmpvar_279.z < 1.413)) {
        tmpvar_282 = pow ((tmpvar_279.z * 0.38317), 0.454545);
      } else {
        tmpvar_282 = (1.0 - exp(-(tmpvar_279.z)));
      };
      L_278.z = tmpvar_282;
      highp vec4 tmpvar_283;
      tmpvar_283.xyz = mix (L_273, L_278, vec3((_global_alpha * visib_2)));
      tmpvar_283.w = _fade;
      tmpvar_1 = tmpvar_283;
    } else {
      highp vec3 L_284;
      highp vec3 tmpvar_285;
      tmpvar_285 = (tmpvar_55 * _Exposure);
      L_284 = tmpvar_285;
      highp float tmpvar_286;
      if ((tmpvar_285.x < 1.413)) {
        tmpvar_286 = pow ((tmpvar_285.x * 0.38317), 0.454545);
      } else {
        tmpvar_286 = (1.0 - exp(-(tmpvar_285.x)));
      };
      L_284.x = tmpvar_286;
      highp float tmpvar_287;
      if ((tmpvar_285.y < 1.413)) {
        tmpvar_287 = pow ((tmpvar_285.y * 0.38317), 0.454545);
      } else {
        tmpvar_287 = (1.0 - exp(-(tmpvar_285.y)));
      };
      L_284.y = tmpvar_287;
      highp float tmpvar_288;
      if ((tmpvar_285.z < 1.413)) {
        tmpvar_288 = pow ((tmpvar_285.z * 0.38317), 0.454545);
      } else {
        tmpvar_288 = (1.0 - exp(-(tmpvar_285.z)));
      };
      L_284.z = tmpvar_288;
      highp vec4 tmpvar_289;
      tmpvar_289.xyz = L_284;
      tmpvar_289.w = ((_global_alpha * visib_2) * _fade);
      tmpvar_1 = tmpvar_289;
    };
  };
  _glesFragData[0] = tmpvar_1;
}



#endif"
}
}
Program "fp" {
SubProgram "opengl " {
"!!GLSL"
}
SubProgram "d3d9 " {
// Stats: 1013 math, 61 textures, 9 branches
Matrix 0 [_ViewProjInv]
Float 4 [M_PI]
Float 5 [Rg]
Float 6 [Rt]
Float 7 [RES_R]
Float 8 [RES_MU]
Float 9 [RES_MU_S]
Float 10 [RES_NU]
Vector 11 [SUN_DIR]
Float 12 [SUN_INTENSITY]
Vector 13 [betaR]
Float 14 [mieG]
Float 15 [_viewdirOffset]
Float 16 [_experimentalAtmoScale]
Float 17 [_global_alpha]
Float 18 [_Exposure]
Float 19 [_global_depth]
Float 20 [_Ocean_Sigma]
Float 21 [fakeOcean]
Float 22 [_fade]
Vector 23 [_Ocean_Color]
Vector 24 [_camPos]
SetTexture 0 [_customDepthTexture] 2D 0
SetTexture 1 [_Transmittance] 2D 1
SetTexture 2 [_Irradiance] 2D 2
SetTexture 3 [_Inscatter] 2D 3
"ps_3_0
dcl_2d s0
dcl_2d s1
dcl_2d s2
dcl_2d s3
def c25, 2.00000000, -1.00000000, 1.00000000, 0.00000000
def c26, 4.00000000, 0.01000000, -2.00000000, 2.71828198
def c27, 0.98000002, 0.02000000, 0.89999998, 0.15000001
def c28, 12.26193905, -0.01348047, 0.05747731, -0.12123910
def c29, 0.19563590, -0.33299461, 0.99999559, 1.57079601
def c30, 0.66666669, 0.20000000, 0.83333331, 0.50000000
def c31, -2.69000006, 5.00000000, 1.50000000, 10.00000000
def c32, 22.70000076, 1.00000000, 1000000015047466200000000000000.00000000, 600.00000000
def c33, 0.00400000, -0.19750001, 5.34960032, -0.00400000
def c34, 0.90909088, 0.74000001, 124.99999237, 16.00000000
def c35, -1.50000000, 50.00000000, 2.00000000, 3.00000000
def c36, 0.00010000, 0.38317001, 0.45454544, -1.41299999
dcl_texcoord2 v0.xy
texld r0.x, v0, s0
mov r3.z, r0.x
mad r3.xy, v0, c25.x, c25.y
mov r3.w, c25.z
dp4 r0.w, r3, c3
dp4 r0.z, r3, c2
dp4 r0.y, r3, c1
dp4 r0.x, r3, c0
rcp r0.w, r0.w
mul r8.xyz, r0, r0.w
mov r3.xyz, c24
dp3 r0.y, c25.w, r3
dp3 r0.x, c24, c24
add r0.w, r0.x, -r0.y
add r0.xyz, r8, -c24
mad r1.y, -c5.x, c5.x, r0.w
dp3 r0.w, r0, r0
dp3 r0.x, r0, c24
mul r1.y, r0.w, r1
mul r0.y, r1, c26.x
mul r0.x, r0, c25
mad r0.y, r0.x, r0.x, -r0
cmp_pp r0.z, r0.y, c25, c25.w
rsq r1.y, r0.y
mul r1.z, r0.w, c25.x
rcp r0.w, r1.y
add r0.x, -r0, -r0.w
rcp r1.y, r1.z
mul r0.w, r0.x, r1.y
cmp r0.x, r0.y, r1, c25.y
cmp r1.x, -r0.z, r0, r0.w
dp3 r1.y, r8, r8
rsq r0.y, r1.y
rcp r0.x, r0.y
add r0.y, r0.x, -c6.x
cmp r9.w, -r1.x, c25, c25.z
abs_pp r0.x, r9.w
cmp r0.y, r0, c25.z, c25.w
cmp_pp r0.x, -r0, c25.z, c25.w
mul_pp r1.y, r0.x, r0
cmp_pp r0, -r1.y, r2, c25.w
mov_pp r2, r0
cmp_pp r8.w, -r1.y, c25.z, c25
mov_pp oC0, r0
if_gt r8.w, c25.w
add r0.xyz, r8, -c24
mul r1.xyz, r1.x, r0
dp3 r0.y, r0, r0
dp3 r0.x, r1, r1
rsq r0.y, r0.y
rsq r0.x, r0.x
rcp r0.y, r0.y
rcp r0.x, r0.x
add r0.x, r0, -r0.y
cmp r10.w, r0.x, c25, c25.z
add r0.xyz, r1, c24
mul_pp r0.w, r10, r9
mov r9.xyz, c25.z
if_gt r0.w, c25.w
mov r0.w, c25.z
mov r8.xyz, r0
if_eq c21.x, r0.w
dp3 r0.w, r0, r0
rsq r0.w, r0.w
rcp r1.x, r0.w
mul r3.xyz, r0.w, r0
max r1.x, r1, c5
mul r0.xyz, r3, r1.x
dp3 r0.w, r0, r0
rsq r0.w, r0.w
rcp r1.w, r0.w
mov r0.w, c5.x
mov r1.xy, r0
mad r0.w, c27.z, -r0, r1
add r1.z, r0, c5.x
cmp r1.z, r0.w, r0, r1
dp3 r3.w, r1, r1
rsq r3.w, r3.w
rcp r3.w, r3.w
cmp r0.w, r0, r1, r3
rcp r4.w, r0.w
mul r5.xyz, r1, r4.w
dp3 r3.w, r5, c11
add r1.x, r3.w, c27.w
mul r1.y, r1.x, c28.x
abs r1.z, r1.y
max r1.x, r1.z, c25.z
rcp r1.w, r1.x
min r1.x, r1.z, c25.z
mul r1.x, r1, r1.w
mul r1.w, r1.x, r1.x
mad r4.x, r1.w, c28.y, c28.z
mad r4.x, r4, r1.w, c28.w
mad r4.x, r4, r1.w, c29
mad r4.x, r4, r1.w, c29.y
mad r1.w, r4.x, r1, c29.z
mul r1.w, r1, r1.x
mov r1.x, c6
add r1.x, -c5, r1
add r4.x, -r1.w, c29.w
add r1.z, r1, c25.y
cmp r4.x, -r1.z, r1.w, r4
rcp r1.x, r1.x
add r0.w, r0, -c5.x
mul r1.zw, r0.w, r1.x
cmp r0.w, r1.y, r4.x, -r4.x
rsq r1.x, r1.z
rcp r4.y, r1.x
mul r4.x, r0.w, c30
add r1.xyz, r0, -c24
mov r4.z, c25.w
texldl r0.xyz, r4.xyzz, s1
dp3 r0.w, r1, r1
rsq r0.w, r0.w
mul r1.xyz, r0.w, r1
mul r4.x, r4.w, c5
mad r0.w, -r4.x, r4.x, c25.z
rsq r4.w, r0.w
add r4.xyz, -r1, c11
dp3 r0.w, r4, r4
rsq r0.w, r0.w
rcp r4.w, r4.w
mul r6.xyz, r0.w, r4
add r4.w, r3, r4
cmp r4.xyz, r4.w, r0, c25.w
dp3 r0.x, -r1, r6
dp3 r0.z, r3, r6
add r0.w, r0.z, c25.z
rcp r4.w, r0.w
add r0.x, -r0, c25.z
mul r0.y, r0.x, r0.x
mul r0.y, r0, r0
mul r0.x, r0.y, r0
mad r5.x, r0, c27, c27.y
rcp r0.w, c20.x
mad r0.z, -r0, r0, c25
mul r0.z, r0, r0.w
mul r0.z, r0, r4.w
mul r4.w, r0.z, c26.z
pow r0, c26.w, r4.w
dp3 r0.w, -r1, r3
max r0.y, r0.w, c26
mov r0.z, r0.x
rcp r1.x, r0.y
dp3 r0.y, r3, c11
max r4.w, r0.y, c26.y
mul r0.y, r4.w, r1.x
mov r0.x, c4
mul r0.x, c20, r0
mul r0.x, r0, c26
rcp r0.x, r0.x
mul r0.x, r0.z, r0
abs r0.y, r0
rsq r0.z, r0.y
mul r0.y, r5.x, r0.x
rcp r0.z, r0.z
mul r5.y, r0, r0.z
add r0.x, r3.w, c30.y
rsq r1.x, c20.x
rcp r3.w, r1.x
mov r0.y, r1.w
mul r4.xyz, r4, c12.x
mul r0.x, r0, c30.z
mov r0.z, c25.w
texldl r0.xyz, r0.xyzz, s2
mul r3.xyz, r0, c12.x
add r0.y, r5.z, c25.z
mul r0.x, r3.w, c31
pow r1, c26.w, r0.x
add r1.y, -r0.w, c25.z
mul r5.x, r0.y, c30.w
pow r0, r3.w, c31.z
mov r0.y, r1.x
mul r1.x, r0.y, c31.y
mov r1.z, r0.x
pow r0, r1.y, r1.x
mad r0.y, r1.z, c32.x, c32
rcp r0.y, r0.y
mul r0.w, r0.x, r0.y
mul r0.xyz, r3, r5.x
add r1.x, -r0.w, c25.z
max r3.x, r5.y, c25.w
mul r0.xyz, r0, c25.x
mul r1.xyz, r1.x, c23
mul r1.xyz, r1, r0
mul r0.xyz, r0.w, r0
rcp r1.w, c4.x
mul r5.xyz, r0, r1.w
cmp r0.x, -r4.w, c25.w, r3
mad r3.xyz, r0.x, r4, r5
mul r0.xyz, r1, r1.w
mad r9.xyz, r0, c31.w, r3
endif
endif
add r0.xyz, r8, -c24
dp3 r0.w, r0, r0
rsq r3.y, r0.w
mul r0.xyz, r3.y, r0
mov r1.yz, r0
add r1.x, r0, c15
dp3 r0.x, r1, r1
rsq r3.z, r0.x
mov r0.y, c24
add r3.x, c5, r0.y
dp3 r0.w, c24, c24
rsq r0.w, r0.w
rcp r4.w, r3.y
mov r0.xz, c24
mul r1.xyz, r3.z, r1
rcp r0.w, r0.w
mov r0.y, c5.x
mad r1.w, c27.z, -r0.y, r0
cmp r0.y, r1.w, c24, r3.x
dp3 r3.x, r0, r0
rsq r3.x, r3.x
rcp r3.z, r3.x
cmp r4.x, r1.w, r0.w, r3.z
mov r3.x, c6
add r0.w, -c5.x, r3.x
mul r0.w, r0, c16.x
dp3 r3.w, r0, r1
mul r3.x, r4, r4
add r0.w, r0, c5.x
mad r3.x, r3.w, r3.w, -r3
mad r3.x, r0.w, r0.w, r3
rsq r3.z, r3.x
rcp r3.z, r3.z
cmp r3.x, r3, r3.z, c32.z
add r3.x, -r3.w, -r3
max r4.y, r3.x, c25.w
add r4.z, r4.y, -r4.w
cmp r5.x, r4.z, c25.w, c25.z
cmp r4.z, -r4.y, c25.w, c25
mul_pp r4.z, r4, r5.x
mad r3.xyz, r4.y, r1, r0
add r5.x, -r4.y, r4.w
cmp r0.xyz, -r4.z, r0, r3
add r3.x, r8.y, c5
cmp r3.y, r1.w, r8, r3.x
cmp r16.x, -r4.z, r4, r0.w
mov_sat r1.w, r4
cmp r15.w, -r4.z, r4, r5.x
mov r3.xz, r8
mad r3.xyz, -r1, r1.w, r3
rcp r1.w, r4.x
add r4.y, r4, r3.w
rcp r4.w, r0.w
mul r4.y, r4, r4.w
mul r1.w, r3, r1
cmp r11.w, -r4.z, r1, r4.y
mov r4.xyz, c25.w
mov r10.xyz, c25.z
if_le r16.x, r0.w
mov r1.w, c5.x
add r3.w, c32, r1
rcp r1.w, r16.x
add r4.w, r16.x, -r3
dp3 r0.x, r0, c11
mul r4.x, r1.w, r3.w
mul r4.xyz, r3, r4.x
cmp r3.xyz, r4.w, r3, r4
mul r13.w, r0.x, r1
dp3 r4.x, r3, r3
dp3 r4.y, r3, c11
dp3 r3.y, r1, r3
rsq r3.x, r4.x
mul r6.z, r3.x, r3.y
mul r7.w, r3.x, r4.y
rcp r11.z, r3.x
dp3 r12.w, r1, c11
cmp r16.x, r4.w, r16, r3.w
if_gt r11.w, c25.w
add r0.x, r6.z, c27.w
mul r1.x, r0, c28
abs r1.y, r1.x
max r0.x, r1.y, c25.z
rcp r0.y, r0.x
min r0.x, r1.y, c25.z
mul r1.z, r0.x, r0.y
add r0.x, r11.w, c27.w
mul r1.w, r0.x, c28.x
mul r3.y, r1.z, r1.z
mad r0.x, r3.y, c28.y, c28.z
mad r0.y, r0.x, r3, c28.w
abs r3.x, r1.w
mad r0.z, r0.y, r3.y, c29.x
max r0.x, r3, c25.z
rcp r0.y, r0.x
min r0.x, r3, c25.z
mul r0.y, r0.x, r0
mad r0.x, r0.z, r3.y, c29.y
mad r3.y, r0.x, r3, c29.z
mul r0.z, r0.y, r0.y
mul r1.z, r3.y, r1
mad r0.x, r0.z, c28.y, c28.z
mad r0.x, r0, r0.z, c28.w
mad r0.x, r0, r0.z, c29
add r3.y, -r1.z, c29.w
add r1.y, r1, c25
cmp r1.y, -r1, r1.z, r3
cmp r1.y, r1.x, r1, -r1
mad r1.x, r0, r0.z, c29.y
mad r0.z, r1.x, r0, c29
mul r3.y, r0.z, r0
mul r0.x, r1.y, c30
add r1.x, r0.w, -c5
rcp r3.z, r1.x
add r1.y, r11.z, -c5.x
mul r1.x, r3.z, r1.y
rsq r0.y, r1.x
mov r0.z, c25.w
rcp r0.y, r0.y
texldl r1.xyz, r0.xyzz, s1
add r0.y, -r3, c29.w
add r0.x, r3, c25.y
cmp r0.x, -r0, r3.y, r0.y
add r0.y, r16.x, -c5.x
cmp r0.x, r1.w, r0, -r0
mul r0.y, r0, r3.z
rsq r0.y, r0.y
mul r0.x, r0, c30
mov r0.z, c25.w
rcp r0.y, r0.y
texldl r0.xyz, r0.xyzz, s1
rcp r1.x, r1.x
rcp r1.z, r1.z
rcp r1.y, r1.y
mul r0.xyz, r0, r1
min r10.xyz, r0, c25.z
else
add r0.x, -r11.w, c27.w
mul r1.x, r0, c28
abs r1.y, r1.x
max r0.x, r1.y, c25.z
rcp r0.y, r0.x
min r0.x, r1.y, c25.z
mul r1.z, r0.x, r0.y
add r0.x, -r6.z, c27.w
mul r1.w, r0.x, c28.x
mul r3.y, r1.z, r1.z
mad r0.x, r3.y, c28.y, c28.z
mad r0.y, r0.x, r3, c28.w
abs r3.x, r1.w
mad r0.z, r0.y, r3.y, c29.x
max r0.x, r3, c25.z
rcp r0.y, r0.x
min r0.x, r3, c25.z
mul r0.y, r0.x, r0
mad r0.x, r0.z, r3.y, c29.y
mad r3.y, r0.x, r3, c29.z
mul r0.z, r0.y, r0.y
mul r1.z, r3.y, r1
mad r0.x, r0.z, c28.y, c28.z
mad r0.x, r0, r0.z, c28.w
mad r0.x, r0, r0.z, c29
add r3.y, -r1.z, c29.w
add r1.y, r1, c25
cmp r1.y, -r1, r1.z, r3
cmp r1.y, r1.x, r1, -r1
mad r1.x, r0, r0.z, c29.y
mad r0.z, r1.x, r0, c29
mul r3.y, r0.z, r0
mul r0.x, r1.y, c30
add r1.x, r0.w, -c5
rcp r3.z, r1.x
add r1.y, r16.x, -c5.x
mul r1.x, r3.z, r1.y
rsq r0.y, r1.x
mov r0.z, c25.w
rcp r0.y, r0.y
texldl r1.xyz, r0.xyzz, s1
add r0.y, -r3, c29.w
add r0.x, r3, c25.y
cmp r0.x, -r0, r3.y, r0.y
add r0.y, r11.z, -c5.x
cmp r0.x, r1.w, r0, -r0
mul r0.y, r0, r3.z
rsq r0.y, r0.y
mul r0.x, r0, c30
mov r0.z, c25.w
rcp r0.y, r0.y
texldl r0.xyz, r0.xyzz, s1
rcp r1.x, r1.x
rcp r1.z, r1.z
rcp r1.y, r1.y
mul r0.xyz, r0, r1
min r10.xyz, r0, c25.z
endif
rcp r0.x, r16.x
mul r0.x, r0, c5
mad r0.x, -r0, r0, c25.z
rsq r0.x, r0.x
rcp r0.x, r0.x
add r0.y, r0.x, r11.w
abs r0.y, r0
mov r14.w, -r0.x
if_lt r0.y, c33.x
rcp r1.w, c8.x
add r5.x, r14.w, c33
rcp r13.y, c7.x
mul r12.y, c5.x, c5.x
mad r0.z, r0.w, r0.w, -r12.y
add r17.x, r14.w, c33.w
mul r0.x, r15.w, r15.w
mov r3.xyz, c25.zwww
rsq r12.z, r0.z
mad r3.w, -r1, c30, c30
mad r4.w, r1, c30, c30
add r13.z, -r1.w, c30.w
mov r4.x, c25.y
rcp r7.x, c10.x
mul r11.z, r16.x, r5.x
add r15.z, -r13.y, c25
mul r14.z, r16.x, r17.x
mad r16.y, r16.x, r16.x, r0.x
mul r16.z, r16.x, r15.w
mul r0.x, r16.z, r5
mad r0.x, r0, c25, r16.y
rsq r0.x, r0.x
mad r0.y, r16.x, r5.x, r15.w
rcp r1.x, r0.x
mul r0.y, r0.x, r0
mul r1.y, r1.x, r0
mul r0.y, r1.x, r1.x
mad r0.y, r1, r1, -r0
mad r1.z, c5.x, c5.x, r0.y
mad r1.x, r1, r1, -r12.y
rsq r1.x, r1.x
cmp r0.y, -r1.z, c25.w, c25.z
cmp r0.x, r1.y, c25.w, c25.z
mul_pp r0.x, r0, r0.y
rcp r0.y, r12.z
mul r4.y, r0, r0
mov r4.z, r0.y
cmp r0, -r0.x, r4, r3
add r0.y, r0, r1.z
rcp r1.x, r1.x
rsq r0.y, r0.y
rcp r0.y, r0.y
add r0.z, r0, r1.x
mad r0.x, r1.y, r0, r0.y
rcp r0.y, r0.z
mul r0.x, r0, r0.y
max r0.y, r7.w, c33
rcp r7.w, c9.x
mad r0.x, r0, r13.z, r0.w
mul r0.z, r12, r1.x
mul r0.w, r0.z, r15.z
mad r1.x, r13.y, c30.w, r0.w
mul r1.z, r1.x, c7.x
frc r11.y, r1.z
add r1.w, r1.z, -r11.y
mul r1.w, r13.y, r1
mul r0.y, r0, c33.z
abs r0.z, r0.y
max r0.w, r0.z, c25.z
rcp r1.x, r0.w
min r0.w, r0.z, c25.z
mul r0.w, r0, r1.x
mul r1.x, r0.w, r0.w
mad r1.y, r1.x, c28, c28.z
mad r1.y, r1, r1.x, c28.w
mad r1.y, r1, r1.x, c29.x
mad r1.y, r1, r1.x, c29
mad r1.x, r1.y, r1, c29.z
mul r0.w, r1.x, r0
mad r5.y, r0.x, r13, r1.w
add r1.z, r1, c25.y
frc r1.w, r1.z
add r1.y, r1.z, -r1.w
mul r1.y, r1, r13
add r11.x, -r7.w, c25.z
add r1.x, -r0.w, c29.w
add r0.z, r0, c25.y
cmp r0.z, -r0, r0.w, r1.x
cmp r0.y, r0, r0.z, -r0.z
mov r0.w, c10.x
mad r0.y, r0, c34.x, c34
mad r0.y, r0, r11.x, r7.w
mul r7.z, r16.x, r16.x
add r0.w, c25.y, r0
add r0.z, r12.w, c25
mul r0.z, r0, r0.w
mul r0.z, r0, c30.w
frc r15.x, r0.z
add r7.y, r0.z, -r15.x
mad r0.w, r0.y, c30, r7.y
mad r0.y, r0.x, r13, r1
add r0.x, r0.w, c25.z
mul r12.x, r7, r0
add r15.y, -r15.x, c25.z
mul r13.x, r0.w, r7
mov r0.z, c25.w
mov r0.x, r12
texldl r1, r0.xyzz, s3
mul r1, r15.x, r1
mov r0.z, c25.w
mov r0.x, r13
texldl r0, r0.xyzz, s3
mad r6, r0, r15.y, r1
mov r0.y, r5
mov r0.z, c25.w
mov r0.x, r13
texldl r1, r0.xyzz, s3
mad r0.x, r11.z, r11.z, -r7.z
mad r14.x, c5, c5, r0
cmp r0.y, -r14.x, c25.w, c25.z
cmp r0.x, r11.z, c25.w, c25.z
mul_pp r0.x, r0, r0.y
cmp r0, -r0.x, r4, r3
add r0.y, r0, r14.x
rsq r0.y, r0.y
rcp r14.x, r0.y
add r0.y, -r11, c25.z
mov r5.x, r12
mov r5.z, c25.w
texldl r5, r5.xyzz, s3
mul r5, r15.x, r5
mad r1, r15.y, r1, r5
mul r1, r11.y, r1
mad r5, r6, r0.y, r1
mad r1.z, r11, r0.x, r14.x
mad r0.y, r16.x, r16.x, -r12
rsq r0.y, r0.y
rcp r14.y, r0.y
add r1.x, r0.z, r14.y
max r0.x, r13.w, c33.y
mul r0.x, r0, c33.z
abs r0.y, r0.x
max r0.z, r0.y, c25
rcp r1.w, r1.x
rcp r1.x, r0.z
min r0.z, r0.y, c25
mul r1.y, r0.z, r1.x
mul r0.z, r1, r1.w
mad r1.x, r13.z, r0.z, r0.w
mul r1.z, r1.y, r1.y
mul r0.w, r12.z, r14.y
mad r0.z, r1, c28.y, c28
mad r0.z, r0, r1, c28.w
mul r0.w, r15.z, r0
mad r0.z, r0, r1, c29.x
mad r1.w, r13.y, c30, r0
mad r0.w, r0.z, r1.z, c29.y
mul r0.z, r1.w, c7.x
mad r0.w, r0, r1.z, c29.z
mul r0.w, r0, r1.y
add r1.z, r0, c25.y
frc r16.w, r0.z
add r1.y, -r0.w, c29.w
add r0.y, r0, c25
cmp r0.y, -r0, r0.w, r1
cmp r0.x, r0, r0.y, -r0.y
frc r1.w, r1.z
add r0.w, r1.z, -r1
mul r11.z, r13.y, r0.w
add r0.y, r0.z, -r16.w
mad r0.x, r0, c34, c34.y
mad r0.x, r11, r0, r7.w
mad r6.w, r0.x, c30, r7.y
mul r11.y, r13, r0
add r0.x, r6.w, c25.z
mul r11.x, r7, r0
mul r14.x, r7, r6.w
mad r6.y, r13, r1.x, r11.z
mad r7.y, r13, r1.x, r11
mov r6.z, c25.w
mov r6.x, r11
texldl r0, r6.xyzz, s3
mul r1, r15.x, r0
mov r0.y, r6
mov r7.x, r11
mov r0.z, c25.w
mov r0.x, r14
texldl r0, r0.xyzz, s3
mad r6, r15.y, r0, r1
mad r1.x, r14.z, r14.z, -r7.z
mad r17.y, c5.x, c5.x, r1.x
cmp r1.x, r14.z, c25.w, c25.z
cmp r1.y, -r17, c25.w, c25.z
mov r0.y, r7
mov r7.z, c25.w
mul_pp r7.w, r1.x, r1.y
texldl r1, r7.xyzz, s3
cmp r7, -r7.w, r4, r3
mul r1, r15.x, r1
add r7.y, r7, r17
mov r0.x, r14
mov r0.z, c25.w
texldl r0, r0.xyzz, s3
mad r0, r15.y, r0, r1
add r1.y, r14, r7.z
rsq r1.x, r7.y
rcp r1.x, r1.x
mad r1.x, r14.z, r7, r1
rcp r1.y, r1.y
mul r1.x, r1, r1.y
mad r7.y, r13.z, r1.x, r7.w
mad r11.y, r13, r7, r11
mul r0, r16.w, r0
add r7.x, -r16.w, c25.z
mad r1, r6, r7.x, r0
mad r6.y, r13, r7, r11.z
mul r7.y, r16.z, r17.x
mad r7.y, r7, c25.x, r16
rsq r7.z, r7.y
rcp r7.y, r7.z
mad r7.w, r16.x, r17.x, r15
mul r7.z, r7, r7.w
mul r7.z, r7.y, r7
mul r7.w, r7.y, r7.y
mad r7.w, r7.z, r7.z, -r7
mov r6.z, c25.w
mov r6.x, r11
texldl r0, r6.xyzz, s3
mad r5, -r5, r10.xyzx, r1
mul r1, r15.x, r0
mov r0.y, r6
mad r7.w, c5.x, c5.x, r7
mov r0.z, c25.w
mov r0.x, r14
texldl r0, r0.xyzz, s3
mad r6, r15.y, r0, r1
mov r11.z, c25.w
texldl r1, r11.xyzz, s3
mul r1, r15.x, r1
mov r14.z, c25.w
mov r14.y, r11
texldl r0, r14.xyzz, s3
mad r0, r15.y, r0, r1
mul r0, r16.w, r0
mad r0, r7.x, r6, r0
cmp r1.y, -r7.w, c25.w, c25.z
cmp r1.x, r7.z, c25.w, c25.z
mul_pp r1.x, r1, r1.y
cmp r1, -r1.x, r4, r3
mad r3.x, r7.y, r7.y, -r12.y
add r1.y, r1, r7.w
rsq r3.x, r3.x
rcp r3.x, r3.x
mul r3.y, r12.z, r3.x
rsq r1.y, r1.y
rcp r1.y, r1.y
mad r1.x, r7.z, r1, r1.y
add r1.y, r1.z, r3.x
mul r3.y, r15.z, r3
mad r1.z, r13.y, c30.w, r3.y
mul r1.z, r1, c7.x
rcp r1.y, r1.y
mul r1.x, r1, r1.y
mad r1.x, r13.z, r1, r1.w
frc r6.w, r1.z
add r1.w, r1.z, -r6
add r1.y, r1.z, c25
mul r1.w, r13.y, r1
frc r1.z, r1.y
add r1.y, r1, -r1.z
mul r1.y, r13, r1
mad r12.y, r13, r1.x, r1.w
mad r6.y, r13, r1.x, r1
mov r12.z, c25.w
texldl r3, r12.xyzz, s3
mov r6.z, c25.w
mov r6.x, r12
texldl r1, r6.xyzz, s3
mul r3, r15.x, r3
mov r13.z, c25.w
mov r13.y, r12
texldl r4, r13.xyzz, s3
mad r3, r15.y, r4, r3
mul r4, r15.x, r1
mul r3, r6.w, r3
mov r1.y, r6
mov r1.z, c25.w
mov r1.x, r13
texldl r1, r1.xyzz, s3
mad r1, r15.y, r1, r4
add r4.x, -r6.w, c25.z
mad r1, r1, r4.x, r3
mad r0, r10.xyzx, -r1, r0
add r3.x, r11.w, -r14.w
max r0, r0, c25.w
max r1, r5, c25.w
add r1, r1, -r0
add r3.x, r3, c33
mul r1, r3.x, r1
mad r0, r1, c34.z, r0
else
rcp r4.x, c8.x
mul r4.y, r16.x, r11.w
rcp r11.w, c7.x
mul r12.x, c5, c5
rcp r12.z, c9.x
mul r0.x, r16, r16
mad r0.y, r4, r4, -r0.x
mad r4.z, c5.x, c5.x, r0.y
mad r0.x, r0.w, r0.w, -r12
rsq r12.y, r0.x
rcp r0.w, r12.y
mul r1.y, r0.w, r0.w
mov r1.z, r0.w
mad r1.w, r4.x, c30, c30
rcp r11.y, c10.x
cmp r0.y, -r4.z, c25.w, c25.z
cmp r0.x, r4.y, c25.w, c25.z
mul_pp r3.x, r0, r0.y
mov r1.x, c25.y
mad r0.w, -r4.x, c30, c30
mov r0.xyz, c25.zwww
cmp r3, -r3.x, r1, r0
add r3.y, r3, r4.z
mad r4.w, r16.x, r16.x, -r12.x
rsq r4.z, r4.w
rcp r4.z, r4.z
add r3.z, r3, r4
add r13.z, -r4.x, c30.w
rsq r3.y, r3.y
rcp r3.y, r3.y
mad r3.y, r4, r3.x, r3
rcp r3.z, r3.z
mul r3.y, r3, r3.z
max r3.x, r13.w, c33.y
mul r3.z, r3.x, c33
mad r6.y, r13.z, r3, r3.w
abs r3.y, r3.z
max r3.x, r3.y, c25.z
rcp r3.w, r3.x
min r3.x, r3.y, c25.z
mul r3.x, r3, r3.w
mul r3.w, r3.x, r3.x
mul r4.x, r12.y, r4.z
add r14.x, -r11.w, c25.z
mul r4.x, r14, r4
mad r4.y, r11.w, c30.w, r4.x
mul r5.x, r4.y, c7
add r4.y, r5.x, c25
frc r14.y, r5.x
frc r4.z, r4.y
add r4.y, r4, -r4.z
mad r4.x, r3.w, c28.y, c28.z
mad r4.x, r4, r3.w, c28.w
mad r4.x, r4, r3.w, c29
mad r4.x, r4, r3.w, c29.y
mad r3.w, r4.x, r3, c29.z
mul r3.w, r3, r3.x
mul r4.x, r11.w, r4.y
mad r4.y, r11.w, r6, r4.x
add r5.x, r5, -r14.y
mul r7.y, r11.w, r5.x
mad r6.y, r11.w, r6, r7
add r4.x, -r3.w, c29.w
add r3.y, r3, c25
cmp r3.w, -r3.y, r3, r4.x
mov r3.x, c10
add r3.y, c25, r3.x
add r3.x, r12.w, c25.z
mul r3.x, r3, r3.y
cmp r3.y, r3.z, r3.w, -r3.w
mul r3.x, r3, c30.w
frc r11.x, r3
add r6.w, -r11.x, c25.z
add r13.y, r3.x, -r11.x
mov r7.y, r6
mad r3.y, r3, c34.x, c34
add r13.x, -r12.z, c25.z
mad r3.x, r13, r3.y, r12.z
mad r3.x, r3, c30.w, r13.y
add r3.z, r3.x, c25
mul r6.x, r11.y, r3.z
mul r7.x, r11.y, r3
mov r3.y, r4
mov r3.x, r7
mov r3.z, c25.w
texldl r3, r3.xyzz, s3
mov r4.x, r6
mov r4.z, c25.w
texldl r4, r4.xyzz, s3
mul r4, r11.x, r4
mad r5, r6.w, r3, r4
mov r7.z, c25.w
texldl r3, r7.xyzz, s3
mul r7.x, r11.z, r6.z
mul r4.x, r11.z, r11.z
mad r4.x, r7, r7, -r4
mad r7.y, c5.x, c5.x, r4.x
mov r6.z, c25.w
texldl r4, r6.xyzz, s3
mul r4, r11.x, r4
cmp r6.y, -r7, c25.w, c25.z
cmp r6.x, r7, c25.w, c25.z
mul_pp r6.x, r6, r6.y
cmp r0, -r6.x, r1, r0
mad r1, r6.w, r3, r4
add r0.y, r0, r7
rsq r0.y, r0.y
add r3.x, -r14.y, c25.z
mul r1, r14.y, r1
mad r1, r5, r3.x, r1
rcp r0.y, r0.y
mad r3.x, r7, r0, r0.y
mad r3.y, r11.z, r11.z, -r12.x
rsq r0.y, r3.y
rcp r3.y, r0.y
add r0.z, r0, r3.y
rcp r3.z, r0.z
mul r3.z, r3.x, r3
max r0.x, r7.w, c33.y
mul r0.x, r0, c33.z
abs r0.y, r0.x
max r0.z, r0.y, c25
rcp r3.x, r0.z
min r0.z, r0.y, c25
mul r3.y, r12, r3
mul r3.y, r3, r14.x
mad r3.y, r11.w, c30.w, r3
mul r3.y, r3, c7.x
mad r4.x, r3.z, r13.z, r0.w
mul r0.z, r0, r3.x
mul r0.w, r0.z, r0.z
mad r3.x, r0.w, c28.y, c28.z
mad r3.x, r3, r0.w, c28.w
mad r3.x, r3, r0.w, c29
mad r3.x, r3, r0.w, c29.y
mad r0.w, r3.x, r0, c29.z
frc r5.w, r3.y
mul r0.z, r0.w, r0
add r3.x, r3.y, -r5.w
mul r3.x, r11.w, r3
mad r5.y, r4.x, r11.w, r3.x
add r0.w, -r0.z, c29
add r0.y, r0, c25
cmp r0.y, -r0, r0.z, r0.w
cmp r0.x, r0, r0.y, -r0.y
add r0.y, r3, c25
frc r0.z, r0.y
mad r0.x, r0, c34, c34.y
mad r0.x, r0, r13, r12.z
add r0.y, r0, -r0.z
mad r7.x, r0, c30.w, r13.y
mul r0.x, r0.y, r11.w
add r0.y, r7.x, c25.z
mul r5.x, r11.y, r0.y
mov r5.z, c25.w
texldl r3, r5.xyzz, s3
mad r6.y, r4.x, r11.w, r0.x
mov r6.x, r5
mov r6.z, c25.w
texldl r0, r6.xyzz, s3
mul r4, r11.x, r3
mul r5.x, r7, r11.y
mov r5.z, c25.w
texldl r3, r5.xyzz, s3
mad r4, r6.w, r3, r4
mul r3, r11.x, r0
mov r0.y, r6
mov r0.z, c25.w
mov r0.x, r5
texldl r0, r0.xyzz, s3
mad r0, r0, r6.w, r3
mul r3, r5.w, r4
add r4.x, -r5.w, c25.z
mad r0, r0, r4.x, r3
mad r0, -r0, r10.xyzx, r1
max r0, r0, c25.w
endif
mul_sat r1.x, r13.w, c35.y
mad r1.y, -r1.x, c35.z, c35.w
max r1.w, r0.x, c36.x
mul r1.x, r1, r1
mul r1.x, r1, r1.y
mul r1.x, r0.w, r1
mul r0.w, r12, c14.x
mul r0.w, r0, c25.x
mad r0.w, c14.x, c14.x, -r0
mul r1.xyz, r0, r1.x
rcp r1.w, r1.w
add r0.w, r0, c25.z
mul r3.xyz, r1, r1.w
pow r1, r0.w, c35.x
mov r0.w, c4.x
mul r0.w, c26.x, r0
mov r1.z, r1.x
mul r1.y, -c14.x, c14.x
add r1.x, r1.y, c25.z
rcp r0.w, r0.w
mul r0.w, r0, r1.x
add r1.y, -r1, c25.x
mul r0.w, r0, r1.z
mad r1.x, r12.w, r12.w, c25.z
mul r1.z, r1.x, r0.w
mov r0.w, c4.x
rcp r1.y, r1.y
mul r0.w, c34, r0
rcp r0.w, r0.w
mul r0.w, r0, r1.x
mul r1.y, r1.z, r1
rcp r4.x, c13.x
rcp r4.z, c13.z
rcp r4.y, c13.y
mul r4.xyz, r4, c13.x
mul r3.xyz, r3, r4
mul r3.xyz, r1.y, r3
mul r1.xyz, r3, c31.z
mul r0.xyz, r0.w, r0
mad r4.xyz, r0, c35.w, r1
endif
add r0.xyz, r8, -c24
dp3 r0.x, r0, r0
rsq r0.x, r0.x
rcp r1.x, r0.x
rcp r0.y, c19.x
mul r0.x, r1, r0.y
mul r1.y, r0.x, c26.x
pow r0, c26.w, -r1.y
mov r0.y, c21.x
add r0.z, c25.y, r0.y
add r0.x, -r0, c25.z
add r0.y, r1.x, -c19.x
cmp r3.w, -r0.y, r0.x, c25.z
abs r0.z, r0
cmp r0.y, -r0.z, c25.z, c25.w
mul_pp r0.x, r9.w, r10.w
mul_pp r0.x, r0, r0.y
mul r3.xyz, r4, c12.x
if_gt r0.x, c25.w
mul r0.xyz, r9, r10
mul r2.xyz, r0, c18.x
mul r4.x, r2.z, c36.y
pow r0, r4.x, c36.z
pow r1, c26.w, -r2.z
mov r0.y, r1.x
mov r0.z, r0.x
pow r1, c26.w, -r2.y
add r2.w, r2.z, c36
add r0.x, -r0.y, c25.z
cmp r2.z, r2.w, r0.x, r0
mul r4.x, r2.y, c36.y
pow r0, r4.x, c36.z
mov r0.y, r1.x
pow r1, c26.w, -r2.x
mul r1.y, r2.x, c36
mov r0.z, r0.x
mul r4.xyz, r3, c18.x
add r2.w, r2.y, c36
add r0.x, -r0.y, c25.z
cmp r2.y, r2.w, r0.x, r0.z
pow r0, r1.y, c36.z
mov r0.y, r1.x
pow r1, c26.w, -r4.z
mul r1.y, r4.z, c36
add r2.w, r2.x, c36
add r0.y, -r0, c25.z
cmp r2.x, r2.w, r0.y, r0
pow r0, r1.y, c36.z
mov r0.y, r1.x
pow r1, c26.w, -r4.y
mul r1.y, r4, c36
mov r0.z, r0.x
add r0.x, r4.z, c36.w
add r0.y, -r0, c25.z
cmp r4.z, r0.x, r0.y, r0
pow r0, r1.y, c36.z
mov r0.y, r1.x
pow r1, c26.w, -r4.x
mul r1.y, r4.x, c36
mov r0.z, r0.x
add r0.x, r4.y, c36.w
add r0.y, -r0, c25.z
cmp r4.y, r0.x, r0, r0.z
pow r0, r1.y, c36.z
mov r0.y, r1.x
mov r0.z, r0.x
add r0.x, r4, c36.w
add r0.y, -r0, c25.z
cmp r4.x, r0, r0.y, r0.z
add r1.xyz, r4, -r2
mul r0.x, r3.w, c17
mad r0.xyz, r0.x, r1, r2
mov r0.w, c22.x
mov_pp r2, r0
mov_pp oC0, r0
mov_pp r8.w, c25
endif
mul r3.xyz, r3, c18.x
pow r1, c26.w, -r3.x
mul r1.y, r3.x, c36
pow r0, r1.y, c36.z
mov r0.y, r1.x
pow r1, c26.w, -r3.y
mul r1.y, r3, c36
mov r0.z, r0.x
add r0.x, r3, c36.w
add r0.y, -r0, c25.z
cmp r3.x, r0, r0.y, r0.z
pow r0, r1.y, c36.z
mov r0.y, r1.x
mov r0.z, r0.x
pow r1, c26.w, -r3.z
mul r1.y, r3.z, c36
add r0.x, r3.y, c36.w
add r0.y, -r0, c25.z
cmp r3.y, r0.x, r0, r0.z
pow r0, r1.y, c36.z
mov r0.y, r1.x
mov r0.z, r0.x
mul r0.w, r3, c17.x
add r0.y, -r0, c25.z
add r0.x, r3.z, c36.w
mul r3.w, r0, c22.x
cmp r3.z, r0.x, r0.y, r0
cmp_pp oC0, -r8.w, r2, r3
endif
"
}
SubProgram "d3d11 " {
// Stats: 685 math, 1 textures, 14 branches
SetTexture 0 [_customDepthTexture] 2D 3
SetTexture 1 [_Transmittance] 2D 0
SetTexture 2 [_Irradiance] 2D 2
SetTexture 3 [_Inscatter] 2D 1
ConstBuffer "$Globals" 336
Matrix 112 [_ViewProjInv]
Float 32 [M_PI]
Float 52 [Rg]
Float 56 [Rt]
Float 64 [RES_R]
Float 68 [RES_MU]
Float 72 [RES_MU_S]
Float 76 [RES_NU]
Vector 80 [SUN_DIR] 3
Float 92 [SUN_INTENSITY]
Vector 96 [betaR] 3
Float 108 [mieG]
Float 176 [_viewdirOffset]
Float 180 [_experimentalAtmoScale]
Float 188 [_global_alpha]
Float 192 [_Exposure]
Float 196 [_global_depth]
Float 200 [_Ocean_Sigma]
Float 204 [fakeOcean]
Float 208 [_fade]
Vector 212 [_Ocean_Color] 3
Vector 224 [_camPos] 3
Float 256 [_openglThreshold]
BindCB  "$Globals" 0
"ps_4_0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"
}
SubProgram "gles " {
"!!GLES"
}
SubProgram "glesdesktop " {
"!!GLES"
}
SubProgram "gles3 " {
"!!GLES3"
}
}
 }
}
}